// --atomics 4 ---atomic_reductions ---fake_divergence ---inter_thread_comm -g 1,2,4813 -l 1,1,1
#define int64_t long
#define uint64_t ulong
#define int_least64_t long
#define uint_least64_t ulong
#define int_fast64_t long
#define uint_fast64_t ulong
#define intmax_t long
#define uintmax_t ulong
#define int32_t int
#define uint32_t uint
#define int16_t short
#define uint16_t ushort
#define int8_t char
#define uint8_t uchar

#define INT64_MIN LONG_MIN
#define INT64_MAX LONG_MAX
#define INT32_MIN INT_MIN
#define INT32_MAX INT_MAX
#define INT16_MIN SHRT_MIN
#define INT16_MAX SHRT_MAX
#define INT8_MIN CHAR_MIN
#define INT8_MAX CHAR_MAX
#define UINT64_MIN ULONG_MIN
#define UINT64_MAX ULONG_MAX
#define UINT32_MIN UINT_MIN
#define UINT32_MAX UINT_MAX
#define UINT16_MIN USHRT_MIN
#define UINT16_MAX USHRT_MAX
#define UINT8_MIN UCHAR_MIN
#define UINT8_MAX UCHAR_MAX

#define transparent_crc(X, Y, Z) transparent_crc_(&crc64_context, X, Y, Z)

#define VECTOR(X , Y) VECTOR_(X, Y)
#define VECTOR_(X, Y) X##Y

#ifndef NO_GROUP_DIVERGENCE
#define GROUP_DIVERGE(x, y) get_group_id(x)
#else
#define GROUP_DIVERGE(x, y) (y)
#endif

#ifndef NO_FAKE_DIVERGENCE
#define FAKE_DIVERGE(x, y, z) (x - y)
#else
#define FAKE_DIVERGE(x, y, z) (z)
#endif

__constant uint32_t permutations[10][1] = {
{0}, // permutation 0
{0}, // permutation 1
{0}, // permutation 2
{0}, // permutation 3
{0}, // permutation 4
{0}, // permutation 5
{0}, // permutation 6
{0}, // permutation 7
{0}, // permutation 8
{0} // permutation 9
};

// Seed: 1416

#include "CLSmith.h"

/* --- Struct/Union Declarations --- */
union U0 {
   uint8_t  f0;
   int8_t * f1;
};

struct S1 {
    VECTOR(int16_t, 2) g_16;
    int8_t g_22;
    int32_t g_28;
    volatile VECTOR(int32_t, 4) g_30;
    volatile VECTOR(uint32_t, 2) g_33;
    int8_t g_37;
    int8_t *g_36;
    volatile VECTOR(int8_t, 4) g_47;
    uint16_t g_83;
    uint8_t g_89;
    union U0 g_91;
    union U0 *g_93[8];
    union U0 ** volatile g_92;
    int32_t *g_99;
    int32_t ** volatile g_98[2];
    int32_t ** volatile g_100;
    volatile uint8_t g_108;
    int32_t ** volatile g_111[2][7][8];
    int32_t g_141;
    int32_t g_143;
    int32_t ** volatile g_150[8];
    volatile VECTOR(uint8_t, 4) g_288;
    int32_t **g_370;
    int32_t ***g_369;
    union U0 **g_374[10];
    VECTOR(uint32_t, 2) g_379;
    uint32_t g_385[1];
    VECTOR(int8_t, 4) g_418;
    uint64_t g_430;
    uint32_t g_435;
    uint32_t g_462;
    VECTOR(int8_t, 8) g_464;
    VECTOR(int8_t, 4) g_465;
    volatile VECTOR(int8_t, 2) g_466;
    VECTOR(int8_t, 2) g_478;
    volatile VECTOR(uint8_t, 16) g_481;
    VECTOR(int32_t, 4) g_495;
    VECTOR(int32_t, 8) g_498;
    volatile VECTOR(int32_t, 16) g_503;
    VECTOR(int32_t, 8) g_513;
    VECTOR(int32_t, 4) g_519;
    union U0 **g_574;
    volatile int64_t * volatile g_575;
    VECTOR(int8_t, 2) g_588;
    uint32_t g_618;
    int8_t **g_641;
    VECTOR(int16_t, 2) g_667;
    uint32_t v_collective;
    uint64_t global_0_offset;
    uint64_t global_1_offset;
    uint64_t global_2_offset;
    uint64_t local_0_offset;
    uint64_t local_1_offset;
    uint64_t local_2_offset;
    uint64_t group_0_offset;
    uint64_t group_1_offset;
    uint64_t group_2_offset;
    uint32_t tid;
    __local volatile uint32_t *l_atomic_input;
    __local volatile uint32_t *l_special_values;
    __global volatile uint32_t *g_atomic_input;
    __global volatile uint32_t *g_special_values;
    __local volatile uint32_t *l_atomic_reduction;
    __global volatile uint32_t *g_atomic_reduction;
    __local int64_t *l_comm_values;
    __global int64_t *g_comm_values;
};


/* --- FORWARD DECLARATIONS --- */
uint64_t  func_1(struct S1 * p_670);
int32_t  func_3(uint16_t  p_4, struct S1 * p_670);
uint8_t  func_5(int8_t * p_6, struct S1 * p_670);
int8_t * func_7(int16_t  p_8, int64_t  p_9, int32_t  p_10, int8_t * p_11, struct S1 * p_670);
VECTOR(int64_t, 4)  func_24(int8_t  p_25, struct S1 * p_670);
uint16_t  func_40(uint16_t  p_41, uint8_t  p_42, uint32_t  p_43, struct S1 * p_670);
VECTOR(int8_t, 8)  func_48(int8_t ** p_49, int8_t ** p_50, int16_t  p_51, struct S1 * p_670);
int8_t ** func_52(uint8_t  p_53, uint32_t  p_54, struct S1 * p_670);
int32_t  func_55(int32_t  p_56, struct S1 * p_670);
int32_t * func_57(uint64_t  p_58, int32_t ** p_59, struct S1 * p_670);


/* --- FUNCTIONS --- */
/* ------------------------------------------ */
/* 
 * reads : p_670->g_16 p_670->g_30 p_670->g_33 p_670->g_comm_values p_670->g_28 p_670->g_36 p_670->g_47 p_670->g_37 p_670->g_22 p_670->l_comm_values p_670->g_92 p_670->g_100 p_670->g_108 p_670->g_99 p_670->g_89 p_670->g_83 p_670->g_288 p_670->g_143 p_670->g_369 p_670->g_385 p_670->g_370 p_670->g_141 p_670->g_418 p_670->g_379 p_670->g_91.f0 p_670->g_464 p_670->g_465 p_670->g_466 p_670->g_478 p_670->g_481 p_670->g_495 p_670->g_498 p_670->g_503 p_670->g_513 p_670->g_519 p_670->g_435 p_670->g_575 p_670->g_588 p_670->g_618 p_670->g_641
 * writes: p_670->g_22 p_670->g_83 p_670->g_89 p_670->g_93 p_670->g_99 p_670->g_108 p_670->g_28 p_670->g_141 p_670->g_143 p_670->g_37 p_670->g_91.f0 p_670->g_369 p_670->g_374 p_670->g_385 p_670->g_430 p_670->g_462 p_670->l_comm_values p_670->g_435 p_670->g_574 p_670->g_16 p_670->g_495 p_670->g_618 p_670->g_641
 */
uint64_t  func_1(struct S1 * p_670)
{ /* block id: 4 */
    uint32_t l_2 = 0x01FC3EEEL;
    int8_t *l_21 = &p_670->g_22;
    VECTOR(int64_t, 4) l_23 = (VECTOR(int64_t, 4))(0x71FA6F63EEDA781BL, (VECTOR(int64_t, 2))(0x71FA6F63EEDA781BL, 0x7A0D7C8A36A77D77L), 0x7A0D7C8A36A77D77L);
    int8_t *l_35 = (void*)0;
    int8_t **l_34 = &l_35;
    int32_t l_629 = 0x49D3CCB4L;
    int32_t l_633 = 0x7813FC9FL;
    int32_t l_634 = (-4L);
    int32_t l_635 = 0x28DF719EL;
    int32_t l_636 = 0x76D09BBDL;
    uint32_t l_637 = 0xECE3337CL;
    uint16_t *l_655 = (void*)0;
    uint16_t *l_656 = (void*)0;
    uint16_t *l_657 = &p_670->g_83;
    uint16_t **l_664 = &l_655;
    uint64_t *l_665 = &p_670->g_430;
    int16_t *l_666 = (void*)0;
    int16_t *l_668[6][5] = {{(void*)0,(void*)0,(void*)0,(void*)0,(void*)0},{(void*)0,(void*)0,(void*)0,(void*)0,(void*)0},{(void*)0,(void*)0,(void*)0,(void*)0,(void*)0},{(void*)0,(void*)0,(void*)0,(void*)0,(void*)0},{(void*)0,(void*)0,(void*)0,(void*)0,(void*)0},{(void*)0,(void*)0,(void*)0,(void*)0,(void*)0}};
    int32_t *l_669[2];
    int i, j;
    for (i = 0; i < 2; i++)
        l_669[i] = &p_670->g_28;
    if ((p_670->g_618 &= ((VECTOR(int32_t, 4))(l_2, func_3((func_5(func_7(l_2, ((safe_sub_func_uint32_t_u_u(((((l_2 <= ((safe_lshift_func_int16_t_s_u(((VECTOR(int16_t, 16))(p_670->g_16.xyyxyyyxyyyxyxyx)).s3, 7)) , p_670->g_16.y)) <= (p_670->g_16.x < (safe_sub_func_uint64_t_u_u(((((((safe_mul_func_int8_t_s_s(((*l_21) = 0x4AL), (((*l_34) = (((((VECTOR(uint64_t, 16))(18446744073709551615UL, 9UL, ((VECTOR(uint64_t, 8))(abs_diff(((VECTOR(int64_t, 2))(0x2C4EB0A117216709L, 0x49CFF29C214F1636L)).yyyyyxxy, ((VECTOR(int64_t, 4))(min(((VECTOR(int64_t, 16))(l_23.wxwywwywwxyzxzyx)).s4acd, ((VECTOR(int64_t, 8))(1L, ((VECTOR(int64_t, 8))(((VECTOR(int64_t, 4))(func_24(p_670->g_16.y, p_670))), 9L, ((VECTOR(int64_t, 2))((((VECTOR(int64_t, 16))(upsample(((VECTOR(int32_t, 4))(p_670->g_30.zzwy)).ywwzwyzxzxxxxxxx, ((VECTOR(uint32_t, 8))((((VECTOR(uint32_t, 16))(p_670->g_33.yyxxyyxyyxxyyxyx)).hi + ((VECTOR(uint32_t, 2))((+((VECTOR(uint32_t, 4))(p_670->g_16.x, 1UL, 0UL, 0x132DC1B2L)).even))).xxyxyxxx))).s7603755145601467))).s4f > ((VECTOR(int64_t, 2))((-1L)))))), 0x11B167519BA600ACL)).s0, ((VECTOR(int64_t, 2))((-1L))), 0x4C62B41911659018L, 0x1BC642EE1E3C1DC0L, (-7L), 1L)).even))).zwzzxwwx))), p_670->g_comm_values[p_670->tid], l_23.x, ((VECTOR(uint64_t, 4))(0x67A065BBD97C2923L)))).sf , GROUP_DIVERGE(2, 1)) >= l_2) , l_21)) != (void*)0))) && l_23.w) | 1UL) == 0x0942L) && 0x7C1F20CFL) , p_670->g_30.x), 0xAF5756627F1A9F13L)))) , l_23.z) >= p_670->g_28), 0xD1904503L)) <= 255UL), l_23.y, p_670->g_36, p_670), p_670) , p_670->g_comm_values[p_670->tid]), p_670), (-6L), 0x0E9963F7L)).y))
    { /* block id: 259 */
        int32_t *l_619 = &p_670->g_143;
        int32_t *l_620 = &p_670->g_143;
        int32_t *l_621 = (void*)0;
        int32_t *l_622 = &p_670->g_28;
        int32_t *l_623 = &p_670->g_141;
        int32_t *l_624 = (void*)0;
        int32_t *l_625 = (void*)0;
        int32_t *l_626 = &p_670->g_28;
        int32_t *l_627 = &p_670->g_28;
        int32_t *l_628[8] = {&p_670->g_28,&p_670->g_28,&p_670->g_28,&p_670->g_28,&p_670->g_28,&p_670->g_28,&p_670->g_28,&p_670->g_28};
        uint16_t l_630 = 65535UL;
        int i;
        --l_630;
        --l_637;
    }
    else
    { /* block id: 262 */
        int8_t ***l_640[8][3] = {{&l_34,&l_34,&l_34},{&l_34,&l_34,&l_34},{&l_34,&l_34,&l_34},{&l_34,&l_34,&l_34},{&l_34,&l_34,&l_34},{&l_34,&l_34,&l_34},{&l_34,&l_34,&l_34},{&l_34,&l_34,&l_34}};
        int32_t *l_642 = &p_670->g_143;
        int i, j;
        (*l_642) = ((p_670->g_641 = &p_670->g_36) == (void*)0);
    }
    p_670->g_495.w ^= (safe_rshift_func_int16_t_s_u((((safe_sub_func_int16_t_s_s(p_670->g_16.x, (safe_lshift_func_int8_t_s_u((safe_rshift_func_uint8_t_u_s(((safe_mod_func_uint64_t_u_u(((safe_mod_func_uint8_t_u_u((((*l_657) = p_670->g_498.s4) > ((VECTOR(uint16_t, 4))(mad_sat(((VECTOR(uint16_t, 2))(hadd(((VECTOR(uint16_t, 2))((((VECTOR(uint16_t, 4))(65529UL, ((safe_mul_func_int8_t_s_s(((l_635 = (p_670->g_418.w && ((*l_665) = (((safe_mod_func_int8_t_s_s((((!9UL) || (p_670->g_91.f0 = (((void*)0 != l_664) > (l_634 & ((&p_670->g_36 == &l_21) , p_670->g_481.sd))))) < 0x7696790DF6400E13L), (**p_670->g_641))) > p_670->g_513.s6) || FAKE_DIVERGE(p_670->global_2_offset, get_global_id(2), 10))))) & (-10L)), (*p_670->g_36))) && l_629), 0UL, 65531UL)).odd + ((VECTOR(uint16_t, 2))(8UL))))), ((VECTOR(uint16_t, 2))(0x430AL))))).xyxx, ((VECTOR(uint16_t, 4))(0x3E05L)), ((VECTOR(uint16_t, 4))(0x804DL))))).x), p_670->g_513.s6)) <= (*p_670->g_36)), l_23.z)) & 4L), 3)), l_636)))) & p_670->g_16.y) , 0x6093L), 10));
    return p_670->g_37;
}


/* ------------------------------------------ */
/* 
 * reads : p_670->g_141
 * writes: p_670->g_141
 */
int32_t  func_3(uint16_t  p_4, struct S1 * p_670)
{ /* block id: 242 */
    int32_t *l_602 = (void*)0;
    int32_t *l_603 = (void*)0;
    int32_t l_617 = 0x417D4CA0L;
    l_603 = l_602;
    for (p_670->g_141 = 0; (p_670->g_141 == 9); p_670->g_141 = safe_add_func_uint8_t_u_u(p_670->g_141, 1))
    { /* block id: 246 */
        if ((atomic_inc(&p_670->l_atomic_input[1]) == 2))
        { /* block id: 248 */
            int32_t l_606 = (-5L);
            uint16_t l_607 = 0x45CAL;
            int8_t l_610 = 0x52L;
            int64_t l_611 = 0x7567840D2E58048BL;
            int64_t l_612 = (-8L);
            int64_t l_613 = 0x5AEDB0B1B4D546C8L;
            uint8_t l_614 = 0x5BL;
            --l_607;
            l_610 ^= 0x6300AD09L;
            --l_614;
            unsigned int result = 0;
            result += l_606;
            result += l_607;
            result += l_610;
            result += l_611;
            result += l_612;
            result += l_613;
            result += l_614;
            atomic_add(&p_670->l_special_values[1], result);
        }
        else
        { /* block id: 252 */
            (1 + 1);
        }
        return p_4;
    }
    return l_617;
}


/* ------------------------------------------ */
/* 
 * reads : p_670->g_89 p_670->g_370 p_670->g_92 p_670->l_comm_values p_670->g_33 p_670->g_22 p_670->g_comm_values p_670->g_369 p_670->g_435 p_670->g_575 p_670->g_36 p_670->g_37 p_670->g_99 p_670->g_28 p_670->g_498 p_670->g_513 p_670->g_588 p_670->g_519 p_670->g_503 p_670->g_495 p_670->g_465
 * writes: p_670->g_89 p_670->g_143 p_670->g_83 p_670->g_99 p_670->g_93 p_670->g_435 p_670->g_374 p_670->g_574 p_670->g_16 p_670->g_28 p_670->g_430 p_670->g_495
 */
uint8_t  func_5(int8_t * p_6, struct S1 * p_670)
{ /* block id: 192 */
    uint8_t l_532 = 0xDEL;
    VECTOR(int32_t, 16) l_535 = (VECTOR(int32_t, 16))(0x137119B6L, (VECTOR(int32_t, 4))(0x137119B6L, (VECTOR(int32_t, 2))(0x137119B6L, 5L), 5L), 5L, 0x137119B6L, 5L, (VECTOR(int32_t, 2))(0x137119B6L, 5L), (VECTOR(int32_t, 2))(0x137119B6L, 5L), 0x137119B6L, 5L, 0x137119B6L, 5L);
    int32_t *l_547[2];
    int32_t l_552 = 0L;
    uint16_t *l_553[2][9] = {{&p_670->g_83,&p_670->g_83,&p_670->g_83,&p_670->g_83,&p_670->g_83,&p_670->g_83,&p_670->g_83,&p_670->g_83,&p_670->g_83},{&p_670->g_83,&p_670->g_83,&p_670->g_83,&p_670->g_83,&p_670->g_83,&p_670->g_83,&p_670->g_83,&p_670->g_83,&p_670->g_83}};
    union U0 **l_573 = (void*)0;
    int64_t *l_576[2];
    VECTOR(int64_t, 4) l_580 = (VECTOR(int64_t, 4))(0x79ED3C1365AE4756L, (VECTOR(int64_t, 2))(0x79ED3C1365AE4756L, 1L), 1L);
    VECTOR(int16_t, 16) l_589 = (VECTOR(int16_t, 16))((-10L), (VECTOR(int16_t, 4))((-10L), (VECTOR(int16_t, 2))((-10L), 0x2718L), 0x2718L), 0x2718L, (-10L), 0x2718L, (VECTOR(int16_t, 2))((-10L), 0x2718L), (VECTOR(int16_t, 2))((-10L), 0x2718L), (-10L), 0x2718L, (-10L), 0x2718L);
    union U0 *l_597[2];
    int i, j;
    for (i = 0; i < 2; i++)
        l_547[i] = (void*)0;
    for (i = 0; i < 2; i++)
        l_576[i] = (void*)0;
    for (i = 0; i < 2; i++)
        l_597[i] = &p_670->g_91;
    for (p_670->g_89 = (-29); (p_670->g_89 > 37); p_670->g_89++)
    { /* block id: 195 */
        int32_t l_537 = 0x7617718BL;
        int32_t l_538 = 0x2A750BF8L;
        int32_t l_539 = 1L;
        int32_t l_540 = 0x5B788F49L;
        int32_t l_541 = 0x4F34E9B5L;
        uint64_t l_542 = 0x0AEAC9B2374A32B8L;
        int32_t l_548 = (-7L);
        uint64_t l_549[9][4][7] = {{{0xF57D6A18141C7F09L,0UL,4UL,18446744073709551615UL,1UL,0x9793A439D51A1BC9L,0xDCE8679DBFFC0F8FL},{0xF57D6A18141C7F09L,0UL,4UL,18446744073709551615UL,1UL,0x9793A439D51A1BC9L,0xDCE8679DBFFC0F8FL},{0xF57D6A18141C7F09L,0UL,4UL,18446744073709551615UL,1UL,0x9793A439D51A1BC9L,0xDCE8679DBFFC0F8FL},{0xF57D6A18141C7F09L,0UL,4UL,18446744073709551615UL,1UL,0x9793A439D51A1BC9L,0xDCE8679DBFFC0F8FL}},{{0xF57D6A18141C7F09L,0UL,4UL,18446744073709551615UL,1UL,0x9793A439D51A1BC9L,0xDCE8679DBFFC0F8FL},{0xF57D6A18141C7F09L,0UL,4UL,18446744073709551615UL,1UL,0x9793A439D51A1BC9L,0xDCE8679DBFFC0F8FL},{0xF57D6A18141C7F09L,0UL,4UL,18446744073709551615UL,1UL,0x9793A439D51A1BC9L,0xDCE8679DBFFC0F8FL},{0xF57D6A18141C7F09L,0UL,4UL,18446744073709551615UL,1UL,0x9793A439D51A1BC9L,0xDCE8679DBFFC0F8FL}},{{0xF57D6A18141C7F09L,0UL,4UL,18446744073709551615UL,1UL,0x9793A439D51A1BC9L,0xDCE8679DBFFC0F8FL},{0xF57D6A18141C7F09L,0UL,4UL,18446744073709551615UL,1UL,0x9793A439D51A1BC9L,0xDCE8679DBFFC0F8FL},{0xF57D6A18141C7F09L,0UL,4UL,18446744073709551615UL,1UL,0x9793A439D51A1BC9L,0xDCE8679DBFFC0F8FL},{0xF57D6A18141C7F09L,0UL,4UL,18446744073709551615UL,1UL,0x9793A439D51A1BC9L,0xDCE8679DBFFC0F8FL}},{{0xF57D6A18141C7F09L,0UL,4UL,18446744073709551615UL,1UL,0x9793A439D51A1BC9L,0xDCE8679DBFFC0F8FL},{0xF57D6A18141C7F09L,0UL,4UL,18446744073709551615UL,1UL,0x9793A439D51A1BC9L,0xDCE8679DBFFC0F8FL},{0xF57D6A18141C7F09L,0UL,4UL,18446744073709551615UL,1UL,0x9793A439D51A1BC9L,0xDCE8679DBFFC0F8FL},{0xF57D6A18141C7F09L,0UL,4UL,18446744073709551615UL,1UL,0x9793A439D51A1BC9L,0xDCE8679DBFFC0F8FL}},{{0xF57D6A18141C7F09L,0UL,4UL,18446744073709551615UL,1UL,0x9793A439D51A1BC9L,0xDCE8679DBFFC0F8FL},{0xF57D6A18141C7F09L,0UL,4UL,18446744073709551615UL,1UL,0x9793A439D51A1BC9L,0xDCE8679DBFFC0F8FL},{0xF57D6A18141C7F09L,0UL,4UL,18446744073709551615UL,1UL,0x9793A439D51A1BC9L,0xDCE8679DBFFC0F8FL},{0xF57D6A18141C7F09L,0UL,4UL,18446744073709551615UL,1UL,0x9793A439D51A1BC9L,0xDCE8679DBFFC0F8FL}},{{0xF57D6A18141C7F09L,0UL,4UL,18446744073709551615UL,1UL,0x9793A439D51A1BC9L,0xDCE8679DBFFC0F8FL},{0xF57D6A18141C7F09L,0UL,4UL,18446744073709551615UL,1UL,0x9793A439D51A1BC9L,0xDCE8679DBFFC0F8FL},{0xF57D6A18141C7F09L,0UL,4UL,18446744073709551615UL,1UL,0x9793A439D51A1BC9L,0xDCE8679DBFFC0F8FL},{0xF57D6A18141C7F09L,0UL,4UL,18446744073709551615UL,1UL,0x9793A439D51A1BC9L,0xDCE8679DBFFC0F8FL}},{{0xF57D6A18141C7F09L,0UL,4UL,18446744073709551615UL,1UL,0x9793A439D51A1BC9L,0xDCE8679DBFFC0F8FL},{0xF57D6A18141C7F09L,0UL,4UL,18446744073709551615UL,1UL,0x9793A439D51A1BC9L,0xDCE8679DBFFC0F8FL},{0xF57D6A18141C7F09L,0UL,4UL,18446744073709551615UL,1UL,0x9793A439D51A1BC9L,0xDCE8679DBFFC0F8FL},{0xF57D6A18141C7F09L,0UL,4UL,18446744073709551615UL,1UL,0x9793A439D51A1BC9L,0xDCE8679DBFFC0F8FL}},{{0xF57D6A18141C7F09L,0UL,4UL,18446744073709551615UL,1UL,0x9793A439D51A1BC9L,0xDCE8679DBFFC0F8FL},{0xF57D6A18141C7F09L,0UL,4UL,18446744073709551615UL,1UL,0x9793A439D51A1BC9L,0xDCE8679DBFFC0F8FL},{0xF57D6A18141C7F09L,0UL,4UL,18446744073709551615UL,1UL,0x9793A439D51A1BC9L,0xDCE8679DBFFC0F8FL},{0xF57D6A18141C7F09L,0UL,4UL,18446744073709551615UL,1UL,0x9793A439D51A1BC9L,0xDCE8679DBFFC0F8FL}},{{0xF57D6A18141C7F09L,0UL,4UL,18446744073709551615UL,1UL,0x9793A439D51A1BC9L,0xDCE8679DBFFC0F8FL},{0xF57D6A18141C7F09L,0UL,4UL,18446744073709551615UL,1UL,0x9793A439D51A1BC9L,0xDCE8679DBFFC0F8FL},{0xF57D6A18141C7F09L,0UL,4UL,18446744073709551615UL,1UL,0x9793A439D51A1BC9L,0xDCE8679DBFFC0F8FL},{0xF57D6A18141C7F09L,0UL,4UL,18446744073709551615UL,1UL,0x9793A439D51A1BC9L,0xDCE8679DBFFC0F8FL}}};
        int i, j, k;
        for (p_670->g_143 = 0; (p_670->g_143 > 1); ++p_670->g_143)
        { /* block id: 198 */
            int32_t *l_536[5][4][7] = {{{&p_670->g_28,&p_670->g_28,&p_670->g_28,(void*)0,(void*)0,(void*)0,&p_670->g_28},{&p_670->g_28,&p_670->g_28,&p_670->g_28,(void*)0,(void*)0,(void*)0,&p_670->g_28},{&p_670->g_28,&p_670->g_28,&p_670->g_28,(void*)0,(void*)0,(void*)0,&p_670->g_28},{&p_670->g_28,&p_670->g_28,&p_670->g_28,(void*)0,(void*)0,(void*)0,&p_670->g_28}},{{&p_670->g_28,&p_670->g_28,&p_670->g_28,(void*)0,(void*)0,(void*)0,&p_670->g_28},{&p_670->g_28,&p_670->g_28,&p_670->g_28,(void*)0,(void*)0,(void*)0,&p_670->g_28},{&p_670->g_28,&p_670->g_28,&p_670->g_28,(void*)0,(void*)0,(void*)0,&p_670->g_28},{&p_670->g_28,&p_670->g_28,&p_670->g_28,(void*)0,(void*)0,(void*)0,&p_670->g_28}},{{&p_670->g_28,&p_670->g_28,&p_670->g_28,(void*)0,(void*)0,(void*)0,&p_670->g_28},{&p_670->g_28,&p_670->g_28,&p_670->g_28,(void*)0,(void*)0,(void*)0,&p_670->g_28},{&p_670->g_28,&p_670->g_28,&p_670->g_28,(void*)0,(void*)0,(void*)0,&p_670->g_28},{&p_670->g_28,&p_670->g_28,&p_670->g_28,(void*)0,(void*)0,(void*)0,&p_670->g_28}},{{&p_670->g_28,&p_670->g_28,&p_670->g_28,(void*)0,(void*)0,(void*)0,&p_670->g_28},{&p_670->g_28,&p_670->g_28,&p_670->g_28,(void*)0,(void*)0,(void*)0,&p_670->g_28},{&p_670->g_28,&p_670->g_28,&p_670->g_28,(void*)0,(void*)0,(void*)0,&p_670->g_28},{&p_670->g_28,&p_670->g_28,&p_670->g_28,(void*)0,(void*)0,(void*)0,&p_670->g_28}},{{&p_670->g_28,&p_670->g_28,&p_670->g_28,(void*)0,(void*)0,(void*)0,&p_670->g_28},{&p_670->g_28,&p_670->g_28,&p_670->g_28,(void*)0,(void*)0,(void*)0,&p_670->g_28},{&p_670->g_28,&p_670->g_28,&p_670->g_28,(void*)0,(void*)0,(void*)0,&p_670->g_28},{&p_670->g_28,&p_670->g_28,&p_670->g_28,(void*)0,(void*)0,(void*)0,&p_670->g_28}}};
            int i, j, k;
            for (p_670->g_83 = 0; (p_670->g_83 < 12); p_670->g_83 = safe_add_func_int8_t_s_s(p_670->g_83, 2))
            { /* block id: 201 */
                int32_t *l_531[4][1];
                int i, j;
                for (i = 0; i < 4; i++)
                {
                    for (j = 0; j < 1; j++)
                        l_531[i][j] = (void*)0;
                }
                l_532++;
            }
            l_542--;
        }
        --l_549[1][2][4];
        (*p_670->g_370) = l_547[1];
        if (l_541)
            break;
    }
    (**p_670->g_369) = func_57((((-1L) || (p_670->g_83 = l_552)) == 0x0F9EL), &l_547[0], p_670);
    if ((4UL != (safe_mul_func_uint8_t_u_u(3UL, (~((void*)0 != (*p_670->g_369)))))))
    { /* block id: 220 */
        int32_t l_556 = (-1L);
        uint32_t *l_563 = &p_670->g_435;
        union U0 ***l_570 = &p_670->g_374[3];
        union U0 **l_572 = &p_670->g_93[2];
        union U0 ***l_571 = &l_572;
        int64_t **l_577 = &l_576[1];
        int16_t *l_585 = (void*)0;
        int8_t l_586 = (-10L);
        VECTOR(int8_t, 16) l_587 = (VECTOR(int8_t, 16))(5L, (VECTOR(int8_t, 4))(5L, (VECTOR(int8_t, 2))(5L, 1L), 1L), 1L, 5L, 1L, (VECTOR(int8_t, 2))(5L, 1L), (VECTOR(int8_t, 2))(5L, 1L), 5L, 1L, 5L, 1L);
        int32_t l_590 = 0x24B66C70L;
        uint16_t *l_591 = &p_670->g_83;
        uint16_t **l_592 = (void*)0;
        uint16_t **l_593 = &l_591;
        uint64_t *l_596 = &p_670->g_430;
        int i;
        (***p_670->g_369) = (l_556 < (safe_mul_func_uint16_t_u_u((((&p_670->g_150[5] != (void*)0) | (safe_add_func_uint16_t_u_u((p_670->g_83 = (safe_mod_func_int64_t_s_s((((*l_563)++) && ((p_670->g_16.y = ((safe_mul_func_uint16_t_u_u(((((safe_lshift_func_uint16_t_u_s((((*l_571) = ((*l_570) = (void*)0)) != (p_670->g_574 = l_573)), 15)) , p_670->g_575) != ((*l_577) = l_576[1])) < GROUP_DIVERGE(0, 1)), (safe_mul_func_uint16_t_u_u((((VECTOR(int64_t, 4))(l_580.xwyw)).y ^ (((safe_div_func_uint8_t_u_u(((&p_670->g_93[4] != ((safe_div_func_uint64_t_u_u(0xC80792BDC86AD7C0L, l_556)) , (void*)0)) ^ 3L), (*p_670->g_36))) >= l_556) == FAKE_DIVERGE(p_670->local_0_offset, get_local_id(0), 10))), l_556)))) || (*p_670->g_99))) < 0xAE5FL)), p_670->g_498.s1))), p_670->g_513.s5))) || l_586), l_556)));
        p_670->g_495.w &= (((VECTOR(int8_t, 4))(((VECTOR(int8_t, 2))(rhadd(((VECTOR(int8_t, 16))(l_587.s65bebf575a85f3da)).s28, ((VECTOR(int8_t, 16))(sub_sat(((VECTOR(int8_t, 2))(p_670->g_588.yy)).yxxyxyyyxyxxxyxy, ((VECTOR(int8_t, 8))(1L, 7L, 0x44L, ((VECTOR(int8_t, 2))((((VECTOR(int8_t, 4))(((+l_556) | ((((l_590 = l_589.s3) >= (4294967293UL | l_556)) | ((l_553[1][6] == ((*l_593) = l_591)) , ((*p_670->g_99) ^= (safe_add_func_uint8_t_u_u(((255UL < ((((((*l_563) &= p_670->g_519.w) , ((!((*l_596) = p_670->g_503.se)) < l_587.s4)) <= p_670->g_519.y) , l_597[1]) == (void*)0)) || GROUP_DIVERGE(1, 1)), 1L))))) , GROUP_DIVERGE(0, 1))), ((VECTOR(int8_t, 2))((-9L))), (-4L))).lo >= ((VECTOR(int8_t, 2))(0x10L))))), 0x3BL, 0x54L, 0x37L)).s7730356562673242))).sf0))), (-4L), 0x0BL)).z > 0x13L);
    }
    else
    { /* block id: 235 */
        uint16_t l_598 = 0x9C20L;
        int32_t *l_601 = (void*)0;
        (*p_670->g_99) = 0x2799FD38L;
        --l_598;
        (*p_670->g_370) = l_601;
        return p_670->g_519.w;
    }
    return p_670->g_465.x;
}


/* ------------------------------------------ */
/* 
 * reads : p_670->g_47 p_670->g_37 p_670->g_16 p_670->g_33 p_670->g_22 p_670->l_comm_values p_670->g_comm_values p_670->g_92 p_670->g_100 p_670->g_108 p_670->g_36 p_670->g_30 p_670->g_99 p_670->g_89 p_670->g_28 p_670->g_83 p_670->g_288 p_670->g_143 p_670->g_369 p_670->g_385 p_670->g_370 p_670->g_141 p_670->g_418 p_670->g_379 p_670->g_91.f0 p_670->g_464 p_670->g_465 p_670->g_466 p_670->g_478 p_670->g_481 p_670->g_495 p_670->g_498 p_670->g_503 p_670->g_513 p_670->g_519
 * writes: p_670->g_83 p_670->g_89 p_670->g_93 p_670->g_99 p_670->g_108 p_670->g_28 p_670->g_141 p_670->g_143 p_670->g_37 p_670->g_91.f0 p_670->g_369 p_670->g_374 p_670->g_385 p_670->g_430 p_670->g_462 p_670->g_22 p_670->l_comm_values
 */
int8_t * func_7(int16_t  p_8, int64_t  p_9, int32_t  p_10, int8_t * p_11, struct S1 * p_670)
{ /* block id: 10 */
    VECTOR(int8_t, 2) l_46 = (VECTOR(int8_t, 2))(0x07L, 0x67L);
    int32_t *l_423[6][1];
    VECTOR(int8_t, 4) l_467 = (VECTOR(int8_t, 4))((-2L), (VECTOR(int8_t, 2))((-2L), 0L), 0L);
    uint16_t *l_468 = &p_670->g_83;
    uint16_t **l_469 = &l_468;
    uint16_t *l_470[8][9] = {{&p_670->g_83,(void*)0,(void*)0,(void*)0,(void*)0,&p_670->g_83,&p_670->g_83,&p_670->g_83,&p_670->g_83},{&p_670->g_83,(void*)0,(void*)0,(void*)0,(void*)0,&p_670->g_83,&p_670->g_83,&p_670->g_83,&p_670->g_83},{&p_670->g_83,(void*)0,(void*)0,(void*)0,(void*)0,&p_670->g_83,&p_670->g_83,&p_670->g_83,&p_670->g_83},{&p_670->g_83,(void*)0,(void*)0,(void*)0,(void*)0,&p_670->g_83,&p_670->g_83,&p_670->g_83,&p_670->g_83},{&p_670->g_83,(void*)0,(void*)0,(void*)0,(void*)0,&p_670->g_83,&p_670->g_83,&p_670->g_83,&p_670->g_83},{&p_670->g_83,(void*)0,(void*)0,(void*)0,(void*)0,&p_670->g_83,&p_670->g_83,&p_670->g_83,&p_670->g_83},{&p_670->g_83,(void*)0,(void*)0,(void*)0,(void*)0,&p_670->g_83,&p_670->g_83,&p_670->g_83,&p_670->g_83},{&p_670->g_83,(void*)0,(void*)0,(void*)0,(void*)0,&p_670->g_83,&p_670->g_83,&p_670->g_83,&p_670->g_83}};
    uint16_t **l_471 = &l_470[5][1];
    VECTOR(int16_t, 8) l_473 = (VECTOR(int16_t, 8))(0x2638L, (VECTOR(int16_t, 4))(0x2638L, (VECTOR(int16_t, 2))(0x2638L, 6L), 6L), 6L, 0x2638L, 6L);
    VECTOR(int16_t, 4) l_474 = (VECTOR(int16_t, 4))(0x3A76L, (VECTOR(int16_t, 2))(0x3A76L, 0x459CL), 0x459CL);
    VECTOR(int16_t, 4) l_477 = (VECTOR(int16_t, 4))(0x71C1L, (VECTOR(int16_t, 2))(0x71C1L, 0x3ED9L), 0x3ED9L);
    VECTOR(uint8_t, 16) l_484 = (VECTOR(uint8_t, 16))(0UL, (VECTOR(uint8_t, 4))(0UL, (VECTOR(uint8_t, 2))(0UL, 0x4EL), 0x4EL), 0x4EL, 0UL, 0x4EL, (VECTOR(uint8_t, 2))(0UL, 0x4EL), (VECTOR(uint8_t, 2))(0UL, 0x4EL), 0UL, 0x4EL, 0UL, 0x4EL);
    uint8_t *l_489[1][1][3];
    int16_t l_490 = 0x41FEL;
    uint32_t l_491 = 0x553E0E99L;
    int8_t *l_492 = (void*)0;
    int8_t *l_493 = &p_670->g_22;
    int64_t *l_494 = (void*)0;
    VECTOR(int32_t, 8) l_496 = (VECTOR(int32_t, 8))(1L, (VECTOR(int32_t, 4))(1L, (VECTOR(int32_t, 2))(1L, 0x41265369L), 0x41265369L), 0x41265369L, 1L, 0x41265369L);
    VECTOR(int32_t, 4) l_502 = (VECTOR(int32_t, 4))((-9L), (VECTOR(int32_t, 2))((-9L), 0x41B78A63L), 0x41B78A63L);
    VECTOR(int32_t, 4) l_504 = (VECTOR(int32_t, 4))((-10L), (VECTOR(int32_t, 2))((-10L), 1L), 1L);
    VECTOR(int32_t, 16) l_509 = (VECTOR(int32_t, 16))(0x23A66718L, (VECTOR(int32_t, 4))(0x23A66718L, (VECTOR(int32_t, 2))(0x23A66718L, 0x6D067BBEL), 0x6D067BBEL), 0x6D067BBEL, 0x23A66718L, 0x6D067BBEL, (VECTOR(int32_t, 2))(0x23A66718L, 0x6D067BBEL), (VECTOR(int32_t, 2))(0x23A66718L, 0x6D067BBEL), 0x23A66718L, 0x6D067BBEL, 0x23A66718L, 0x6D067BBEL);
    VECTOR(int32_t, 16) l_514 = (VECTOR(int32_t, 16))(0x2D278323L, (VECTOR(int32_t, 4))(0x2D278323L, (VECTOR(int32_t, 2))(0x2D278323L, (-4L)), (-4L)), (-4L), 0x2D278323L, (-4L), (VECTOR(int32_t, 2))(0x2D278323L, (-4L)), (VECTOR(int32_t, 2))(0x2D278323L, (-4L)), 0x2D278323L, (-4L), 0x2D278323L, (-4L));
    VECTOR(int32_t, 4) l_516 = (VECTOR(int32_t, 4))((-9L), (VECTOR(int32_t, 2))((-9L), (-1L)), (-1L));
    VECTOR(int32_t, 4) l_517 = (VECTOR(int32_t, 4))((-3L), (VECTOR(int32_t, 2))((-3L), (-1L)), (-1L));
    VECTOR(int32_t, 16) l_518 = (VECTOR(int32_t, 16))(0x463F4DBCL, (VECTOR(int32_t, 4))(0x463F4DBCL, (VECTOR(int32_t, 2))(0x463F4DBCL, (-3L)), (-3L)), (-3L), 0x463F4DBCL, (-3L), (VECTOR(int32_t, 2))(0x463F4DBCL, (-3L)), (VECTOR(int32_t, 2))(0x463F4DBCL, (-3L)), 0x463F4DBCL, (-3L), 0x463F4DBCL, (-3L));
    int32_t l_521 = 2L;
    int i, j, k;
    for (i = 0; i < 6; i++)
    {
        for (j = 0; j < 1; j++)
            l_423[i][j] = &p_670->g_141;
    }
    for (i = 0; i < 1; i++)
    {
        for (j = 0; j < 1; j++)
        {
            for (k = 0; k < 3; k++)
                l_489[i][j][k] = &p_670->g_91.f0;
        }
    }
    if ((safe_rshift_func_uint16_t_u_s(func_40((safe_lshift_func_uint8_t_u_u(((VECTOR(uint8_t, 16))(255UL, ((VECTOR(uint8_t, 2))(mad_sat(((VECTOR(uint8_t, 2))(abs_diff(((VECTOR(int8_t, 2))(hadd(((VECTOR(int8_t, 2))(0x23L, 0x07L)), ((VECTOR(int8_t, 8))(l_46.yyxxyyxx)).s23))), ((VECTOR(int8_t, 4))((((VECTOR(int8_t, 2))(p_670->g_47.zz)).yxxy && ((VECTOR(int8_t, 8))(func_48(func_52(p_670->g_37, ((p_670->g_16.x , func_55(p_9, p_670)) | (l_46.y ^ (safe_div_func_uint16_t_u_u(l_46.x, (safe_mod_func_int16_t_s_s(0x5102L, (safe_add_func_int32_t_s_s(l_46.y, p_670->g_16.x)))))))), p_670), &p_670->g_36, p_8, p_670))).odd))).even))), ((VECTOR(uint8_t, 2))(0x16L)), ((VECTOR(uint8_t, 2))(0UL))))), 0xA8L, ((VECTOR(uint8_t, 8))(0x67L)), ((VECTOR(uint8_t, 2))(1UL)), 253UL, 255UL)).s8, 4)), p_10, p_670->l_comm_values[(safe_mod_func_uint32_t_u_u(p_670->tid, 1))], p_670), p_10)))
    { /* block id: 164 */
        int32_t **l_422 = &p_670->g_99;
        union U0 l_431 = {0x30L};
        uint32_t *l_434[9][4][7] = {{{(void*)0,&p_670->g_435,&p_670->g_435,&p_670->g_435,&p_670->g_435,&p_670->g_435,&p_670->g_435},{(void*)0,&p_670->g_435,&p_670->g_435,&p_670->g_435,&p_670->g_435,&p_670->g_435,&p_670->g_435},{(void*)0,&p_670->g_435,&p_670->g_435,&p_670->g_435,&p_670->g_435,&p_670->g_435,&p_670->g_435},{(void*)0,&p_670->g_435,&p_670->g_435,&p_670->g_435,&p_670->g_435,&p_670->g_435,&p_670->g_435}},{{(void*)0,&p_670->g_435,&p_670->g_435,&p_670->g_435,&p_670->g_435,&p_670->g_435,&p_670->g_435},{(void*)0,&p_670->g_435,&p_670->g_435,&p_670->g_435,&p_670->g_435,&p_670->g_435,&p_670->g_435},{(void*)0,&p_670->g_435,&p_670->g_435,&p_670->g_435,&p_670->g_435,&p_670->g_435,&p_670->g_435},{(void*)0,&p_670->g_435,&p_670->g_435,&p_670->g_435,&p_670->g_435,&p_670->g_435,&p_670->g_435}},{{(void*)0,&p_670->g_435,&p_670->g_435,&p_670->g_435,&p_670->g_435,&p_670->g_435,&p_670->g_435},{(void*)0,&p_670->g_435,&p_670->g_435,&p_670->g_435,&p_670->g_435,&p_670->g_435,&p_670->g_435},{(void*)0,&p_670->g_435,&p_670->g_435,&p_670->g_435,&p_670->g_435,&p_670->g_435,&p_670->g_435},{(void*)0,&p_670->g_435,&p_670->g_435,&p_670->g_435,&p_670->g_435,&p_670->g_435,&p_670->g_435}},{{(void*)0,&p_670->g_435,&p_670->g_435,&p_670->g_435,&p_670->g_435,&p_670->g_435,&p_670->g_435},{(void*)0,&p_670->g_435,&p_670->g_435,&p_670->g_435,&p_670->g_435,&p_670->g_435,&p_670->g_435},{(void*)0,&p_670->g_435,&p_670->g_435,&p_670->g_435,&p_670->g_435,&p_670->g_435,&p_670->g_435},{(void*)0,&p_670->g_435,&p_670->g_435,&p_670->g_435,&p_670->g_435,&p_670->g_435,&p_670->g_435}},{{(void*)0,&p_670->g_435,&p_670->g_435,&p_670->g_435,&p_670->g_435,&p_670->g_435,&p_670->g_435},{(void*)0,&p_670->g_435,&p_670->g_435,&p_670->g_435,&p_670->g_435,&p_670->g_435,&p_670->g_435},{(void*)0,&p_670->g_435,&p_670->g_435,&p_670->g_435,&p_670->g_435,&p_670->g_435,&p_670->g_435},{(void*)0,&p_670->g_435,&p_670->g_435,&p_670->g_435,&p_670->g_435,&p_670->g_435,&p_670->g_435}},{{(void*)0,&p_670->g_435,&p_670->g_435,&p_670->g_435,&p_670->g_435,&p_670->g_435,&p_670->g_435},{(void*)0,&p_670->g_435,&p_670->g_435,&p_670->g_435,&p_670->g_435,&p_670->g_435,&p_670->g_435},{(void*)0,&p_670->g_435,&p_670->g_435,&p_670->g_435,&p_670->g_435,&p_670->g_435,&p_670->g_435},{(void*)0,&p_670->g_435,&p_670->g_435,&p_670->g_435,&p_670->g_435,&p_670->g_435,&p_670->g_435}},{{(void*)0,&p_670->g_435,&p_670->g_435,&p_670->g_435,&p_670->g_435,&p_670->g_435,&p_670->g_435},{(void*)0,&p_670->g_435,&p_670->g_435,&p_670->g_435,&p_670->g_435,&p_670->g_435,&p_670->g_435},{(void*)0,&p_670->g_435,&p_670->g_435,&p_670->g_435,&p_670->g_435,&p_670->g_435,&p_670->g_435},{(void*)0,&p_670->g_435,&p_670->g_435,&p_670->g_435,&p_670->g_435,&p_670->g_435,&p_670->g_435}},{{(void*)0,&p_670->g_435,&p_670->g_435,&p_670->g_435,&p_670->g_435,&p_670->g_435,&p_670->g_435},{(void*)0,&p_670->g_435,&p_670->g_435,&p_670->g_435,&p_670->g_435,&p_670->g_435,&p_670->g_435},{(void*)0,&p_670->g_435,&p_670->g_435,&p_670->g_435,&p_670->g_435,&p_670->g_435,&p_670->g_435},{(void*)0,&p_670->g_435,&p_670->g_435,&p_670->g_435,&p_670->g_435,&p_670->g_435,&p_670->g_435}},{{(void*)0,&p_670->g_435,&p_670->g_435,&p_670->g_435,&p_670->g_435,&p_670->g_435,&p_670->g_435},{(void*)0,&p_670->g_435,&p_670->g_435,&p_670->g_435,&p_670->g_435,&p_670->g_435,&p_670->g_435},{(void*)0,&p_670->g_435,&p_670->g_435,&p_670->g_435,&p_670->g_435,&p_670->g_435,&p_670->g_435},{(void*)0,&p_670->g_435,&p_670->g_435,&p_670->g_435,&p_670->g_435,&p_670->g_435,&p_670->g_435}}};
        int32_t l_446 = 0x78F90EE5L;
        uint8_t l_447[7][4] = {{0xB5L,0xB5L,0xA2L,0UL},{0xB5L,0xB5L,0xA2L,0UL},{0xB5L,0xB5L,0xA2L,0UL},{0xB5L,0xB5L,0xA2L,0UL},{0xB5L,0xB5L,0xA2L,0UL},{0xB5L,0xB5L,0xA2L,0UL},{0xB5L,0xB5L,0xA2L,0UL}};
        int i, j, k;
        (*l_422) = ((((VECTOR(uint32_t, 8))((((VECTOR(uint32_t, 2))(7UL, 0xBB65AF1EL)).xxxxxyyx | ((VECTOR(uint32_t, 4))((-((VECTOR(uint32_t, 2))(3UL, 0UL)).xxxy))).zwzxyywx))).s7 | GROUP_DIVERGE(0, 1)) , func_57((p_670->g_83 > p_670->g_288.w), (l_46.y , l_422), p_670));
        l_423[0][0] = ((**p_670->g_369) = l_423[0][0]);
        (**p_670->g_369) = func_57(((GROUP_DIVERGE(1, 1) , ((safe_sub_func_uint64_t_u_u(((safe_sub_func_int64_t_s_s((safe_add_func_uint64_t_u_u(((0x12D11FC3DF9600C1L >= (p_670->g_430 = 0UL)) , ((l_431 , 0x05D2L) <= ((p_670->g_47.y , ((((!((safe_add_func_uint32_t_u_u(((**l_422) = p_9), ((VECTOR(int32_t, 16))(0x79CC3CFDL, (safe_lshift_func_uint8_t_u_s((safe_rshift_func_int16_t_s_s((safe_add_func_int64_t_s_s((safe_div_func_int8_t_s_s((*p_670->g_36), ((VECTOR(int8_t, 4))(rhadd(((VECTOR(int8_t, 2))(0x49L, 0x16L)).yyyy, ((VECTOR(int8_t, 2))(0x28L, (-10L))).yyxy))).w)), (safe_rshift_func_uint16_t_u_s(((l_446 = 1L) > 0x2AF56BBDL), l_447[3][0])))), p_670->g_16.x)), (*p_670->g_36))), p_8, p_9, ((VECTOR(int32_t, 2))(1L)), 2L, 0x1A93390EL, (-8L), p_10, (-2L), ((VECTOR(int32_t, 2))((-1L))), 0x1147FA53L, 0x7EC69BE2L, 0L)).sc)) && GROUP_DIVERGE(0, 1))) || p_8) & p_670->g_418.x) != p_10)) , p_9))), 0x4D1F74BA9E946E8EL)), p_9)) | p_10), 0x2C2750C409C2E319L)) | p_8)) | (-1L)), &l_423[0][0], p_670);
    }
    else
    { /* block id: 172 */
        int16_t *l_456[10][4] = {{(void*)0,(void*)0,(void*)0,(void*)0},{(void*)0,(void*)0,(void*)0,(void*)0},{(void*)0,(void*)0,(void*)0,(void*)0},{(void*)0,(void*)0,(void*)0,(void*)0},{(void*)0,(void*)0,(void*)0,(void*)0},{(void*)0,(void*)0,(void*)0,(void*)0},{(void*)0,(void*)0,(void*)0,(void*)0},{(void*)0,(void*)0,(void*)0,(void*)0},{(void*)0,(void*)0,(void*)0,(void*)0},{(void*)0,(void*)0,(void*)0,(void*)0}};
        int32_t l_457[5] = {0x6459A5AEL,0x6459A5AEL,0x6459A5AEL,0x6459A5AEL,0x6459A5AEL};
        int32_t l_460 = 0L;
        uint32_t *l_461 = &p_670->g_462;
        int32_t l_463 = (-1L);
        int i, j;
        l_463 ^= (((FAKE_DIVERGE(p_670->local_1_offset, get_local_id(1), 10) <= ((p_670->g_16.y <= (p_10 , (((*l_461) = (safe_div_func_int32_t_s_s(p_9, (((safe_sub_func_uint8_t_u_u((p_8 ^ ((p_670->g_379.x ^ (safe_div_func_int64_t_s_s((safe_rshift_func_int16_t_s_u((l_457[4] = p_670->g_47.x), 11)), (safe_add_func_uint32_t_u_u(0xD63B27E8L, 0x30AC0643L))))) <= ((void*)0 == l_423[0][0]))), p_9)) >= (**p_670->g_370)) & l_460)))) , p_10))) & 6UL)) >= 0UL) <= p_670->g_91.f0);
        return p_11;
    }
    if (((p_670->l_comm_values[(safe_mod_func_uint32_t_u_u(p_670->tid, 1))] = (((*l_493) = ((VECTOR(int8_t, 16))((-6L), (*p_11), 0x32L, 0x41L, 0x29L, ((VECTOR(int8_t, 8))(p_670->g_464.s01010727)), ((VECTOR(int8_t, 2))((((VECTOR(int8_t, 4))(rhadd(((VECTOR(int8_t, 8))((((VECTOR(int8_t, 16))(((*p_11) |= ((VECTOR(int8_t, 2))((((VECTOR(int8_t, 2))(clz(((VECTOR(int8_t, 2))((((VECTOR(int8_t, 8))(p_670->g_465.zwxywyzx)).s71 || ((VECTOR(int8_t, 16))(hadd(((VECTOR(int8_t, 16))(p_670->g_466.yyyxyxyxxxxyxxyy)), ((VECTOR(int8_t, 2))(0x2EL, 1L)).yyyyxxyxxyxxxyyy))).sae)))))) && ((VECTOR(int8_t, 2))((((VECTOR(int8_t, 8))(0x2AL, ((VECTOR(int8_t, 2))(l_467.zx)), ((((*l_469) = l_468) != ((*l_471) = l_470[2][6])) , (-6L)), ((void*)0 != &p_670->g_83), 0x50L, 0x1CL, 0x28L)).s00 && ((VECTOR(int8_t, 4))(0x08L, (safe_unary_minus_func_uint8_t_u((((VECTOR(int16_t, 8))(0x44E3L, ((VECTOR(int16_t, 2))((((VECTOR(int16_t, 4))(mad_sat(((VECTOR(int16_t, 4))(max(((VECTOR(int16_t, 16))((((VECTOR(int16_t, 16))(l_473.s5575133752352631)) ^ ((VECTOR(int16_t, 8))(l_474.zzxxwxxz)).s6502065451363372))).s046a, (int16_t)(safe_lshift_func_int16_t_s_s(((VECTOR(int16_t, 2))(0x1177L, 0x4A38L)).lo, 3))))), ((VECTOR(int16_t, 4))(l_477.wxxx)), ((VECTOR(int16_t, 2))(safe_clamp_func(VECTOR(int16_t, 2),VECTOR(int16_t, 2),((VECTOR(int16_t, 16))(rhadd(((VECTOR(int16_t, 2))(safe_mad_hi_func_int16_t_s_s_s(VECTOR(int16_t, 2),((VECTOR(int16_t, 2))(5L, 0L)), ((VECTOR(int16_t, 2))(0L, 0L)), ((VECTOR(int16_t, 16))(0x08DBL, p_670->g_418.x, ((VECTOR(int16_t, 2))((((VECTOR(int16_t, 4))(upsample(((VECTOR(int8_t, 8))(p_670->g_478.xxyyxyyy)).even, ((VECTOR(uint8_t, 2))(safe_clamp_func(VECTOR(uint8_t, 2),VECTOR(uint8_t, 2),((VECTOR(uint8_t, 2))((((VECTOR(uint8_t, 8))(p_670->g_481.s3441f030)).s14 + ((VECTOR(uint8_t, 8))((((VECTOR(uint8_t, 8))((((VECTOR(uint8_t, 2))(l_484.s70)).xyxyyyyx + ((VECTOR(uint8_t, 16))(1UL, 1UL, 255UL, (p_670->g_89 = (safe_rshift_func_int8_t_s_u((safe_mod_func_uint16_t_u_u(p_8, p_10)), 3))), 0UL, 0xA1L, 0x05L, 254UL, 0xC3L, 0x59L, ((VECTOR(uint8_t, 2))(0xDAL)), 246UL, 8UL, 0xE8L, 0UL)).hi))) & ((VECTOR(uint8_t, 8))(1UL))))).s24))), ((VECTOR(uint8_t, 2))(3UL)), ((VECTOR(uint8_t, 2))(1UL))))).xyxx))).hi <= ((VECTOR(int16_t, 2))(0L))))), (-1L), ((VECTOR(int16_t, 4))(0L)), l_490, ((VECTOR(int16_t, 2))(0x6BBEL)), ((VECTOR(int16_t, 4))(3L)))).sce))).yxyyxyyyyxxxyxyx, ((VECTOR(int16_t, 16))(0x36EAL))))).s94, ((VECTOR(int16_t, 2))((-1L))), ((VECTOR(int16_t, 2))(0x6144L))))).yxxx))).even && ((VECTOR(int16_t, 2))(0x4C60L))))), p_670->g_385[0], ((VECTOR(int16_t, 4))(0x4C76L)))).s3 | p_670->g_465.z))), 0x2CL, (-1L))).lo)))))).hi), 0L, 1L, ((VECTOR(int8_t, 2))(0x7CL)), l_491, (-10L), (*p_670->g_36), ((VECTOR(int8_t, 8))((-8L))))).hi && ((VECTOR(int8_t, 8))((-2L)))))).hi, ((VECTOR(int8_t, 4))(8L))))).odd && ((VECTOR(int8_t, 2))((-1L)))))), (-1L))).s9) , p_9)) >= p_670->g_379.y))
    { /* block id: 184 */
        VECTOR(int32_t, 4) l_497 = (VECTOR(int32_t, 4))(1L, (VECTOR(int32_t, 2))(1L, 0x62CF8532L), 0x62CF8532L);
        uint8_t l_501 = 0x5DL;
        VECTOR(int32_t, 8) l_505 = (VECTOR(int32_t, 8))((-1L), (VECTOR(int32_t, 4))((-1L), (VECTOR(int32_t, 2))((-1L), (-5L)), (-5L)), (-5L), (-1L), (-5L));
        VECTOR(int32_t, 8) l_506 = (VECTOR(int32_t, 8))(9L, (VECTOR(int32_t, 4))(9L, (VECTOR(int32_t, 2))(9L, 0x151E375AL), 0x151E375AL), 0x151E375AL, 9L, 0x151E375AL);
        VECTOR(int32_t, 16) l_510 = (VECTOR(int32_t, 16))((-3L), (VECTOR(int32_t, 4))((-3L), (VECTOR(int32_t, 2))((-3L), 0L), 0L), 0L, (-3L), 0L, (VECTOR(int32_t, 2))((-3L), 0L), (VECTOR(int32_t, 2))((-3L), 0L), (-3L), 0L, (-3L), 0L);
        VECTOR(int32_t, 4) l_511 = (VECTOR(int32_t, 4))(0x1B95DD95L, (VECTOR(int32_t, 2))(0x1B95DD95L, 0L), 0L);
        VECTOR(int32_t, 4) l_512 = (VECTOR(int32_t, 4))(0x55C349DBL, (VECTOR(int32_t, 2))(0x55C349DBL, 0x364F09B6L), 0x364F09B6L);
        VECTOR(int32_t, 8) l_515 = (VECTOR(int32_t, 8))(0x09C1A0B6L, (VECTOR(int32_t, 4))(0x09C1A0B6L, (VECTOR(int32_t, 2))(0x09C1A0B6L, 0x7B451275L), 0x7B451275L), 0x7B451275L, 0x09C1A0B6L, 0x7B451275L);
        int32_t l_520 = 8L;
        uint8_t l_522[2];
        int i;
        for (i = 0; i < 2; i++)
            l_522[i] = 1UL;
        (*p_670->g_99) = (((VECTOR(int32_t, 16))((((VECTOR(int32_t, 8))(((VECTOR(int32_t, 2))(p_670->g_495.wx)), ((VECTOR(int32_t, 4))(0x7DF2C22FL, ((VECTOR(int32_t, 2))((((VECTOR(int32_t, 8))((((VECTOR(int32_t, 16))(safe_clamp_func(VECTOR(int32_t, 16),int32_t,((VECTOR(int32_t, 2))(safe_mul24_func_int32_t_s_s(VECTOR(int32_t, 2),((VECTOR(int32_t, 2))(mad_sat(((VECTOR(int32_t, 8))(l_496.s20501040)).s50, ((VECTOR(int32_t, 16))(min(((VECTOR(int32_t, 4))((((VECTOR(int32_t, 2))(l_497.yw)).yxxy > ((VECTOR(int32_t, 4))(((VECTOR(int32_t, 16))(clz(((VECTOR(int32_t, 4))(p_670->g_498.s2700)).wxwxxyyyzyxyyxwx))).s4, (safe_add_func_int32_t_s_s(p_8, (p_670->g_464.s1 , (p_670->g_comm_values[p_670->tid] != p_9)))), 0x04D06E3CL, 7L))))).zwxxzwxzzyzywyzz, (int32_t)l_501))).s86, ((VECTOR(int32_t, 16))(safe_mad_hi_func_int32_t_s_s_s(VECTOR(int32_t, 16),((VECTOR(int32_t, 4))(((VECTOR(int32_t, 2))((((VECTOR(int32_t, 2))(l_502.zy)) <= ((VECTOR(int32_t, 2))(5L, 1L))))), 0L, (-1L))).xwxzzyxwwxyxyxww, ((VECTOR(int32_t, 4))(min(((VECTOR(int32_t, 2))(min(((VECTOR(int32_t, 8))(sub_sat(((VECTOR(int32_t, 2))((((VECTOR(int32_t, 8))((((VECTOR(int32_t, 16))(0x4FA4ADDCL, ((VECTOR(int32_t, 4))((((VECTOR(int32_t, 8))(mad_sat(((VECTOR(int32_t, 4))((((VECTOR(int32_t, 4))(p_670->g_503.s1451)) && ((VECTOR(int32_t, 2))((((VECTOR(int32_t, 16))(l_504.xxwwzzwyzwzyxzzy)).s96 && ((VECTOR(int32_t, 8))(max(((VECTOR(int32_t, 2))(safe_mul24_func_int32_t_s_s(VECTOR(int32_t, 2),((VECTOR(int32_t, 2))(min(((VECTOR(int32_t, 16))(rotate(((VECTOR(int32_t, 8))(l_505.s25274360)).s0572710564426220, ((VECTOR(int32_t, 2))(l_506.s43)).xyxyxyyyxyxxxxxx))).sbe, ((VECTOR(int32_t, 16))(hadd(((VECTOR(int32_t, 8))((p_9 & (safe_mul_func_uint16_t_u_u(FAKE_DIVERGE(p_670->global_1_offset, get_global_id(1), 10), p_670->g_28))), 0x4E7C7ACEL, ((VECTOR(int32_t, 2))(l_509.s02)), 0x26A3AAE0L, ((VECTOR(int32_t, 2))(l_510.se5)), (-8L))).s6125111302410347, ((VECTOR(int32_t, 16))(l_511.xzxwzxwyyxxxyxwz))))).sd2))), ((VECTOR(int32_t, 8))(((VECTOR(int32_t, 4))(safe_mul24_func_int32_t_s_s(VECTOR(int32_t, 4),((VECTOR(int32_t, 8))(l_512.zzyywzzw)).even, ((VECTOR(int32_t, 4))(rotate(((VECTOR(int32_t, 4))((((VECTOR(int32_t, 4))(p_670->g_513.s2376)) || ((VECTOR(int32_t, 4))((((VECTOR(int32_t, 16))(l_514.s871033a2c4cc19f7)).se552 < ((VECTOR(int32_t, 4))(add_sat(((VECTOR(int32_t, 8))(clz(((VECTOR(int32_t, 2))(l_515.s50)).xxxyxxxx))).lo, ((VECTOR(int32_t, 16))(add_sat(((VECTOR(int32_t, 16))(l_516.yzwxxxzyzyxwxwwz)), ((VECTOR(int32_t, 4))(safe_clamp_func(VECTOR(int32_t, 4),int32_t,((VECTOR(int32_t, 8))(safe_mad24_func_int32_t_s_s_s(VECTOR(int32_t, 8),((VECTOR(int32_t, 4))((-6L), ((VECTOR(int32_t, 2))(safe_clamp_func(VECTOR(int32_t, 2),int32_t,((VECTOR(int32_t, 16))(safe_mad24_func_int32_t_s_s_s(VECTOR(int32_t, 16),((VECTOR(int32_t, 8))((((VECTOR(int32_t, 2))(min(((VECTOR(int32_t, 2))(l_517.yz)), ((VECTOR(int32_t, 8))(((VECTOR(int32_t, 4))(((VECTOR(int32_t, 2))((((VECTOR(int32_t, 4))(l_518.s17eb)).hi ^ ((VECTOR(int32_t, 16))(p_670->g_519.zwzywzzwzxwyzxyy)).s3f))), (-2L), 0x1C90AC05L)), ((((void*)0 == l_492) , p_670->g_385[0]) & 0xEDFF9126A54A9079L), ((VECTOR(int32_t, 2))(0x5ADCAC0CL)), 0x6D2DD816L)).s21))).yxyyyxxy || ((VECTOR(int32_t, 8))(0x74767F68L))))).s0263406212773267, ((VECTOR(int32_t, 16))(0L)), ((VECTOR(int32_t, 16))(1L))))).s1d, (int32_t)p_9, (int32_t)l_512.z))).lo, (-6L), 0x081DB76AL)).zxwzxwxy, ((VECTOR(int32_t, 8))(0x4F0BA272L)), ((VECTOR(int32_t, 8))(0L))))).hi, (int32_t)(***p_670->g_369), (int32_t)p_9))).xzyxxxxxyzzwxzxw))).s470e))))))))), ((VECTOR(int32_t, 4))(0x124870A3L)))))))), l_497.x, 0x1CD811DBL, (-1L), 0x0CF10664L)).s34))).xxyxyxxx, ((VECTOR(int32_t, 8))((-2L)))))).s31))).yyyx))).yyxzywzz, ((VECTOR(int32_t, 8))((-1L))), ((VECTOR(int32_t, 8))((-4L)))))).odd ^ ((VECTOR(int32_t, 4))(0x32368968L))))), (***p_670->g_369), 0x6CF1C58CL, 0x49E4057DL, 0L, l_520, 0x2D04C37EL, 0L, p_10, 0x328D8CA0L, (-4L), (-1L))).hi && ((VECTOR(int32_t, 8))(0x0617510EL))))).s44 && ((VECTOR(int32_t, 2))(0x128AF2A7L))))).xyxxxyxy, ((VECTOR(int32_t, 8))(0x37B8CE59L))))).s31, ((VECTOR(int32_t, 2))(1L))))).xyxy, ((VECTOR(int32_t, 4))(0x24C8512AL))))).zxwwwyywxwyzwyyy, ((VECTOR(int32_t, 16))(1L))))).sc3))), ((VECTOR(int32_t, 2))((-5L)))))).xxxxxyxyyxyyxxxy, (int32_t)l_510.s2, (int32_t)(-1L)))).hi ^ ((VECTOR(int32_t, 8))((-1L)))))).s43 && ((VECTOR(int32_t, 2))(0x74785844L))))), 0L)), 0x3FCC6056L, (-3L))).s1563774777161251 ^ ((VECTOR(int32_t, 16))(9L))))).s5 ^ p_9);
        ++l_522[0];
    }
    else
    { /* block id: 187 */
        return p_11;
    }
    (*p_670->g_99) &= p_10;
    return p_11;
}


/* ------------------------------------------ */
/* 
 * reads :
 * writes:
 */
VECTOR(int64_t, 4)  func_24(int8_t  p_25, struct S1 * p_670)
{ /* block id: 6 */
    int32_t *l_27 = &p_670->g_28;
    int32_t **l_26 = &l_27;
    VECTOR(int64_t, 4) l_29 = (VECTOR(int64_t, 4))(0x045180735653649DL, (VECTOR(int64_t, 2))(0x045180735653649DL, 1L), 1L);
    int i;
    (*l_26) = (void*)0;
    return l_29.ywzy;
}


/* ------------------------------------------ */
/* 
 * reads : p_670->g_33
 * writes:
 */
uint16_t  func_40(uint16_t  p_41, uint8_t  p_42, uint32_t  p_43, struct S1 * p_670)
{ /* block id: 161 */
    VECTOR(uint32_t, 8) l_419 = (VECTOR(uint32_t, 8))(0xE9724E1EL, (VECTOR(uint32_t, 4))(0xE9724E1EL, (VECTOR(uint32_t, 2))(0xE9724E1EL, 0x42822598L), 0x42822598L), 0x42822598L, 0xE9724E1EL, 0x42822598L);
    int i;
    --l_419.s5;
    return p_670->g_33.y;
}


/* ------------------------------------------ */
/* 
 * reads : p_670->g_369 p_670->g_370 p_670->g_99 p_670->g_28 p_670->g_141 p_670->g_36 p_670->g_47 p_670->g_92 p_670->l_comm_values p_670->g_33 p_670->g_22 p_670->g_comm_values p_670->g_418
 * writes: p_670->g_141 p_670->g_37 p_670->g_93 p_670->g_83 p_670->g_89 p_670->g_99
 */
VECTOR(int8_t, 8)  func_48(int8_t ** p_49, int8_t ** p_50, int16_t  p_51, struct S1 * p_670)
{ /* block id: 155 */
    int32_t *l_388 = &p_670->g_141;
    VECTOR(uint16_t, 8) l_399 = (VECTOR(uint16_t, 8))(1UL, (VECTOR(uint16_t, 4))(1UL, (VECTOR(uint16_t, 2))(1UL, 3UL), 3UL), 3UL, 1UL, 3UL);
    int32_t ***l_415[10][6][4] = {{{&p_670->g_370,(void*)0,&p_670->g_370,&p_670->g_370},{&p_670->g_370,(void*)0,&p_670->g_370,&p_670->g_370},{&p_670->g_370,(void*)0,&p_670->g_370,&p_670->g_370},{&p_670->g_370,(void*)0,&p_670->g_370,&p_670->g_370},{&p_670->g_370,(void*)0,&p_670->g_370,&p_670->g_370},{&p_670->g_370,(void*)0,&p_670->g_370,&p_670->g_370}},{{&p_670->g_370,(void*)0,&p_670->g_370,&p_670->g_370},{&p_670->g_370,(void*)0,&p_670->g_370,&p_670->g_370},{&p_670->g_370,(void*)0,&p_670->g_370,&p_670->g_370},{&p_670->g_370,(void*)0,&p_670->g_370,&p_670->g_370},{&p_670->g_370,(void*)0,&p_670->g_370,&p_670->g_370},{&p_670->g_370,(void*)0,&p_670->g_370,&p_670->g_370}},{{&p_670->g_370,(void*)0,&p_670->g_370,&p_670->g_370},{&p_670->g_370,(void*)0,&p_670->g_370,&p_670->g_370},{&p_670->g_370,(void*)0,&p_670->g_370,&p_670->g_370},{&p_670->g_370,(void*)0,&p_670->g_370,&p_670->g_370},{&p_670->g_370,(void*)0,&p_670->g_370,&p_670->g_370},{&p_670->g_370,(void*)0,&p_670->g_370,&p_670->g_370}},{{&p_670->g_370,(void*)0,&p_670->g_370,&p_670->g_370},{&p_670->g_370,(void*)0,&p_670->g_370,&p_670->g_370},{&p_670->g_370,(void*)0,&p_670->g_370,&p_670->g_370},{&p_670->g_370,(void*)0,&p_670->g_370,&p_670->g_370},{&p_670->g_370,(void*)0,&p_670->g_370,&p_670->g_370},{&p_670->g_370,(void*)0,&p_670->g_370,&p_670->g_370}},{{&p_670->g_370,(void*)0,&p_670->g_370,&p_670->g_370},{&p_670->g_370,(void*)0,&p_670->g_370,&p_670->g_370},{&p_670->g_370,(void*)0,&p_670->g_370,&p_670->g_370},{&p_670->g_370,(void*)0,&p_670->g_370,&p_670->g_370},{&p_670->g_370,(void*)0,&p_670->g_370,&p_670->g_370},{&p_670->g_370,(void*)0,&p_670->g_370,&p_670->g_370}},{{&p_670->g_370,(void*)0,&p_670->g_370,&p_670->g_370},{&p_670->g_370,(void*)0,&p_670->g_370,&p_670->g_370},{&p_670->g_370,(void*)0,&p_670->g_370,&p_670->g_370},{&p_670->g_370,(void*)0,&p_670->g_370,&p_670->g_370},{&p_670->g_370,(void*)0,&p_670->g_370,&p_670->g_370},{&p_670->g_370,(void*)0,&p_670->g_370,&p_670->g_370}},{{&p_670->g_370,(void*)0,&p_670->g_370,&p_670->g_370},{&p_670->g_370,(void*)0,&p_670->g_370,&p_670->g_370},{&p_670->g_370,(void*)0,&p_670->g_370,&p_670->g_370},{&p_670->g_370,(void*)0,&p_670->g_370,&p_670->g_370},{&p_670->g_370,(void*)0,&p_670->g_370,&p_670->g_370},{&p_670->g_370,(void*)0,&p_670->g_370,&p_670->g_370}},{{&p_670->g_370,(void*)0,&p_670->g_370,&p_670->g_370},{&p_670->g_370,(void*)0,&p_670->g_370,&p_670->g_370},{&p_670->g_370,(void*)0,&p_670->g_370,&p_670->g_370},{&p_670->g_370,(void*)0,&p_670->g_370,&p_670->g_370},{&p_670->g_370,(void*)0,&p_670->g_370,&p_670->g_370},{&p_670->g_370,(void*)0,&p_670->g_370,&p_670->g_370}},{{&p_670->g_370,(void*)0,&p_670->g_370,&p_670->g_370},{&p_670->g_370,(void*)0,&p_670->g_370,&p_670->g_370},{&p_670->g_370,(void*)0,&p_670->g_370,&p_670->g_370},{&p_670->g_370,(void*)0,&p_670->g_370,&p_670->g_370},{&p_670->g_370,(void*)0,&p_670->g_370,&p_670->g_370},{&p_670->g_370,(void*)0,&p_670->g_370,&p_670->g_370}},{{&p_670->g_370,(void*)0,&p_670->g_370,&p_670->g_370},{&p_670->g_370,(void*)0,&p_670->g_370,&p_670->g_370},{&p_670->g_370,(void*)0,&p_670->g_370,&p_670->g_370},{&p_670->g_370,(void*)0,&p_670->g_370,&p_670->g_370},{&p_670->g_370,(void*)0,&p_670->g_370,&p_670->g_370},{&p_670->g_370,(void*)0,&p_670->g_370,&p_670->g_370}}};
    union U0 *l_416 = &p_670->g_91;
    union U0 **l_417 = &p_670->g_93[4];
    int i, j, k;
    (*l_388) &= (***p_670->g_369);
    (*p_670->g_370) = func_57(((safe_mul_func_int8_t_s_s((safe_mod_func_uint64_t_u_u((safe_rshift_func_uint16_t_u_u(((VECTOR(uint16_t, 16))(0x09A9L, ((VECTOR(uint16_t, 8))((((VECTOR(uint16_t, 2))(65535UL, 0x5AF0L)).xxxyxxxy + ((VECTOR(uint16_t, 16))((((VECTOR(uint16_t, 8))(mad_sat(((VECTOR(uint16_t, 2))(l_399.s33)).xxxxyyyy, ((VECTOR(uint16_t, 8))((((VECTOR(uint16_t, 16))(p_51, 0UL, 65534UL, 0xBE22L, ((VECTOR(uint16_t, 4))((((VECTOR(uint16_t, 2))(abs_diff(((VECTOR(uint16_t, 8))((((VECTOR(uint16_t, 8))(((safe_mul_func_uint8_t_u_u((*l_388), (safe_rshift_func_int16_t_s_s((((l_388 == l_388) , &p_670->g_374[0]) == &p_670->g_374[0]), 12)))) ^ ((((**p_49) = (safe_unary_minus_func_int64_t_s(p_51))) , ((safe_add_func_int16_t_s_s((safe_mod_func_uint8_t_u_u(((*l_388) , (l_415[6][1][3] != &p_670->g_100)), 0x5EL)), p_51)) , p_51)) , p_670->g_47.x)), ((VECTOR(uint16_t, 2))(0xD498L)), p_51, ((VECTOR(uint16_t, 4))(1UL)))) * ((VECTOR(uint16_t, 8))(0xA642L))))).s03, ((VECTOR(uint16_t, 2))(65533UL))))).yyxy + ((VECTOR(uint16_t, 4))(1UL))))), FAKE_DIVERGE(p_670->group_0_offset, get_group_id(0), 10), 0x27D2L, 65535UL, ((VECTOR(uint16_t, 4))(65528UL)), 1UL)).hi + ((VECTOR(uint16_t, 8))(0x3DF1L))))), ((VECTOR(uint16_t, 8))(0UL))))).s5411525276242437 + ((VECTOR(uint16_t, 16))(0x854CL))))).hi))), 0UL, 1UL, 65535UL, 65532UL, ((VECTOR(uint16_t, 2))(1UL)), 0xE79BL)).se, p_51)), 0x54585D67A78EF364L)), p_51)) , 1UL), (*p_670->g_369), p_670);
    (*l_417) = l_416;
    return p_670->g_418.wxwxyzwz;
}


/* ------------------------------------------ */
/* 
 * reads : p_670->g_36 p_670->g_37 p_670->g_30 p_670->g_99 p_670->g_89 p_670->g_22 p_670->l_comm_values p_670->g_28 p_670->g_83 p_670->g_288 p_670->g_143 p_670->g_comm_values p_670->g_92 p_670->g_33 p_670->g_369 p_670->g_385
 * writes: p_670->g_28 p_670->g_141 p_670->g_143 p_670->g_37 p_670->g_83 p_670->g_93 p_670->g_89 p_670->g_91.f0 p_670->g_369 p_670->g_374 p_670->g_385
 */
int8_t ** func_52(uint8_t  p_53, uint32_t  p_54, struct S1 * p_670)
{ /* block id: 35 */
    uint32_t l_125 = 1UL;
    int32_t l_126 = 9L;
    int32_t *l_137 = &l_126;
    int32_t l_138 = 0x048EBA30L;
    int32_t *l_139 = (void*)0;
    int32_t *l_140 = &p_670->g_141;
    int32_t *l_142 = &p_670->g_143;
    int32_t *l_144 = (void*)0;
    int32_t *l_145[7];
    int32_t l_146[1][6] = {{1L,1L,1L,1L,1L,1L}};
    uint64_t l_147 = 0xB0101A31BCC97913L;
    int32_t **l_151 = &l_142;
    int32_t l_318 = 0x20ED5610L;
    int8_t **l_357[7][6] = {{&p_670->g_36,&p_670->g_36,&p_670->g_36,&p_670->g_36,&p_670->g_36,&p_670->g_36},{&p_670->g_36,&p_670->g_36,&p_670->g_36,&p_670->g_36,&p_670->g_36,&p_670->g_36},{&p_670->g_36,&p_670->g_36,&p_670->g_36,&p_670->g_36,&p_670->g_36,&p_670->g_36},{&p_670->g_36,&p_670->g_36,&p_670->g_36,&p_670->g_36,&p_670->g_36,&p_670->g_36},{&p_670->g_36,&p_670->g_36,&p_670->g_36,&p_670->g_36,&p_670->g_36,&p_670->g_36},{&p_670->g_36,&p_670->g_36,&p_670->g_36,&p_670->g_36,&p_670->g_36,&p_670->g_36},{&p_670->g_36,&p_670->g_36,&p_670->g_36,&p_670->g_36,&p_670->g_36,&p_670->g_36}};
    uint8_t l_362 = 0UL;
    int32_t **l_380 = &l_145[1];
    int i, j;
    for (i = 0; i < 7; i++)
        l_145[i] = (void*)0;
    (*l_142) = ((*l_140) = (l_138 ^= ((*l_137) = (safe_rshift_func_int16_t_s_u((safe_div_func_int64_t_s_s(((l_125 = ((*p_670->g_36) < (-1L))) || 0L), l_126)), ((VECTOR(uint16_t, 8))((+((VECTOR(uint16_t, 16))(hadd(((VECTOR(uint16_t, 8))(((VECTOR(uint16_t, 2))(clz(((VECTOR(uint16_t, 8))((((VECTOR(uint16_t, 2))(1UL, 0x522DL)).xyxyxxyy + ((VECTOR(uint16_t, 4))(((0x1EF97960L | (FAKE_DIVERGE(p_670->local_1_offset, get_local_id(1), 10) , (((VECTOR(int64_t, 8))(((VECTOR(int64_t, 4))(((VECTOR(int64_t, 2))(add_sat(((VECTOR(int64_t, 4))((((VECTOR(int64_t, 8))((((VECTOR(int64_t, 8))(0L, (safe_mul_func_int16_t_s_s((safe_mod_func_int64_t_s_s(((VECTOR(int64_t, 2))(0x69D581DC2E7BD33CL, 8L)).odd, (safe_mod_func_int64_t_s_s(l_126, (safe_lshift_func_int8_t_s_s((l_126 == ((*p_670->g_99) = ((&p_53 == &p_670->g_89) == p_670->g_30.y))), 0)))))), p_670->g_89)), ((VECTOR(int64_t, 4))(0x5EBD512F4ECBCE0EL)), (-9L), 1L)) <= ((VECTOR(int64_t, 8))(0x2979D12DC1848BC0L))))).odd || ((VECTOR(int64_t, 4))((-9L)))))).hi, ((VECTOR(int64_t, 2))(0x4CF47AE02F2754EDL))))), 0x3031DE9004F71531L, (-10L))), (-6L), 0x5B1C9D1C1E51B7A5L, 0x6873C8D9F3E27632L, (-1L))).s1 | p_670->g_89))) ^ GROUP_DIVERGE(0, 1)), 0UL, 0xACFDL, 0xEC70L)).yywyxyxx))).s45))), ((VECTOR(uint16_t, 2))(0x6DA7L)), 0UL, 65533UL, 0xCBE0L, 0UL)).s5571426451145171, ((VECTOR(uint16_t, 16))(65535UL))))).even))).s5)))));
    --l_147;
    (*l_151) = &l_146[0][2];
    for (p_54 = 0; (p_54 > 52); p_54++)
    { /* block id: 46 */
        int32_t *l_297[5];
        int32_t l_298 = 0x62189C13L;
        int32_t l_299[3];
        int32_t l_300 = (-1L);
        uint32_t l_320 = 1UL;
        int i;
        for (i = 0; i < 5; i++)
            l_297[i] = &p_670->g_28;
        for (i = 0; i < 3; i++)
            l_299[i] = 6L;
        if ((atomic_inc(&p_670->g_atomic_input[4 * get_linear_group_id() + 2]) == 1))
        { /* block id: 48 */
            uint32_t l_154 = 0x313960B7L;
            if (l_154)
            { /* block id: 49 */
                int32_t l_155 = 1L;
                int32_t *l_162 = &l_155;
                int64_t l_163 = (-9L);
                VECTOR(uint32_t, 8) l_164 = (VECTOR(uint32_t, 8))(0UL, (VECTOR(uint32_t, 4))(0UL, (VECTOR(uint32_t, 2))(0UL, 0x602BA409L), 0x602BA409L), 0x602BA409L, 0UL, 0x602BA409L);
                int i;
                for (l_155 = 0; (l_155 >= 19); ++l_155)
                { /* block id: 52 */
                    int32_t *l_158 = (void*)0;
                    int32_t l_160[9][3][8] = {{{(-7L),7L,0x1F8BE0D8L,0x73F720A1L,0x1F8BE0D8L,7L,(-7L),7L},{(-7L),7L,0x1F8BE0D8L,0x73F720A1L,0x1F8BE0D8L,7L,(-7L),7L},{(-7L),7L,0x1F8BE0D8L,0x73F720A1L,0x1F8BE0D8L,7L,(-7L),7L}},{{(-7L),7L,0x1F8BE0D8L,0x73F720A1L,0x1F8BE0D8L,7L,(-7L),7L},{(-7L),7L,0x1F8BE0D8L,0x73F720A1L,0x1F8BE0D8L,7L,(-7L),7L},{(-7L),7L,0x1F8BE0D8L,0x73F720A1L,0x1F8BE0D8L,7L,(-7L),7L}},{{(-7L),7L,0x1F8BE0D8L,0x73F720A1L,0x1F8BE0D8L,7L,(-7L),7L},{(-7L),7L,0x1F8BE0D8L,0x73F720A1L,0x1F8BE0D8L,7L,(-7L),7L},{(-7L),7L,0x1F8BE0D8L,0x73F720A1L,0x1F8BE0D8L,7L,(-7L),7L}},{{(-7L),7L,0x1F8BE0D8L,0x73F720A1L,0x1F8BE0D8L,7L,(-7L),7L},{(-7L),7L,0x1F8BE0D8L,0x73F720A1L,0x1F8BE0D8L,7L,(-7L),7L},{(-7L),7L,0x1F8BE0D8L,0x73F720A1L,0x1F8BE0D8L,7L,(-7L),7L}},{{(-7L),7L,0x1F8BE0D8L,0x73F720A1L,0x1F8BE0D8L,7L,(-7L),7L},{(-7L),7L,0x1F8BE0D8L,0x73F720A1L,0x1F8BE0D8L,7L,(-7L),7L},{(-7L),7L,0x1F8BE0D8L,0x73F720A1L,0x1F8BE0D8L,7L,(-7L),7L}},{{(-7L),7L,0x1F8BE0D8L,0x73F720A1L,0x1F8BE0D8L,7L,(-7L),7L},{(-7L),7L,0x1F8BE0D8L,0x73F720A1L,0x1F8BE0D8L,7L,(-7L),7L},{(-7L),7L,0x1F8BE0D8L,0x73F720A1L,0x1F8BE0D8L,7L,(-7L),7L}},{{(-7L),7L,0x1F8BE0D8L,0x73F720A1L,0x1F8BE0D8L,7L,(-7L),7L},{(-7L),7L,0x1F8BE0D8L,0x73F720A1L,0x1F8BE0D8L,7L,(-7L),7L},{(-7L),7L,0x1F8BE0D8L,0x73F720A1L,0x1F8BE0D8L,7L,(-7L),7L}},{{(-7L),7L,0x1F8BE0D8L,0x73F720A1L,0x1F8BE0D8L,7L,(-7L),7L},{(-7L),7L,0x1F8BE0D8L,0x73F720A1L,0x1F8BE0D8L,7L,(-7L),7L},{(-7L),7L,0x1F8BE0D8L,0x73F720A1L,0x1F8BE0D8L,7L,(-7L),7L}},{{(-7L),7L,0x1F8BE0D8L,0x73F720A1L,0x1F8BE0D8L,7L,(-7L),7L},{(-7L),7L,0x1F8BE0D8L,0x73F720A1L,0x1F8BE0D8L,7L,(-7L),7L},{(-7L),7L,0x1F8BE0D8L,0x73F720A1L,0x1F8BE0D8L,7L,(-7L),7L}}};
                    int32_t *l_159 = &l_160[1][1][0];
                    int32_t *l_161 = &l_160[1][1][0];
                    int i, j, k;
                    l_159 = l_158;
                    l_161 = (l_158 = (void*)0);
                }
                l_162 = (void*)0;
                l_164.s1 = (l_163 = (-6L));
            }
            else
            { /* block id: 60 */
                int32_t l_165 = 0L;
                int16_t l_265[6][3][1] = {{{(-5L)},{(-5L)},{(-5L)}},{{(-5L)},{(-5L)},{(-5L)}},{{(-5L)},{(-5L)},{(-5L)}},{{(-5L)},{(-5L)},{(-5L)}},{{(-5L)},{(-5L)},{(-5L)}},{{(-5L)},{(-5L)},{(-5L)}}};
                int32_t l_266 = 0L;
                uint64_t l_267 = 2UL;
                int i, j, k;
                if (l_165)
                { /* block id: 61 */
                    int32_t l_166 = 1L;
                    int64_t l_167 = 0x008D468FBE2ECC4FL;
                    VECTOR(int16_t, 8) l_168 = (VECTOR(int16_t, 8))((-5L), (VECTOR(int16_t, 4))((-5L), (VECTOR(int16_t, 2))((-5L), 0x3B9BL), 0x3B9BL), 0x3B9BL, (-5L), 0x3B9BL);
                    VECTOR(int16_t, 2) l_169 = (VECTOR(int16_t, 2))(0x5023L, (-7L));
                    uint32_t l_170 = 0xF9E0A5FCL;
                    uint32_t l_171 = 0UL;
                    VECTOR(int16_t, 8) l_172 = (VECTOR(int16_t, 8))(0x626AL, (VECTOR(int16_t, 4))(0x626AL, (VECTOR(int16_t, 2))(0x626AL, 0x363CL), 0x363CL), 0x363CL, 0x626AL, 0x363CL);
                    int32_t l_173 = (-10L);
                    int64_t l_174 = 0x139D7BC268F25B8AL;
                    uint64_t l_175[7] = {0x3F10C4547A68E1F3L,0x3F10C4547A68E1F3L,0x3F10C4547A68E1F3L,0x3F10C4547A68E1F3L,0x3F10C4547A68E1F3L,0x3F10C4547A68E1F3L,0x3F10C4547A68E1F3L};
                    VECTOR(int16_t, 4) l_176 = (VECTOR(int16_t, 4))(0x6177L, (VECTOR(int16_t, 2))(0x6177L, 0x78F8L), 0x78F8L);
                    VECTOR(int16_t, 8) l_177 = (VECTOR(int16_t, 8))(0x0DA2L, (VECTOR(int16_t, 4))(0x0DA2L, (VECTOR(int16_t, 2))(0x0DA2L, 0x3384L), 0x3384L), 0x3384L, 0x0DA2L, 0x3384L);
                    VECTOR(int16_t, 8) l_178 = (VECTOR(int16_t, 8))(1L, (VECTOR(int16_t, 4))(1L, (VECTOR(int16_t, 2))(1L, 0L), 0L), 0L, 1L, 0L);
                    uint8_t l_179 = 0xDDL;
                    int32_t l_180 = 0L;
                    int32_t l_181[5][6][1] = {{{0x59D5B589L},{0x59D5B589L},{0x59D5B589L},{0x59D5B589L},{0x59D5B589L},{0x59D5B589L}},{{0x59D5B589L},{0x59D5B589L},{0x59D5B589L},{0x59D5B589L},{0x59D5B589L},{0x59D5B589L}},{{0x59D5B589L},{0x59D5B589L},{0x59D5B589L},{0x59D5B589L},{0x59D5B589L},{0x59D5B589L}},{{0x59D5B589L},{0x59D5B589L},{0x59D5B589L},{0x59D5B589L},{0x59D5B589L},{0x59D5B589L}},{{0x59D5B589L},{0x59D5B589L},{0x59D5B589L},{0x59D5B589L},{0x59D5B589L},{0x59D5B589L}}};
                    uint16_t l_182 = 0x8901L;
                    uint16_t l_183 = 1UL;
                    uint64_t l_215 = 1UL;
                    union U0 l_216[7] = {{0UL},{0UL},{0UL},{0UL},{0UL},{0UL},{0UL}};
                    int16_t l_217 = 0x3A66L;
                    int32_t *l_218 = &l_173;
                    int32_t *l_219 = &l_166;
                    int i, j, k;
                    if ((l_173 = ((VECTOR(int32_t, 2))((((VECTOR(int32_t, 2))((((VECTOR(int32_t, 8))((((VECTOR(int32_t, 8))(0x33B8ED1EL, ((VECTOR(int32_t, 2))(0x5DE65A91L, (-1L))), ((VECTOR(int32_t, 2))(upsample(((VECTOR(int16_t, 2))(rhadd(((VECTOR(int16_t, 8))(min(((VECTOR(int16_t, 16))(safe_mad_hi_func_int16_t_s_s_s(VECTOR(int16_t, 16),((VECTOR(int16_t, 4))((((VECTOR(int16_t, 4))(l_166, l_167, 0x1780L, 0x33C0L)) || ((VECTOR(int16_t, 2))(safe_mad_hi_func_int16_t_s_s_s(VECTOR(int16_t, 2),((VECTOR(int16_t, 4))((((VECTOR(int16_t, 4))((((VECTOR(int16_t, 4))(l_168.s7215)) && ((VECTOR(int16_t, 2))(l_169.xy)).yxyx))) > ((VECTOR(int16_t, 4))((((VECTOR(int16_t, 2))((((VECTOR(int16_t, 16))((l_171 &= l_170), (-7L), ((VECTOR(int16_t, 2))(l_172.s26)), l_173, 0x5889L, (l_175[5] = l_174), 0x6A42L, ((VECTOR(int16_t, 4))(1L, 2L, (-1L), 0x1774L)), ((VECTOR(int16_t, 8))((((VECTOR(int16_t, 4))(l_176.yzzx)).zzyzyyxw && ((VECTOR(int16_t, 16))(((VECTOR(int16_t, 4))(0x614CL, ((VECTOR(int16_t, 2))((-4L), (-1L))), 0x787EL)), 0x5513L, 5L, (-1L), 0x00C9L, ((VECTOR(int16_t, 8))(l_177.s13540660)))).hi))).s7, ((VECTOR(int16_t, 2))(l_178.s42)), 0L)).s2e && ((VECTOR(int16_t, 2))((((VECTOR(int16_t, 8))(0x28FAL, 9L, (l_182 |= (l_181[3][3][0] &= (l_180 = ((l_179 = 0UL) , 7L)))), ((VECTOR(int16_t, 2))(0x2569L)), l_183, 0L, 0x190AL)).s60 && ((VECTOR(int16_t, 2))((-9L))))))))).xxyy ^ ((VECTOR(int16_t, 4))(0L)))))))).even, ((VECTOR(int16_t, 2))(0x0E44L)), ((VECTOR(int16_t, 2))(0x6AC8L))))).yxxx))).ywxxwzwwxzwyxxxz, ((VECTOR(int16_t, 16))(0x56E3L)), ((VECTOR(int16_t, 16))(1L))))).even, (int16_t)0x15A4L))).s17, ((VECTOR(int16_t, 2))(0x3368L))))), ((VECTOR(uint16_t, 2))(4UL))))), ((VECTOR(int32_t, 2))(0x0E576FCFL)), 0x1A4B138EL)) && ((VECTOR(int32_t, 8))(3L))))).s72 && ((VECTOR(int32_t, 2))(0x08BB56DCL))))) || ((VECTOR(int32_t, 2))(1L))))).hi))
                    { /* block id: 69 */
                        VECTOR(int32_t, 8) l_184 = (VECTOR(int32_t, 8))(0x645D199DL, (VECTOR(int32_t, 4))(0x645D199DL, (VECTOR(int32_t, 2))(0x645D199DL, 1L), 1L), 1L, 0x645D199DL, 1L);
                        int32_t l_185 = (-7L);
                        VECTOR(int32_t, 16) l_186 = (VECTOR(int32_t, 16))(0x1030FC9DL, (VECTOR(int32_t, 4))(0x1030FC9DL, (VECTOR(int32_t, 2))(0x1030FC9DL, 0L), 0L), 0L, 0x1030FC9DL, 0L, (VECTOR(int32_t, 2))(0x1030FC9DL, 0L), (VECTOR(int32_t, 2))(0x1030FC9DL, 0L), 0x1030FC9DL, 0L, 0x1030FC9DL, 0L);
                        int32_t l_187 = 0x6C49478BL;
                        VECTOR(int32_t, 16) l_188 = (VECTOR(int32_t, 16))(0x0867B80CL, (VECTOR(int32_t, 4))(0x0867B80CL, (VECTOR(int32_t, 2))(0x0867B80CL, 0x2A19D67CL), 0x2A19D67CL), 0x2A19D67CL, 0x0867B80CL, 0x2A19D67CL, (VECTOR(int32_t, 2))(0x0867B80CL, 0x2A19D67CL), (VECTOR(int32_t, 2))(0x0867B80CL, 0x2A19D67CL), 0x0867B80CL, 0x2A19D67CL, 0x0867B80CL, 0x2A19D67CL);
                        int64_t l_189 = 3L;
                        VECTOR(int32_t, 16) l_190 = (VECTOR(int32_t, 16))(1L, (VECTOR(int32_t, 4))(1L, (VECTOR(int32_t, 2))(1L, 0L), 0L), 0L, 1L, 0L, (VECTOR(int32_t, 2))(1L, 0L), (VECTOR(int32_t, 2))(1L, 0L), 1L, 0L, 1L, 0L);
                        VECTOR(int32_t, 2) l_191 = (VECTOR(int32_t, 2))(0L, 0x231ABC1FL);
                        int32_t l_192 = 0x3081A098L;
                        int8_t l_193 = (-5L);
                        VECTOR(int32_t, 8) l_194 = (VECTOR(int32_t, 8))(1L, (VECTOR(int32_t, 4))(1L, (VECTOR(int32_t, 2))(1L, 0x216B0A57L), 0x216B0A57L), 0x216B0A57L, 1L, 0x216B0A57L);
                        uint16_t l_195 = 65526UL;
                        VECTOR(int32_t, 4) l_196 = (VECTOR(int32_t, 4))(0L, (VECTOR(int32_t, 2))(0L, 0x61535540L), 0x61535540L);
                        uint8_t l_197 = 4UL;
                        int32_t l_198 = (-9L);
                        uint32_t l_199 = 0x5B1CF151L;
                        int8_t l_200 = (-1L);
                        uint32_t l_201 = 4294967287UL;
                        int64_t l_202 = 0x7D13A130829EF2F3L;
                        uint8_t l_203 = 0x69L;
                        int i;
                        l_173 ^= ((VECTOR(int32_t, 2))(mul_hi(((VECTOR(int32_t, 4))((((VECTOR(int32_t, 4))(((VECTOR(int32_t, 2))(0x2BBB11FCL, (-6L))), (-1L), 0x7BD2D9BEL)) & ((VECTOR(int32_t, 4))((((VECTOR(int32_t, 2))((!((VECTOR(int32_t, 4))(min(((VECTOR(int32_t, 16))(l_184.s4322737774421313)).s637e, (int32_t)l_185))).odd))).yyyx && ((VECTOR(int32_t, 4))(l_186.sa9e6)))))))).even, ((VECTOR(int32_t, 8))((((VECTOR(int32_t, 4))((((VECTOR(int32_t, 2))((((VECTOR(int32_t, 4))(0x450761EDL, l_187, 0x629B9E97L, 0x525321BDL)).odd && ((VECTOR(int32_t, 16))(0x5BCB941CL, (((VECTOR(int32_t, 16))(max(((VECTOR(int32_t, 8))(0L, 6L, ((VECTOR(int32_t, 4))(l_188.s5e2b)), 8L, 0x1F1B08C5L)).s1622546706163307, ((VECTOR(int32_t, 16))(l_189, ((VECTOR(int32_t, 8))(hadd(((VECTOR(int32_t, 8))(add_sat(((VECTOR(int32_t, 2))(min(((VECTOR(int32_t, 8))(l_190.se8ab1b66)).s34, ((VECTOR(int32_t, 4))(l_191.xxxy)).even))).xxyxxxyx, ((VECTOR(int32_t, 16))((((VECTOR(int32_t, 2))(2L, 0L)).yxyxxyxxxxxyxxxy && ((VECTOR(int32_t, 16))(l_192, 9L, 0x2DB29B32L, 3L, l_193, ((VECTOR(int32_t, 4))(l_194.s5731)), 0x28A99E67L, 0x1F1FA6DFL, l_195, 6L, 1L, 1L, (-6L)))))).hi))), ((VECTOR(int32_t, 2))(0x32A55D4DL, 9L)).xyxyyyxx))), ((VECTOR(int32_t, 16))(l_196.wxywyzywxzzwyyyw)).s6, 0x7DFD5089L, l_197, l_198, ((VECTOR(int32_t, 2))(7L)), 0x0917B79CL))))).se , l_199), l_200, l_201, l_202, 0L, (-2L), l_203, (-1L), ((VECTOR(int32_t, 2))(8L)), ((VECTOR(int32_t, 4))(0L)), 0x73C657A0L)).s9a))).xxxy ^ ((VECTOR(int32_t, 4))(0x1B31E70AL))))).wxyxzyzz > ((VECTOR(int32_t, 8))(0x4C524864L))))).s06))).hi;
                    }
                    else
                    { /* block id: 71 */
                        int32_t *l_204 = (void*)0;
                        int32_t *l_205 = (void*)0;
                        int8_t l_206 = 1L;
                        int64_t l_207 = 0x24EB4185503AD83EL;
                        int8_t l_208 = 0x48L;
                        VECTOR(int32_t, 4) l_209 = (VECTOR(int32_t, 4))((-4L), (VECTOR(int32_t, 2))((-4L), 1L), 1L);
                        int32_t *l_210 = (void*)0;
                        VECTOR(uint8_t, 16) l_211 = (VECTOR(uint8_t, 16))(0x64L, (VECTOR(uint8_t, 4))(0x64L, (VECTOR(uint8_t, 2))(0x64L, 3UL), 3UL), 3UL, 0x64L, 3UL, (VECTOR(uint8_t, 2))(0x64L, 3UL), (VECTOR(uint8_t, 2))(0x64L, 3UL), 0x64L, 3UL, 0x64L, 3UL);
                        int32_t *l_212 = (void*)0;
                        int32_t *l_213 = (void*)0;
                        int32_t *l_214 = (void*)0;
                        int i;
                        l_205 = (l_204 = l_204);
                        l_166 = ((VECTOR(int32_t, 16))(0x53DBD2A6L, l_206, 0L, (l_181[3][1][0] |= l_207), l_208, 9L, 0L, 7L, (-2L), 0x77FA71A2L, ((VECTOR(int32_t, 2))(l_209.ww)), (-1L), (-3L), 0L, (-7L))).s5;
                        l_210 = (void*)0;
                        l_214 = (((VECTOR(uint8_t, 16))(l_211.s6293fc5627abc631)).s2 , (l_213 = l_212));
                    }
                    l_165 = l_215;
                    l_181[1][0][0] = (l_165 ^= (l_216[6] , l_217));
                    l_219 = (l_218 = (void*)0);
                }
                else
                { /* block id: 85 */
                    int32_t l_220 = 0x6886E2DFL;
                    VECTOR(int32_t, 16) l_225 = (VECTOR(int32_t, 16))((-9L), (VECTOR(int32_t, 4))((-9L), (VECTOR(int32_t, 2))((-9L), 0x247ABD0CL), 0x247ABD0CL), 0x247ABD0CL, (-9L), 0x247ABD0CL, (VECTOR(int32_t, 2))((-9L), 0x247ABD0CL), (VECTOR(int32_t, 2))((-9L), 0x247ABD0CL), (-9L), 0x247ABD0CL, (-9L), 0x247ABD0CL);
                    VECTOR(int32_t, 4) l_226 = (VECTOR(int32_t, 4))(0L, (VECTOR(int32_t, 2))(0L, 0x3B268BF3L), 0x3B268BF3L);
                    VECTOR(int32_t, 4) l_227 = (VECTOR(int32_t, 4))((-1L), (VECTOR(int32_t, 2))((-1L), 0L), 0L);
                    VECTOR(int32_t, 16) l_228 = (VECTOR(int32_t, 16))((-1L), (VECTOR(int32_t, 4))((-1L), (VECTOR(int32_t, 2))((-1L), 0x334CF7A4L), 0x334CF7A4L), 0x334CF7A4L, (-1L), 0x334CF7A4L, (VECTOR(int32_t, 2))((-1L), 0x334CF7A4L), (VECTOR(int32_t, 2))((-1L), 0x334CF7A4L), (-1L), 0x334CF7A4L, (-1L), 0x334CF7A4L);
                    VECTOR(int8_t, 2) l_229 = (VECTOR(int8_t, 2))(1L, (-1L));
                    VECTOR(uint8_t, 2) l_232 = (VECTOR(uint8_t, 2))(0x90L, 247UL);
                    VECTOR(uint8_t, 4) l_233 = (VECTOR(uint8_t, 4))(0x24L, (VECTOR(uint8_t, 2))(0x24L, 0xC8L), 0xC8L);
                    VECTOR(uint16_t, 2) l_236 = (VECTOR(uint16_t, 2))(4UL, 0x2C58L);
                    int32_t l_237 = 1L;
                    uint16_t l_238 = 0x3706L;
                    uint8_t l_241 = 255UL;
                    int32_t l_242 = 0x60DF409EL;
                    VECTOR(int32_t, 16) l_243 = (VECTOR(int32_t, 16))(0x7C74D141L, (VECTOR(int32_t, 4))(0x7C74D141L, (VECTOR(int32_t, 2))(0x7C74D141L, 0x52BC9011L), 0x52BC9011L), 0x52BC9011L, 0x7C74D141L, 0x52BC9011L, (VECTOR(int32_t, 2))(0x7C74D141L, 0x52BC9011L), (VECTOR(int32_t, 2))(0x7C74D141L, 0x52BC9011L), 0x7C74D141L, 0x52BC9011L, 0x7C74D141L, 0x52BC9011L);
                    VECTOR(int32_t, 4) l_244 = (VECTOR(int32_t, 4))((-7L), (VECTOR(int32_t, 2))((-7L), 0x42BF8CB4L), 0x42BF8CB4L);
                    VECTOR(int32_t, 16) l_245 = (VECTOR(int32_t, 16))(0x15AFFE87L, (VECTOR(int32_t, 4))(0x15AFFE87L, (VECTOR(int32_t, 2))(0x15AFFE87L, 3L), 3L), 3L, 0x15AFFE87L, 3L, (VECTOR(int32_t, 2))(0x15AFFE87L, 3L), (VECTOR(int32_t, 2))(0x15AFFE87L, 3L), 0x15AFFE87L, 3L, 0x15AFFE87L, 3L);
                    VECTOR(int32_t, 8) l_246 = (VECTOR(int32_t, 8))(0x24B31A8EL, (VECTOR(int32_t, 4))(0x24B31A8EL, (VECTOR(int32_t, 2))(0x24B31A8EL, (-7L)), (-7L)), (-7L), 0x24B31A8EL, (-7L));
                    VECTOR(int32_t, 8) l_247 = (VECTOR(int32_t, 8))(0x73846020L, (VECTOR(int32_t, 4))(0x73846020L, (VECTOR(int32_t, 2))(0x73846020L, 0x66595363L), 0x66595363L), 0x66595363L, 0x73846020L, 0x66595363L);
                    VECTOR(int32_t, 2) l_248 = (VECTOR(int32_t, 2))(0x1174D2FEL, 1L);
                    VECTOR(int16_t, 2) l_249 = (VECTOR(int16_t, 2))((-2L), 5L);
                    uint8_t l_250 = 1UL;
                    int32_t l_251[5] = {2L,2L,2L,2L,2L};
                    VECTOR(int32_t, 8) l_252 = (VECTOR(int32_t, 8))(0x40F2A8A3L, (VECTOR(int32_t, 4))(0x40F2A8A3L, (VECTOR(int32_t, 2))(0x40F2A8A3L, (-8L)), (-8L)), (-8L), 0x40F2A8A3L, (-8L));
                    uint32_t l_253 = 0x61B3A266L;
                    uint32_t l_254[6][5] = {{0x5187F818L,0x5187F818L,0x5187F818L,0x5187F818L,0x5187F818L},{0x5187F818L,0x5187F818L,0x5187F818L,0x5187F818L,0x5187F818L},{0x5187F818L,0x5187F818L,0x5187F818L,0x5187F818L,0x5187F818L},{0x5187F818L,0x5187F818L,0x5187F818L,0x5187F818L,0x5187F818L},{0x5187F818L,0x5187F818L,0x5187F818L,0x5187F818L,0x5187F818L},{0x5187F818L,0x5187F818L,0x5187F818L,0x5187F818L,0x5187F818L}};
                    int i, j;
                    for (l_220 = 0; (l_220 >= (-2)); l_220 = safe_sub_func_int16_t_s_s(l_220, 4))
                    { /* block id: 88 */
                        uint8_t l_223 = 1UL;
                        uint64_t l_224 = 0x0921904DDF840340L;
                        l_165 ^= l_223;
                        l_165 |= l_224;
                    }
                    if (((VECTOR(int32_t, 2))((((VECTOR(int32_t, 16))(l_225.s9975902a8f9cb822)).s73 && ((VECTOR(int32_t, 4))(add_sat(((VECTOR(int32_t, 8))((((VECTOR(int32_t, 4))(safe_clamp_func(VECTOR(int32_t, 4),int32_t,((VECTOR(int32_t, 16))(((VECTOR(int32_t, 2))(l_226.wy)), ((VECTOR(int32_t, 2))((((VECTOR(int32_t, 4))(l_227.wwxz)).even && ((VECTOR(int32_t, 16))(l_228.sb4d117c2a5b5b071)).s35))), ((VECTOR(int32_t, 8))(hadd(((VECTOR(int32_t, 8))(upsample(((VECTOR(int16_t, 2))(upsample(((VECTOR(int8_t, 8))(l_229.yyxyyyxx)).s65, ((VECTOR(uint8_t, 8))((((VECTOR(uint8_t, 4))(l_232.xxyy)).wwyzzywz + ((VECTOR(uint8_t, 16))(l_233.zyxyxzzwwxxyzwxz)).even))).s65))).yxxxxxyx, ((VECTOR(uint16_t, 8))((((VECTOR(uint16_t, 16))(max(((VECTOR(uint16_t, 2))(safe_clamp_func(VECTOR(uint16_t, 2),uint16_t,((VECTOR(uint16_t, 4))(l_236.xxyy)).hi, (uint16_t)((--l_238) , l_241), (uint16_t)FAKE_DIVERGE(p_670->group_1_offset, get_group_id(1), 10)))).xyxxyyxyyxyyxxyx, (uint16_t)l_242))).hi - ((VECTOR(uint16_t, 2))(1UL, 0UL)).xxyyyxxx)))))), ((VECTOR(int32_t, 2))(mad_sat(((VECTOR(int32_t, 2))(l_243.sc2)), ((VECTOR(int32_t, 4))((((VECTOR(int32_t, 4))(min(((VECTOR(int32_t, 8))(safe_clamp_func(VECTOR(int32_t, 8),VECTOR(int32_t, 8),((VECTOR(int32_t, 4))(l_244.wwyz)).xwywwxzy, ((VECTOR(int32_t, 16))(l_245.s46a55db8d7a7fa21)).lo, ((VECTOR(int32_t, 16))(l_246.s4312070565420012)).even))).lo, (int32_t)7L))) && ((VECTOR(int32_t, 16))((((VECTOR(int32_t, 8))((((VECTOR(int32_t, 2))((-1L), 0x73E1BCF0L)).yyxxxxxx && ((VECTOR(int32_t, 2))(0L, 0x08E8DD6AL)).xxyyxyxy))).s0025273123466465 >= ((VECTOR(int32_t, 8))(l_247.s71557463)).s3575600730620343))).s5079))).even, ((VECTOR(int32_t, 2))(l_248.xx))))).xyyyyxyx))).s3, 0x18A9741AL, 0x748553BBL, 0x3D254469L, (((VECTOR(int16_t, 4))(l_249.yyyx)).z , l_250), l_251[0], 6L, ((VECTOR(int32_t, 2))(l_252.s22)), l_253, 1L, 3L)).s9633, (int32_t)((l_254[2][0] = 0x0A68BF895B2C4312L) , 9L), (int32_t)0x72F0760AL))).xwzxzywy > ((VECTOR(int32_t, 8))(0x0549FEF6L))))).odd, ((VECTOR(int32_t, 4))((-8L)))))).lo))).odd)
                    { /* block id: 94 */
                        int32_t l_257[6][3];
                        uint16_t l_258 = 9UL;
                        int i, j;
                        for (i = 0; i < 6; i++)
                        {
                            for (j = 0; j < 3; j++)
                                l_257[i][j] = 0L;
                        }
                        l_225.s3 &= ((--l_236.x) , ((l_257[5][1] , l_258) , ((VECTOR(int32_t, 2))(0x1BC3DCDBL, 0x35D0FB07L)).odd));
                    }
                    else
                    { /* block id: 97 */
                        uint64_t l_259 = 0x480D821A32C9F228L;
                        int8_t l_262 = 0x35L;
                        int32_t l_263 = 0x3495495FL;
                        int16_t l_264 = 4L;
                        ++l_259;
                        l_263 = l_262;
                        l_252.s7 &= l_264;
                    }
                }
                l_267--;
            }
            unsigned int result = 0;
            result += l_154;
            atomic_add(&p_670->g_special_values[4 * get_linear_group_id() + 2], result);
        }
        else
        { /* block id: 105 */
            (1 + 1);
        }
        for (l_125 = (-16); (l_125 != 30); l_125 = safe_add_func_int32_t_s_s(l_125, 8))
        { /* block id: 110 */
            uint32_t l_280[4][8] = {{0UL,0UL,0UL,0UL,0UL,0UL,0UL,0UL},{0UL,0UL,0UL,0UL,0UL,0UL,0UL,0UL},{0UL,0UL,0UL,0UL,0UL,0UL,0UL,0UL},{0UL,0UL,0UL,0UL,0UL,0UL,0UL,0UL}};
            uint32_t *l_281 = (void*)0;
            uint32_t *l_282[7] = {&l_125,&l_125,&l_125,&l_125,&l_125,&l_125,&l_125};
            int32_t l_283 = (-9L);
            uint8_t *l_301 = &p_670->g_91.f0;
            int32_t l_302 = 0x15FE38ECL;
            int32_t l_314 = 1L;
            int32_t l_315 = (-1L);
            int32_t l_317[2];
            int i, j;
            for (i = 0; i < 2; i++)
                l_317[i] = 1L;
            (*l_137) &= (l_302 = (((safe_add_func_uint8_t_u_u(0x97L, ((*p_670->g_36) = ((safe_rshift_func_uint8_t_u_u((safe_mul_func_uint8_t_u_u(((safe_sub_func_uint32_t_u_u((l_283 = l_280[1][6]), ((safe_lshift_func_uint16_t_u_s((0x12E71CDCL ^ ((safe_add_func_uint8_t_u_u(((VECTOR(uint8_t, 8))(((VECTOR(uint8_t, 2))(safe_clamp_func(VECTOR(uint8_t, 2),uint8_t,((VECTOR(uint8_t, 4))(p_670->g_288.wzyw)).even, (uint8_t)((*l_301) ^= (safe_div_func_int32_t_s_s(((((safe_div_func_int32_t_s_s(((*l_142) &= (((VECTOR(uint8_t, 16))(((0x0979L <= ((safe_div_func_uint64_t_u_u((((safe_add_func_int32_t_s_s(0x0F70EA9CL, 0x71BACA6DL)) , l_297[1]) == (void*)0), l_298)) && p_53)) , p_670->g_143), 0x51L, 1UL, p_670->g_47.y, ((VECTOR(uint8_t, 8))(0x81L)), 0UL, l_299[0], 0xFEL, 0x2EL)).sc , l_300)), p_53)) == p_53) || 0L) != 65529UL), (*p_670->g_99)))), (uint8_t)GROUP_DIVERGE(0, 1)))), p_53, p_670->g_47.w, ((VECTOR(uint8_t, 4))(255UL)))).s1, l_280[1][6])) , (-10L))), 13)) , p_670->g_22))) & (*p_670->g_36)), (*p_670->g_36))), p_670->l_comm_values[(safe_mod_func_uint32_t_u_u(p_670->tid, 1))])) ^ 4294967295UL)))) && p_53) ^ l_280[1][6]));
            if ((*l_142))
            { /* block id: 117 */
                uint16_t *l_305[8][9] = {{&p_670->g_83,&p_670->g_83,(void*)0,&p_670->g_83,&p_670->g_83,&p_670->g_83,(void*)0,&p_670->g_83,&p_670->g_83},{&p_670->g_83,&p_670->g_83,(void*)0,&p_670->g_83,&p_670->g_83,&p_670->g_83,(void*)0,&p_670->g_83,&p_670->g_83},{&p_670->g_83,&p_670->g_83,(void*)0,&p_670->g_83,&p_670->g_83,&p_670->g_83,(void*)0,&p_670->g_83,&p_670->g_83},{&p_670->g_83,&p_670->g_83,(void*)0,&p_670->g_83,&p_670->g_83,&p_670->g_83,(void*)0,&p_670->g_83,&p_670->g_83},{&p_670->g_83,&p_670->g_83,(void*)0,&p_670->g_83,&p_670->g_83,&p_670->g_83,(void*)0,&p_670->g_83,&p_670->g_83},{&p_670->g_83,&p_670->g_83,(void*)0,&p_670->g_83,&p_670->g_83,&p_670->g_83,(void*)0,&p_670->g_83,&p_670->g_83},{&p_670->g_83,&p_670->g_83,(void*)0,&p_670->g_83,&p_670->g_83,&p_670->g_83,(void*)0,&p_670->g_83,&p_670->g_83},{&p_670->g_83,&p_670->g_83,(void*)0,&p_670->g_83,&p_670->g_83,&p_670->g_83,(void*)0,&p_670->g_83,&p_670->g_83}};
                int32_t l_308 = 0x584603DDL;
                int32_t l_309 = (-5L);
                int32_t l_310 = 0x4F1E0671L;
                int32_t l_311 = 0x04499DD3L;
                int32_t l_312 = 1L;
                int32_t l_313 = 0x5D2E531EL;
                int32_t l_316 = 0x48190C90L;
                int32_t l_319 = 0x01228ECAL;
                int i, j;
                (*l_140) = (p_54 ^ (safe_rshift_func_uint16_t_u_s((p_670->g_83--), 10)));
                l_320--;
                (*l_137) ^= (safe_mul_func_int16_t_s_s((safe_div_func_uint8_t_u_u(p_53, l_319)), (safe_unary_minus_func_uint8_t_u((+l_280[1][4])))));
                (*l_140) = (!(safe_rshift_func_int16_t_s_s((l_302 = 0x60FBL), 14)));
            }
            else
            { /* block id: 124 */
                for (p_670->g_83 = (-24); (p_670->g_83 != 8); p_670->g_83 = safe_add_func_uint16_t_u_u(p_670->g_83, 1))
                { /* block id: 127 */
                    return &p_670->g_36;
                }
                if ((atomic_inc(&p_670->g_atomic_input[4 * get_linear_group_id() + 3]) == 0))
                { /* block id: 131 */
                    uint64_t l_332 = 0x8C55F51B6DE635F2L;
                    int32_t l_333 = 0x09EAF65BL;
                    int32_t l_335 = (-7L);
                    int32_t *l_334 = &l_335;
                    int32_t *l_336 = &l_335;
                    uint32_t l_337 = 0xC45A12C6L;
                    uint16_t l_338[4] = {0x1158L,0x1158L,0x1158L,0x1158L};
                    int16_t l_339 = 0L;
                    uint64_t l_340 = 9UL;
                    int i;
                    l_336 = (((VECTOR(uint8_t, 8))(3UL, 255UL, (l_332 , l_333), FAKE_DIVERGE(p_670->group_1_offset, get_group_id(1), 10), ((VECTOR(uint8_t, 2))(0x19L, 0xD8L)), 1UL, 0x15L)).s5 , l_334);
                    l_338[3] = l_337;
                    l_340 ^= l_339;
                    unsigned int result = 0;
                    result += l_332;
                    result += l_333;
                    result += l_335;
                    result += l_337;
                    int l_338_i0;
                    for (l_338_i0 = 0; l_338_i0 < 4; l_338_i0++)
                        result += l_338[l_338_i0];
                    result += l_339;
                    result += l_340;
                    atomic_add(&p_670->g_special_values[4 * get_linear_group_id() + 3], result);
                }
                else
                { /* block id: 135 */
                    (1 + 1);
                }
                (*l_151) = func_57((safe_mod_func_uint64_t_u_u(((safe_lshift_func_uint8_t_u_u((safe_rshift_func_int16_t_s_u((safe_mul_func_uint8_t_u_u((p_54 == ((safe_sub_func_uint64_t_u_u((p_53 | (0xADL == (safe_add_func_int8_t_s_s(((void*)0 == &p_670->g_108), ((((!(p_670->g_288.x > ((((1L >= 0x38DB97C4L) & (safe_sub_func_uint16_t_u_u(0xD600L, p_53))) ^ (-10L)) , 0xCA536F2928B95906L))) < p_670->g_143) > p_670->g_37) , p_54))))), p_54)) <= p_670->g_comm_values[p_670->tid])), (*p_670->g_36))), p_670->g_37)), 7)) <= p_53), 0xD69E62C4057CCA2CL)), &l_297[1], p_670);
            }
            (*l_137) |= ((l_357[5][1] == (((2L && (((safe_mod_func_uint8_t_u_u((p_53 |= ((*l_301) = l_302)), p_54)) > (p_54 > (5UL || (safe_add_func_uint64_t_u_u(GROUP_DIVERGE(1, 1), (p_54 & ((p_670->g_83 <= (p_54 == l_280[1][6])) , l_362))))))) > p_670->g_comm_values[p_670->tid])) >= p_54) , (void*)0)) < (**l_151));
        }
        for (l_300 = 0; (l_300 < 5); l_300 = safe_add_func_uint16_t_u_u(l_300, 8))
        { /* block id: 146 */
            int32_t ****l_371 = &p_670->g_369;
            union U0 **l_372 = (void*)0;
            union U0 ***l_373[6][5] = {{&l_372,&l_372,(void*)0,(void*)0,&l_372},{&l_372,&l_372,(void*)0,(void*)0,&l_372},{&l_372,&l_372,(void*)0,(void*)0,&l_372},{&l_372,&l_372,(void*)0,(void*)0,&l_372},{&l_372,&l_372,(void*)0,(void*)0,&l_372},{&l_372,&l_372,(void*)0,(void*)0,&l_372}};
            uint32_t l_381 = 0UL;
            int32_t l_382 = (-8L);
            int32_t l_383 = (-2L);
            int32_t l_384 = (-9L);
            int i, j;
            (*l_380) = func_57((safe_add_func_uint32_t_u_u((safe_mul_func_uint8_t_u_u((p_53 == ((((*l_371) = p_670->g_369) == (void*)0) != (0xB3F8L & (((l_372 != (p_670->g_374[0] = &p_670->g_93[2])) | (safe_sub_func_int8_t_s_s((safe_sub_func_int8_t_s_s((*p_670->g_36), ((((VECTOR(uint32_t, 4))(p_670->g_379.yxyy)).y , p_53) > ((VECTOR(uint16_t, 8))(65535UL, ((VECTOR(uint16_t, 2))(0x096DL)), p_670->g_22, ((VECTOR(uint16_t, 2))(0x6F2DL)), 65526UL, 65535UL)).s6))), (*p_670->g_36)))) , 0x21C0L)))), GROUP_DIVERGE(0, 1))), p_670->g_143)), l_380, p_670);
            if (l_381)
                continue;
            p_670->g_385[0]++;
        }
    }
    return l_357[1][1];
}


/* ------------------------------------------ */
/* 
 * reads : p_670->g_16 p_670->g_33 p_670->g_22 p_670->l_comm_values p_670->g_comm_values p_670->g_92 p_670->g_100 p_670->g_108
 * writes: p_670->g_83 p_670->g_89 p_670->g_93 p_670->g_99 p_670->g_108
 */
int32_t  func_55(int32_t  p_56, struct S1 * p_670)
{ /* block id: 11 */
    VECTOR(uint32_t, 16) l_60 = (VECTOR(uint32_t, 16))(6UL, (VECTOR(uint32_t, 4))(6UL, (VECTOR(uint32_t, 2))(6UL, 4294967295UL), 4294967295UL), 4294967295UL, 6UL, 4294967295UL, (VECTOR(uint32_t, 2))(6UL, 4294967295UL), (VECTOR(uint32_t, 2))(6UL, 4294967295UL), 6UL, 4294967295UL, 6UL, 4294967295UL);
    int32_t l_106 = (-7L);
    int i;
    if (p_670->g_16.x)
    { /* block id: 12 */
        int32_t *l_63 = &p_670->g_28;
        int32_t **l_62 = &l_63;
        int32_t ***l_61 = &l_62;
        (*p_670->g_100) = func_57(l_60.s8, ((*l_61) = (void*)0), p_670);
    }
    else
    { /* block id: 28 */
        int16_t *l_103 = (void*)0;
        int16_t *l_104 = (void*)0;
        int32_t l_105 = 0x02F80E56L;
        int32_t *l_107[8][8] = {{&l_106,&l_105,&p_670->g_28,&l_105,&l_106,&l_106,&l_105,&p_670->g_28},{&l_106,&l_105,&p_670->g_28,&l_105,&l_106,&l_106,&l_105,&p_670->g_28},{&l_106,&l_105,&p_670->g_28,&l_105,&l_106,&l_106,&l_105,&p_670->g_28},{&l_106,&l_105,&p_670->g_28,&l_105,&l_106,&l_106,&l_105,&p_670->g_28},{&l_106,&l_105,&p_670->g_28,&l_105,&l_106,&l_106,&l_105,&p_670->g_28},{&l_106,&l_105,&p_670->g_28,&l_105,&l_106,&l_106,&l_105,&p_670->g_28},{&l_106,&l_105,&p_670->g_28,&l_105,&l_106,&l_106,&l_105,&p_670->g_28},{&l_106,&l_105,&p_670->g_28,&l_105,&l_106,&l_106,&l_105,&p_670->g_28}};
        int32_t **l_112 = &l_107[7][5];
        int i, j;
        atomic_sub(&p_670->l_atomic_reduction[0], (safe_mul_func_int16_t_s_s((l_105 = 1L), GROUP_DIVERGE(0, 1))));
        barrier(CLK_LOCAL_MEM_FENCE | CLK_GLOBAL_MEM_FENCE);
        if (get_linear_local_id() == 0)
            p_670->v_collective += p_670->l_atomic_reduction[0];
        barrier(CLK_LOCAL_MEM_FENCE | CLK_GLOBAL_MEM_FENCE);
        p_670->g_108--;
        (*l_112) = &l_105;
    }
    return l_60.sb;
}


/* ------------------------------------------ */
/* 
 * reads : p_670->g_33 p_670->g_22 p_670->l_comm_values p_670->g_comm_values p_670->g_92
 * writes: p_670->g_83 p_670->g_89 p_670->g_93
 */
int32_t * func_57(uint64_t  p_58, int32_t ** p_59, struct S1 * p_670)
{ /* block id: 14 */
    int32_t l_67 = 1L;
    uint16_t *l_82 = &p_670->g_83;
    int16_t *l_84 = (void*)0;
    int32_t l_85 = 0L;
    uint8_t *l_86 = (void*)0;
    int32_t l_87 = 0x0322C85EL;
    uint8_t *l_88 = &p_670->g_89;
    union U0 *l_90[9] = {(void*)0,(void*)0,(void*)0,(void*)0,(void*)0,(void*)0,(void*)0,(void*)0,(void*)0};
    int i;
    atomic_xor(&p_670->g_atomic_reduction[get_linear_group_id()], (safe_lshift_func_uint8_t_u_s(((*l_88) = (l_87 = ((l_85 |= (safe_unary_minus_func_uint8_t_u((((p_58 , 0x1534L) ^ (l_67 , (((safe_sub_func_uint32_t_u_u((safe_lshift_func_int16_t_s_u(((safe_sub_func_uint64_t_u_u((!((+(((*l_82) = (((safe_mul_func_uint16_t_u_u(l_67, l_67)) <= (safe_rshift_func_uint16_t_u_u((l_67 , (l_67 , p_670->g_33.x)), 11))) || ((VECTOR(uint32_t, 16))((((VECTOR(uint32_t, 2))((((VECTOR(uint32_t, 8))(abs(((VECTOR(uint32_t, 2))(3UL, 0UL)).xyxyyyyx))).s01 + ((VECTOR(uint32_t, 8))((p_58 , p_58), 4294967289UL, 4294967295UL, p_670->g_22, 4294967291UL, 0xAA3A0A77L, 4294967292UL, 4294967286UL)).s44))).xxyxyyyyxyyyyxyy + ((VECTOR(uint32_t, 16))(1UL))))).sf)) > l_67)) < p_670->l_comm_values[(safe_mod_func_uint32_t_u_u(p_670->tid, 1))])), 0x2B8ADFEA0260AD58L)) == l_67), 7)), p_670->g_comm_values[p_670->tid])) , l_67) < p_58))) || p_58)))) | 1UL))), p_58)) + get_linear_global_id());
    barrier(CLK_LOCAL_MEM_FENCE | CLK_GLOBAL_MEM_FENCE);
    if (get_linear_local_id() == 0)
        p_670->v_collective += p_670->g_atomic_reduction[get_linear_group_id()];
    barrier(CLK_LOCAL_MEM_FENCE | CLK_GLOBAL_MEM_FENCE);
    (*p_670->g_92) = l_90[3];
    for (l_67 = 0; (l_67 <= (-11)); l_67 = safe_sub_func_int16_t_s_s(l_67, 1))
    { /* block id: 23 */
        uint8_t l_96 = 0x3AL;
        int32_t l_97 = 0x77CD1832L;
        l_97 = (l_96 ^ p_670->l_comm_values[(safe_mod_func_uint32_t_u_u(p_670->tid, 1))]);
    }
    return &p_670->g_28;
}


__kernel void entry(__global ulong *result, __global volatile uint *g_atomic_input, __global volatile uint *g_special_values, __global volatile int *g_atomic_reduction, __global int *sequence_input, __global long *g_comm_values) {
    int i, j, k;
    __local volatile uint32_t l_atomic_input[4];
    if (get_linear_local_id() == 0)
        for (i = 0; i < 4; i++)
            l_atomic_input[i] = 0;
    __local volatile uint32_t l_special_values[4];
    if (get_linear_local_id() == 0)
        for (i = 0; i < 4; i++)
            l_special_values[i] = 0;
    __local volatile uint32_t l_atomic_reduction[1];
    if (get_linear_local_id() == 0)
        for (i = 0; i < 1; i++)
            l_atomic_reduction[i] = 0;
    __local int64_t l_comm_values[1];
    if (get_linear_local_id() == 0)
        for (i = 0; i < 1; i++)
            l_comm_values[i] = 1;
    struct S1 c_671;
    struct S1* p_670 = &c_671;
    struct S1 c_672 = {
        (VECTOR(int16_t, 2))(6L, 0x24B5L), // p_670->g_16
        0x48L, // p_670->g_22
        8L, // p_670->g_28
        (VECTOR(int32_t, 4))((-8L), (VECTOR(int32_t, 2))((-8L), 0x2D982FC9L), 0x2D982FC9L), // p_670->g_30
        (VECTOR(uint32_t, 2))(9UL, 4294967295UL), // p_670->g_33
        (-1L), // p_670->g_37
        &p_670->g_37, // p_670->g_36
        (VECTOR(int8_t, 4))(1L, (VECTOR(int8_t, 2))(1L, 0x35L), 0x35L), // p_670->g_47
        0x4528L, // p_670->g_83
        0x1BL, // p_670->g_89
        {0UL}, // p_670->g_91
        {&p_670->g_91,&p_670->g_91,&p_670->g_91,&p_670->g_91,&p_670->g_91,&p_670->g_91,&p_670->g_91,&p_670->g_91}, // p_670->g_93
        &p_670->g_93[4], // p_670->g_92
        &p_670->g_28, // p_670->g_99
        {&p_670->g_99,&p_670->g_99}, // p_670->g_98
        &p_670->g_99, // p_670->g_100
        0x43L, // p_670->g_108
        {{{&p_670->g_99,&p_670->g_99,&p_670->g_99,&p_670->g_99,&p_670->g_99,&p_670->g_99,&p_670->g_99,&p_670->g_99},{&p_670->g_99,&p_670->g_99,&p_670->g_99,&p_670->g_99,&p_670->g_99,&p_670->g_99,&p_670->g_99,&p_670->g_99},{&p_670->g_99,&p_670->g_99,&p_670->g_99,&p_670->g_99,&p_670->g_99,&p_670->g_99,&p_670->g_99,&p_670->g_99},{&p_670->g_99,&p_670->g_99,&p_670->g_99,&p_670->g_99,&p_670->g_99,&p_670->g_99,&p_670->g_99,&p_670->g_99},{&p_670->g_99,&p_670->g_99,&p_670->g_99,&p_670->g_99,&p_670->g_99,&p_670->g_99,&p_670->g_99,&p_670->g_99},{&p_670->g_99,&p_670->g_99,&p_670->g_99,&p_670->g_99,&p_670->g_99,&p_670->g_99,&p_670->g_99,&p_670->g_99},{&p_670->g_99,&p_670->g_99,&p_670->g_99,&p_670->g_99,&p_670->g_99,&p_670->g_99,&p_670->g_99,&p_670->g_99}},{{&p_670->g_99,&p_670->g_99,&p_670->g_99,&p_670->g_99,&p_670->g_99,&p_670->g_99,&p_670->g_99,&p_670->g_99},{&p_670->g_99,&p_670->g_99,&p_670->g_99,&p_670->g_99,&p_670->g_99,&p_670->g_99,&p_670->g_99,&p_670->g_99},{&p_670->g_99,&p_670->g_99,&p_670->g_99,&p_670->g_99,&p_670->g_99,&p_670->g_99,&p_670->g_99,&p_670->g_99},{&p_670->g_99,&p_670->g_99,&p_670->g_99,&p_670->g_99,&p_670->g_99,&p_670->g_99,&p_670->g_99,&p_670->g_99},{&p_670->g_99,&p_670->g_99,&p_670->g_99,&p_670->g_99,&p_670->g_99,&p_670->g_99,&p_670->g_99,&p_670->g_99},{&p_670->g_99,&p_670->g_99,&p_670->g_99,&p_670->g_99,&p_670->g_99,&p_670->g_99,&p_670->g_99,&p_670->g_99},{&p_670->g_99,&p_670->g_99,&p_670->g_99,&p_670->g_99,&p_670->g_99,&p_670->g_99,&p_670->g_99,&p_670->g_99}}}, // p_670->g_111
        0x1FFD6F7CL, // p_670->g_141
        0x48A961F3L, // p_670->g_143
        {(void*)0,(void*)0,(void*)0,(void*)0,(void*)0,(void*)0,(void*)0,(void*)0}, // p_670->g_150
        (VECTOR(uint8_t, 4))(0xCFL, (VECTOR(uint8_t, 2))(0xCFL, 254UL), 254UL), // p_670->g_288
        &p_670->g_99, // p_670->g_370
        &p_670->g_370, // p_670->g_369
        {&p_670->g_93[4],&p_670->g_93[4],&p_670->g_93[4],&p_670->g_93[4],&p_670->g_93[4],&p_670->g_93[4],&p_670->g_93[4],&p_670->g_93[4],&p_670->g_93[4],&p_670->g_93[4]}, // p_670->g_374
        (VECTOR(uint32_t, 2))(1UL, 4294967289UL), // p_670->g_379
        {0x1D59A99DL}, // p_670->g_385
        (VECTOR(int8_t, 4))((-8L), (VECTOR(int8_t, 2))((-8L), 0L), 0L), // p_670->g_418
        18446744073709551607UL, // p_670->g_430
        0x44D2C272L, // p_670->g_435
        4294967295UL, // p_670->g_462
        (VECTOR(int8_t, 8))((-7L), (VECTOR(int8_t, 4))((-7L), (VECTOR(int8_t, 2))((-7L), 0x34L), 0x34L), 0x34L, (-7L), 0x34L), // p_670->g_464
        (VECTOR(int8_t, 4))(0x0EL, (VECTOR(int8_t, 2))(0x0EL, (-1L)), (-1L)), // p_670->g_465
        (VECTOR(int8_t, 2))(0x6AL, 0x6CL), // p_670->g_466
        (VECTOR(int8_t, 2))(1L, 0x51L), // p_670->g_478
        (VECTOR(uint8_t, 16))(0x30L, (VECTOR(uint8_t, 4))(0x30L, (VECTOR(uint8_t, 2))(0x30L, 0xF2L), 0xF2L), 0xF2L, 0x30L, 0xF2L, (VECTOR(uint8_t, 2))(0x30L, 0xF2L), (VECTOR(uint8_t, 2))(0x30L, 0xF2L), 0x30L, 0xF2L, 0x30L, 0xF2L), // p_670->g_481
        (VECTOR(int32_t, 4))(1L, (VECTOR(int32_t, 2))(1L, 0x26E6CBF8L), 0x26E6CBF8L), // p_670->g_495
        (VECTOR(int32_t, 8))(2L, (VECTOR(int32_t, 4))(2L, (VECTOR(int32_t, 2))(2L, 0x3C25134BL), 0x3C25134BL), 0x3C25134BL, 2L, 0x3C25134BL), // p_670->g_498
        (VECTOR(int32_t, 16))(9L, (VECTOR(int32_t, 4))(9L, (VECTOR(int32_t, 2))(9L, 1L), 1L), 1L, 9L, 1L, (VECTOR(int32_t, 2))(9L, 1L), (VECTOR(int32_t, 2))(9L, 1L), 9L, 1L, 9L, 1L), // p_670->g_503
        (VECTOR(int32_t, 8))((-1L), (VECTOR(int32_t, 4))((-1L), (VECTOR(int32_t, 2))((-1L), (-4L)), (-4L)), (-4L), (-1L), (-4L)), // p_670->g_513
        (VECTOR(int32_t, 4))(0x127FEACCL, (VECTOR(int32_t, 2))(0x127FEACCL, 1L), 1L), // p_670->g_519
        (void*)0, // p_670->g_574
        (void*)0, // p_670->g_575
        (VECTOR(int8_t, 2))(0L, 0L), // p_670->g_588
        0x966BAD40L, // p_670->g_618
        &p_670->g_36, // p_670->g_641
        (VECTOR(int16_t, 2))(1L, 0x722DL), // p_670->g_667
        0, // p_670->v_collective
        sequence_input[get_global_id(0)], // p_670->global_0_offset
        sequence_input[get_global_id(1)], // p_670->global_1_offset
        sequence_input[get_global_id(2)], // p_670->global_2_offset
        sequence_input[get_local_id(0)], // p_670->local_0_offset
        sequence_input[get_local_id(1)], // p_670->local_1_offset
        sequence_input[get_local_id(2)], // p_670->local_2_offset
        sequence_input[get_group_id(0)], // p_670->group_0_offset
        sequence_input[get_group_id(1)], // p_670->group_1_offset
        sequence_input[get_group_id(2)], // p_670->group_2_offset
        (safe_add_func_uint32_t_u_u((safe_mul_func_uint32_t_u_u(get_linear_group_id(), 1)), permutations[0][get_linear_local_id()])), // p_670->tid
        l_atomic_input, // l_atomic_input
        l_special_values, // l_special_values
        g_atomic_input, // g_atomic_input
        g_special_values, // g_special_values
        l_atomic_reduction, // l_atomic_reduction
        g_atomic_reduction, // g_atomic_reduction
        l_comm_values, // l_comm_values
        g_comm_values, // g_comm_values
    };
    c_671 = c_672;
    barrier(CLK_LOCAL_MEM_FENCE | CLK_GLOBAL_MEM_FENCE);
    func_1(p_670);
    barrier(CLK_LOCAL_MEM_FENCE | CLK_GLOBAL_MEM_FENCE);
    uint64_t crc64_context = 0xFFFFFFFFFFFFFFFFUL;
    int print_hash_value = 0;
    transparent_crc(p_670->g_16.x, "p_670->g_16.x", print_hash_value);
    transparent_crc(p_670->g_16.y, "p_670->g_16.y", print_hash_value);
    transparent_crc(p_670->g_22, "p_670->g_22", print_hash_value);
    transparent_crc(p_670->g_28, "p_670->g_28", print_hash_value);
    transparent_crc(p_670->g_30.x, "p_670->g_30.x", print_hash_value);
    transparent_crc(p_670->g_30.y, "p_670->g_30.y", print_hash_value);
    transparent_crc(p_670->g_30.z, "p_670->g_30.z", print_hash_value);
    transparent_crc(p_670->g_30.w, "p_670->g_30.w", print_hash_value);
    transparent_crc(p_670->g_33.x, "p_670->g_33.x", print_hash_value);
    transparent_crc(p_670->g_33.y, "p_670->g_33.y", print_hash_value);
    transparent_crc(p_670->g_37, "p_670->g_37", print_hash_value);
    transparent_crc(p_670->g_47.x, "p_670->g_47.x", print_hash_value);
    transparent_crc(p_670->g_47.y, "p_670->g_47.y", print_hash_value);
    transparent_crc(p_670->g_47.z, "p_670->g_47.z", print_hash_value);
    transparent_crc(p_670->g_47.w, "p_670->g_47.w", print_hash_value);
    transparent_crc(p_670->g_83, "p_670->g_83", print_hash_value);
    transparent_crc(p_670->g_89, "p_670->g_89", print_hash_value);
    transparent_crc(p_670->g_91.f0, "p_670->g_91.f0", print_hash_value);
    transparent_crc(p_670->g_108, "p_670->g_108", print_hash_value);
    transparent_crc(p_670->g_141, "p_670->g_141", print_hash_value);
    transparent_crc(p_670->g_143, "p_670->g_143", print_hash_value);
    transparent_crc(p_670->g_288.x, "p_670->g_288.x", print_hash_value);
    transparent_crc(p_670->g_288.y, "p_670->g_288.y", print_hash_value);
    transparent_crc(p_670->g_288.z, "p_670->g_288.z", print_hash_value);
    transparent_crc(p_670->g_288.w, "p_670->g_288.w", print_hash_value);
    transparent_crc(p_670->g_379.x, "p_670->g_379.x", print_hash_value);
    transparent_crc(p_670->g_379.y, "p_670->g_379.y", print_hash_value);
    for (i = 0; i < 1; i++)
    {
        transparent_crc(p_670->g_385[i], "p_670->g_385[i]", print_hash_value);

    }
    transparent_crc(p_670->g_418.x, "p_670->g_418.x", print_hash_value);
    transparent_crc(p_670->g_418.y, "p_670->g_418.y", print_hash_value);
    transparent_crc(p_670->g_418.z, "p_670->g_418.z", print_hash_value);
    transparent_crc(p_670->g_418.w, "p_670->g_418.w", print_hash_value);
    transparent_crc(p_670->g_430, "p_670->g_430", print_hash_value);
    transparent_crc(p_670->g_435, "p_670->g_435", print_hash_value);
    transparent_crc(p_670->g_462, "p_670->g_462", print_hash_value);
    transparent_crc(p_670->g_464.s0, "p_670->g_464.s0", print_hash_value);
    transparent_crc(p_670->g_464.s1, "p_670->g_464.s1", print_hash_value);
    transparent_crc(p_670->g_464.s2, "p_670->g_464.s2", print_hash_value);
    transparent_crc(p_670->g_464.s3, "p_670->g_464.s3", print_hash_value);
    transparent_crc(p_670->g_464.s4, "p_670->g_464.s4", print_hash_value);
    transparent_crc(p_670->g_464.s5, "p_670->g_464.s5", print_hash_value);
    transparent_crc(p_670->g_464.s6, "p_670->g_464.s6", print_hash_value);
    transparent_crc(p_670->g_464.s7, "p_670->g_464.s7", print_hash_value);
    transparent_crc(p_670->g_465.x, "p_670->g_465.x", print_hash_value);
    transparent_crc(p_670->g_465.y, "p_670->g_465.y", print_hash_value);
    transparent_crc(p_670->g_465.z, "p_670->g_465.z", print_hash_value);
    transparent_crc(p_670->g_465.w, "p_670->g_465.w", print_hash_value);
    transparent_crc(p_670->g_466.x, "p_670->g_466.x", print_hash_value);
    transparent_crc(p_670->g_466.y, "p_670->g_466.y", print_hash_value);
    transparent_crc(p_670->g_478.x, "p_670->g_478.x", print_hash_value);
    transparent_crc(p_670->g_478.y, "p_670->g_478.y", print_hash_value);
    transparent_crc(p_670->g_481.s0, "p_670->g_481.s0", print_hash_value);
    transparent_crc(p_670->g_481.s1, "p_670->g_481.s1", print_hash_value);
    transparent_crc(p_670->g_481.s2, "p_670->g_481.s2", print_hash_value);
    transparent_crc(p_670->g_481.s3, "p_670->g_481.s3", print_hash_value);
    transparent_crc(p_670->g_481.s4, "p_670->g_481.s4", print_hash_value);
    transparent_crc(p_670->g_481.s5, "p_670->g_481.s5", print_hash_value);
    transparent_crc(p_670->g_481.s6, "p_670->g_481.s6", print_hash_value);
    transparent_crc(p_670->g_481.s7, "p_670->g_481.s7", print_hash_value);
    transparent_crc(p_670->g_481.s8, "p_670->g_481.s8", print_hash_value);
    transparent_crc(p_670->g_481.s9, "p_670->g_481.s9", print_hash_value);
    transparent_crc(p_670->g_481.sa, "p_670->g_481.sa", print_hash_value);
    transparent_crc(p_670->g_481.sb, "p_670->g_481.sb", print_hash_value);
    transparent_crc(p_670->g_481.sc, "p_670->g_481.sc", print_hash_value);
    transparent_crc(p_670->g_481.sd, "p_670->g_481.sd", print_hash_value);
    transparent_crc(p_670->g_481.se, "p_670->g_481.se", print_hash_value);
    transparent_crc(p_670->g_481.sf, "p_670->g_481.sf", print_hash_value);
    transparent_crc(p_670->g_495.x, "p_670->g_495.x", print_hash_value);
    transparent_crc(p_670->g_495.y, "p_670->g_495.y", print_hash_value);
    transparent_crc(p_670->g_495.z, "p_670->g_495.z", print_hash_value);
    transparent_crc(p_670->g_495.w, "p_670->g_495.w", print_hash_value);
    transparent_crc(p_670->g_498.s0, "p_670->g_498.s0", print_hash_value);
    transparent_crc(p_670->g_498.s1, "p_670->g_498.s1", print_hash_value);
    transparent_crc(p_670->g_498.s2, "p_670->g_498.s2", print_hash_value);
    transparent_crc(p_670->g_498.s3, "p_670->g_498.s3", print_hash_value);
    transparent_crc(p_670->g_498.s4, "p_670->g_498.s4", print_hash_value);
    transparent_crc(p_670->g_498.s5, "p_670->g_498.s5", print_hash_value);
    transparent_crc(p_670->g_498.s6, "p_670->g_498.s6", print_hash_value);
    transparent_crc(p_670->g_498.s7, "p_670->g_498.s7", print_hash_value);
    transparent_crc(p_670->g_503.s0, "p_670->g_503.s0", print_hash_value);
    transparent_crc(p_670->g_503.s1, "p_670->g_503.s1", print_hash_value);
    transparent_crc(p_670->g_503.s2, "p_670->g_503.s2", print_hash_value);
    transparent_crc(p_670->g_503.s3, "p_670->g_503.s3", print_hash_value);
    transparent_crc(p_670->g_503.s4, "p_670->g_503.s4", print_hash_value);
    transparent_crc(p_670->g_503.s5, "p_670->g_503.s5", print_hash_value);
    transparent_crc(p_670->g_503.s6, "p_670->g_503.s6", print_hash_value);
    transparent_crc(p_670->g_503.s7, "p_670->g_503.s7", print_hash_value);
    transparent_crc(p_670->g_503.s8, "p_670->g_503.s8", print_hash_value);
    transparent_crc(p_670->g_503.s9, "p_670->g_503.s9", print_hash_value);
    transparent_crc(p_670->g_503.sa, "p_670->g_503.sa", print_hash_value);
    transparent_crc(p_670->g_503.sb, "p_670->g_503.sb", print_hash_value);
    transparent_crc(p_670->g_503.sc, "p_670->g_503.sc", print_hash_value);
    transparent_crc(p_670->g_503.sd, "p_670->g_503.sd", print_hash_value);
    transparent_crc(p_670->g_503.se, "p_670->g_503.se", print_hash_value);
    transparent_crc(p_670->g_503.sf, "p_670->g_503.sf", print_hash_value);
    transparent_crc(p_670->g_513.s0, "p_670->g_513.s0", print_hash_value);
    transparent_crc(p_670->g_513.s1, "p_670->g_513.s1", print_hash_value);
    transparent_crc(p_670->g_513.s2, "p_670->g_513.s2", print_hash_value);
    transparent_crc(p_670->g_513.s3, "p_670->g_513.s3", print_hash_value);
    transparent_crc(p_670->g_513.s4, "p_670->g_513.s4", print_hash_value);
    transparent_crc(p_670->g_513.s5, "p_670->g_513.s5", print_hash_value);
    transparent_crc(p_670->g_513.s6, "p_670->g_513.s6", print_hash_value);
    transparent_crc(p_670->g_513.s7, "p_670->g_513.s7", print_hash_value);
    transparent_crc(p_670->g_519.x, "p_670->g_519.x", print_hash_value);
    transparent_crc(p_670->g_519.y, "p_670->g_519.y", print_hash_value);
    transparent_crc(p_670->g_519.z, "p_670->g_519.z", print_hash_value);
    transparent_crc(p_670->g_519.w, "p_670->g_519.w", print_hash_value);
    transparent_crc(p_670->g_588.x, "p_670->g_588.x", print_hash_value);
    transparent_crc(p_670->g_588.y, "p_670->g_588.y", print_hash_value);
    transparent_crc(p_670->g_618, "p_670->g_618", print_hash_value);
    transparent_crc(p_670->g_667.x, "p_670->g_667.x", print_hash_value);
    transparent_crc(p_670->g_667.y, "p_670->g_667.y", print_hash_value);
    transparent_crc(p_670->v_collective, "p_670->v_collective", print_hash_value);
    barrier(CLK_LOCAL_MEM_FENCE | CLK_GLOBAL_MEM_FENCE);
    if (!get_linear_global_id())
        for (i = 0 ; i < 4; i++)
            transparent_crc(p_670->g_special_values[i + 4 * get_linear_group_id()], "p_670->g_special_values[i + 4 * get_linear_group_id()]", print_hash_value);
    barrier(CLK_LOCAL_MEM_FENCE | CLK_GLOBAL_MEM_FENCE);
    if (!get_linear_local_id())
        for (i = 0; i < 4; i++)
            transparent_crc(p_670->l_special_values[i], "p_670->l_special_values[i]", print_hash_value);
    transparent_crc(p_670->l_comm_values[get_linear_local_id()], "p_670->l_comm_values[get_linear_local_id()]", print_hash_value);
    transparent_crc(p_670->g_comm_values[get_linear_global_id()], "p_670->g_comm_values[get_linear_global_id()]", print_hash_value);
    result[get_linear_global_id()] = crc64_context ^ 0xFFFFFFFFFFFFFFFFUL;
}
