// --atomics 69 ---atomic_reductions ---fake_divergence ---inter_thread_comm ---emi -g 1,1,6503 -l 1,1,1
#define int64_t long
#define uint64_t ulong
#define int_least64_t long
#define uint_least64_t ulong
#define int_fast64_t long
#define uint_fast64_t ulong
#define intmax_t long
#define uintmax_t ulong
#define int32_t int
#define uint32_t uint
#define int16_t short
#define uint16_t ushort
#define int8_t char
#define uint8_t uchar

#define INT64_MIN LONG_MIN
#define INT64_MAX LONG_MAX
#define INT32_MIN INT_MIN
#define INT32_MAX INT_MAX
#define INT16_MIN SHRT_MIN
#define INT16_MAX SHRT_MAX
#define INT8_MIN CHAR_MIN
#define INT8_MAX CHAR_MAX
#define UINT64_MIN ULONG_MIN
#define UINT64_MAX ULONG_MAX
#define UINT32_MIN UINT_MIN
#define UINT32_MAX UINT_MAX
#define UINT16_MIN USHRT_MIN
#define UINT16_MAX USHRT_MAX
#define UINT8_MIN UCHAR_MIN
#define UINT8_MAX UCHAR_MAX

#define transparent_crc(X, Y, Z) transparent_crc_(&crc64_context, X, Y, Z)

#define VECTOR(X , Y) VECTOR_(X, Y)
#define VECTOR_(X, Y) X##Y

#ifndef NO_GROUP_DIVERGENCE
#define GROUP_DIVERGE(x, y) get_group_id(x)
#else
#define GROUP_DIVERGE(x, y) (y)
#endif

#ifndef NO_FAKE_DIVERGENCE
#define FAKE_DIVERGE(x, y, z) (x - y)
#else
#define FAKE_DIVERGE(x, y, z) (z)
#endif

__constant uint32_t permutations[10][1] = {
{0}, // permutation 0
{0}, // permutation 1
{0}, // permutation 2
{0}, // permutation 3
{0}, // permutation 4
{0}, // permutation 5
{0}, // permutation 6
{0}, // permutation 7
{0}, // permutation 8
{0} // permutation 9
};

// Seed: 2

#include "CLSmith.h"

/* --- Struct/Union Declarations --- */
struct S0 {
    volatile VECTOR(int16_t, 16) g_10;
    int32_t g_25[2];
    uint32_t g_48;
    uint32_t g_54;
    int32_t g_72;
    VECTOR(int64_t, 16) g_78;
    int8_t g_79;
    uint64_t g_80[1];
    VECTOR(int32_t, 8) g_83;
    volatile uint32_t g_97[1];
    volatile uint32_t *g_96;
    volatile uint32_t * volatile *g_95;
    volatile uint32_t * volatile **g_94;
    int16_t g_116[3];
    uint32_t g_118;
    VECTOR(int8_t, 8) g_127;
    VECTOR(int8_t, 16) g_170;
    VECTOR(int16_t, 8) g_186;
    VECTOR(uint16_t, 8) g_187;
    volatile int32_t **g_216;
    int8_t g_232;
    VECTOR(uint32_t, 4) g_242;
    VECTOR(uint16_t, 8) g_253;
    VECTOR(int32_t, 8) g_267;
    VECTOR(uint8_t, 2) g_272;
    VECTOR(uint8_t, 4) g_276;
    VECTOR(uint32_t, 8) g_306;
    VECTOR(uint32_t, 16) g_313;
    VECTOR(uint32_t, 2) g_317;
    VECTOR(uint32_t, 8) g_320;
    VECTOR(uint8_t, 2) g_331;
    uint32_t g_354;
    VECTOR(uint32_t, 4) g_374;
    VECTOR(int32_t, 8) g_386;
    VECTOR(int32_t, 16) g_387;
    VECTOR(uint64_t, 16) g_395;
    uint32_t *g_397;
    VECTOR(uint64_t, 8) g_399;
    VECTOR(uint64_t, 16) g_402;
    uint64_t g_696;
    VECTOR(int64_t, 4) g_710;
    VECTOR(int64_t, 2) g_711;
    VECTOR(int64_t, 4) g_712;
    VECTOR(uint8_t, 2) g_769;
    VECTOR(uint8_t, 8) g_770;
    VECTOR(uint64_t, 16) g_777;
    uint16_t g_800;
    uint16_t g_802;
    int32_t ***g_817;
    VECTOR(int8_t, 16) g_824;
    int8_t g_860[10][2];
    VECTOR(int64_t, 8) g_872;
    VECTOR(int64_t, 8) g_878;
    VECTOR(int64_t, 4) g_879;
    uint32_t g_889;
    int64_t g_908;
    VECTOR(int32_t, 2) g_924;
    VECTOR(int64_t, 8) g_946;
    VECTOR(int32_t, 8) g_1868;
    volatile uint8_t g_2080;
    volatile uint8_t * volatile g_2079;
    volatile VECTOR(int32_t, 2) g_2176;
    volatile VECTOR(int8_t, 16) g_2189;
    VECTOR(int8_t, 4) g_2191;
    VECTOR(int8_t, 4) g_2192;
    volatile VECTOR(int8_t, 4) g_2194;
    VECTOR(int8_t, 8) g_2195;
    volatile VECTOR(int8_t, 8) g_2196;
    int32_t *g_2205[2];
    int32_t ** volatile g_2204;
    VECTOR(uint16_t, 8) g_2209;
    VECTOR(int32_t, 2) g_2215;
    uint32_t v_collective;
    uint64_t global_0_offset;
    uint64_t global_1_offset;
    uint64_t global_2_offset;
    uint64_t local_0_offset;
    uint64_t local_1_offset;
    uint64_t local_2_offset;
    uint64_t group_0_offset;
    uint64_t group_1_offset;
    uint64_t group_2_offset;
    uint32_t tid;
    __local volatile uint32_t *l_atomic_input;
    __local volatile uint32_t *l_special_values;
    __global volatile uint32_t *g_atomic_input;
    __global volatile uint32_t *g_special_values;
    __local volatile uint32_t *l_atomic_reduction;
    __global volatile uint32_t *g_atomic_reduction;
    __global int32_t *emi_input;
    __local int64_t *l_comm_values;
    __global int64_t *g_comm_values;
};

int8_t  func_59(struct S0 * p_2232)
{ /* block id: 35 */
    for (p_2232->g_48 = (-13); (p_2232->g_48 >= 44); p_2232->g_48 = safe_add_func_uint8_t_u_u(p_2232->g_48, 9))
        if ((p_2232->emi_input[2] < p_2232->emi_input[3]))
            if ((((VECTOR(int8_t, 4))(p_2232->g_127.s1553)).y == (p_2232->g_72 <= 1UL)))
            { /* block id: 45 */
            }
    return 1L;
}

__kernel void entry(__global ulong *result, __global volatile uint *g_atomic_input, __global volatile uint *g_special_values, __global volatile int *g_atomic_reduction, __global int *emi_input, __global int *sequence_input, __global long *g_comm_values) {
    int i, j;
    __local volatile uint32_t l_atomic_input[69];
    if (get_linear_local_id() == 0)
        for (i = 0; i < 69; i++)
            l_atomic_input[i] = 0;
    __local volatile uint32_t l_special_values[69];
    if (get_linear_local_id() == 0)
        for (i = 0; i < 69; i++)
            l_special_values[i] = 0;
    __local volatile uint32_t l_atomic_reduction[1];
    if (get_linear_local_id() == 0)
        for (i = 0; i < 1; i++)
            l_atomic_reduction[i] = 0;
    __local int64_t l_comm_values[1];
    if (get_linear_local_id() == 0)
        for (i = 0; i < 1; i++)
            l_comm_values[i] = 1;
    struct S0 c_2233;
    struct S0* p_2232 = &c_2233;
    struct S0 c_2234 = {
        (VECTOR(int16_t, 16))((VECTOR(int16_t, 4))((VECTOR(int16_t, 2))(0L, 1L), 0L, 1L), 0L, (VECTOR(int16_t, 2))(0L, 1L), (VECTOR(int16_t, 4))(0L, (VECTOR(int16_t, 2))(0L, 1L), 1L), (VECTOR(int16_t, 4))(0L, 1L, 0L, 1L), 1L), // p_2232->g_10
        {4L,4L}, // p_2232->g_25
        0xFAADAD2DL, // p_2232->g_48
        0UL, // p_2232->g_54
        0x2D1E5678L, // p_2232->g_72
        (VECTOR(int64_t, 16))(9L, (VECTOR(int64_t, 4))((VECTOR(int64_t, 2))(9L, 8L), 9L, 8L), 8L, (VECTOR(int64_t, 4))(9L, 8L, 9L, 8L), 9L, 8L, 9L, (VECTOR(int64_t, 2))(9L, 8L), 8L), // p_2232->g_78
        (-4L), // p_2232->g_79
        {1UL}, // p_2232->g_80
        (VECTOR(int32_t, 8))((VECTOR(int32_t, 2))(0x5B33FCDFL, 0x0FB7EBE1L), (VECTOR(int32_t, 2))(0x5B33FCDFL, 0x0FB7EBE1L), (VECTOR(int32_t, 2))(0x5B33FCDFL, 0x0FB7EBE1L), 0x5B33FCDFL, 0x0FB7EBE1L), // p_2232->g_83
        {0xF5EDDB6FL}, // p_2232->g_97
        &p_2232->g_97[0], // p_2232->g_96
        &p_2232->g_96, // p_2232->g_95
        &p_2232->g_95, // p_2232->g_94
        {(-1L),(-1L),(-1L)}, // p_2232->g_116
        0x4FF402FEL, // p_2232->g_118
        (VECTOR(int8_t, 8))(0x44L, (VECTOR(int8_t, 4))(0x44L, 0x22L, 0x44L, 0x22L), (VECTOR(int8_t, 2))(0x44L, 0x22L), 0x22L), // p_2232->g_127
        (VECTOR(int8_t, 16))((VECTOR(int8_t, 4))(0x59L, (VECTOR(int8_t, 2))(0x59L, 9L), 9L), 0x59L, (VECTOR(int8_t, 2))(0x59L, 9L), 9L, (VECTOR(int8_t, 2))(0x59L, 9L), 0x59L, 9L, (VECTOR(int8_t, 2))(0x59L, 9L), 0x59L, 9L), // p_2232->g_170
        (VECTOR(int16_t, 8))(1L, 1L, (VECTOR(int16_t, 2))(1L, 1L), (VECTOR(int16_t, 2))(1L, 1L), 1L, 1L), // p_2232->g_186
        (VECTOR(uint16_t, 8))(0x84B0L, 65533UL, (VECTOR(uint16_t, 2))(0x84B0L, 65533UL), 0x84B0L, (VECTOR(uint16_t, 2))(0x84B0L, 65533UL), 65533UL), // p_2232->g_187
        (void*)0, // p_2232->g_216
        0x70L, // p_2232->g_232
        (VECTOR(uint32_t, 4))((VECTOR(uint32_t, 2))(4294967295UL, 3UL), 4294967295UL, 3UL), // p_2232->g_242
        (VECTOR(uint16_t, 8))((VECTOR(uint16_t, 2))(0x85EFL, 0UL), 0x85EFL, 0UL, (VECTOR(uint16_t, 2))(0x85EFL, 0UL), 0x85EFL, 0UL), // p_2232->g_253
        (VECTOR(int32_t, 8))((VECTOR(int32_t, 2))((-3L), 0x2870D0B1L), (VECTOR(int32_t, 2))((-3L), 0x2870D0B1L), (-3L), (VECTOR(int32_t, 2))((-3L), 0x2870D0B1L), 0x2870D0B1L), // p_2232->g_267
        (VECTOR(uint8_t, 2))(1UL, 8UL), // p_2232->g_272
        (VECTOR(uint8_t, 4))((VECTOR(uint8_t, 2))(0x29L, 0x2DL), 0x29L, 0x2DL), // p_2232->g_276
        (VECTOR(uint32_t, 8))(0x39F61A1BL, 1UL, (VECTOR(uint32_t, 2))(0x39F61A1BL, 1UL), 0x39F61A1BL, 1UL, 0x39F61A1BL, 1UL), // p_2232->g_306
        (VECTOR(uint32_t, 16))(0xBCAF0811L, (VECTOR(uint32_t, 4))(0xBCAF0811L, (VECTOR(uint32_t, 2))(0xBCAF0811L, 0xED41813AL), 0xED41813AL), (VECTOR(uint32_t, 2))(0xBCAF0811L, 0xED41813AL), 0xED41813AL, 0xBCAF0811L, (VECTOR(uint32_t, 4))((VECTOR(uint32_t, 2))(0xBCAF0811L, 0xED41813AL), 0xBCAF0811L, 0xED41813AL), 0xED41813AL, 0xBCAF0811L, 0xED41813AL), // p_2232->g_313
        (VECTOR(uint32_t, 2))(0xA2F4FB3AL, 6UL), // p_2232->g_317
        (VECTOR(uint32_t, 8))((VECTOR(uint32_t, 2))(0x878CFAC5L, 0x3AD2EF7AL), (VECTOR(uint32_t, 2))(0x878CFAC5L, 0x3AD2EF7AL), (VECTOR(uint32_t, 2))(0x878CFAC5L, 0x3AD2EF7AL), 0x878CFAC5L, 0x3AD2EF7AL), // p_2232->g_320
        (VECTOR(uint8_t, 2))(0x92L, 0xC7L), // p_2232->g_331
        4294967293UL, // p_2232->g_354
        (VECTOR(uint32_t, 4))(6UL, 0x235C6B1BL, 6UL, 0x235C6B1BL), // p_2232->g_374
        (VECTOR(int32_t, 8))(0x3492BCE1L, 0x261D4161L, (VECTOR(int32_t, 2))(0x3492BCE1L, 0x261D4161L), 0x3492BCE1L, (VECTOR(int32_t, 2))(0x3492BCE1L, 0x261D4161L), 0x261D4161L), // p_2232->g_386
        (VECTOR(int32_t, 16))((VECTOR(int32_t, 4))(0L, 0L, 0L, 0L), 0L, (VECTOR(int32_t, 2))(0L, 0L), 0L, (VECTOR(int32_t, 2))(0L, 0L), (VECTOR(int32_t, 2))(0L, 0L), 0L, (VECTOR(int32_t, 2))(0L, 0L), 0L), // p_2232->g_387
        (VECTOR(uint64_t, 16))((VECTOR(uint64_t, 4))((VECTOR(uint64_t, 2))(0UL, 0xCA87C93DA484EEF5L), 0UL, 0xCA87C93DA484EEF5L), (VECTOR(uint64_t, 4))((VECTOR(uint64_t, 2))(0UL, 0xCA87C93DA484EEF5L), 0UL, 0xCA87C93DA484EEF5L), 0UL, (VECTOR(uint64_t, 4))((VECTOR(uint64_t, 2))(0UL, 0xCA87C93DA484EEF5L), 0UL, 0xCA87C93DA484EEF5L), 0xCA87C93DA484EEF5L, 0UL, 0xCA87C93DA484EEF5L), // p_2232->g_395
        (void*)0, // p_2232->g_397
        (VECTOR(uint64_t, 8))(18446744073709551613UL, (VECTOR(uint64_t, 4))((VECTOR(uint64_t, 2))(18446744073709551613UL, 0x35D09D9527E8FD32L), 18446744073709551613UL, 0x35D09D9527E8FD32L), (VECTOR(uint64_t, 2))(18446744073709551613UL, 0x35D09D9527E8FD32L), 0x35D09D9527E8FD32L), // p_2232->g_399
        (VECTOR(uint64_t, 16))((VECTOR(uint64_t, 4))(0xDC57BA0327D7D170L, 18446744073709551613UL, 0xDC57BA0327D7D170L, 18446744073709551613UL), (VECTOR(uint64_t, 4))((VECTOR(uint64_t, 2))(0xDC57BA0327D7D170L, 18446744073709551613UL), 0xDC57BA0327D7D170L, 18446744073709551613UL), (VECTOR(uint64_t, 2))(0xDC57BA0327D7D170L, 18446744073709551613UL), 0xDC57BA0327D7D170L, 18446744073709551613UL, (VECTOR(uint64_t, 2))(0xDC57BA0327D7D170L, 18446744073709551613UL), 0xDC57BA0327D7D170L, 18446744073709551613UL), // p_2232->g_402
        18446744073709551615UL, // p_2232->g_696
        (VECTOR(int64_t, 4))(0x4F4B9662464922EDL, (VECTOR(int64_t, 2))(0x4F4B9662464922EDL, 0x5AF339897AAFD90FL), 0x5AF339897AAFD90FL), // p_2232->g_710
        (VECTOR(int64_t, 2))(1L, 0x3BAF4B5340CCD2A5L), // p_2232->g_711
        (VECTOR(int64_t, 4))(0x43AA148A1E6BA576L, (VECTOR(int64_t, 2))(0x43AA148A1E6BA576L, 0x6804AE334EB755AEL), 0x6804AE334EB755AEL), // p_2232->g_712
        (VECTOR(uint8_t, 2))(0UL, 3UL), // p_2232->g_769
        (VECTOR(uint8_t, 8))((VECTOR(uint8_t, 2))(253UL, 255UL), (VECTOR(uint8_t, 2))(253UL, 255UL), 253UL, 255UL, 253UL, 255UL), // p_2232->g_770
        (VECTOR(uint64_t, 16))(0x7D082258C24DD6DBL, (VECTOR(uint64_t, 4))((VECTOR(uint64_t, 2))(0x7D082258C24DD6DBL, 0x3D5CBD98703F9F3FL), 0x7D082258C24DD6DBL, 0x3D5CBD98703F9F3FL), 0x3D5CBD98703F9F3FL, 0x7D082258C24DD6DBL, 0x3D5CBD98703F9F3FL, (VECTOR(uint64_t, 2))(0x7D082258C24DD6DBL, 0x3D5CBD98703F9F3FL), (VECTOR(uint64_t, 2))(0x7D082258C24DD6DBL, 0x3D5CBD98703F9F3FL), 0x7D082258C24DD6DBL, (VECTOR(uint64_t, 2))(0x7D082258C24DD6DBL, 0x3D5CBD98703F9F3FL), 0x3D5CBD98703F9F3FL), // p_2232->g_777
        0x17F2L, // p_2232->g_800
        65532UL, // p_2232->g_802
        (void*)0, // p_2232->g_817
        (VECTOR(int8_t, 16))(1L, (VECTOR(int8_t, 4))(1L, 0x48L, 1L, 0x48L), (VECTOR(int8_t, 2))(1L, 0x48L), (VECTOR(int8_t, 4))(1L, (VECTOR(int8_t, 2))(1L, 0x48L), 0x48L), (VECTOR(int8_t, 4))(1L, 0x48L, 1L, 0x48L), 0x48L), // p_2232->g_824
        {{0x20L,0x20L},{0x20L,0x20L},{0x20L,0x20L},{0x20L,0x20L},{0x20L,0x20L},{0x20L,0x20L},{0x20L,0x20L},{0x20L,0x20L},{0x20L,0x20L},{0x20L,0x20L}}, // p_2232->g_860
        (VECTOR(int64_t, 8))(0x0B86A8E3CA47381BL, (VECTOR(int64_t, 4))(0x0B86A8E3CA47381BL, (VECTOR(int64_t, 2))(0x0B86A8E3CA47381BL, 0x0A2F657574D28A19L), 0x0A2F657574D28A19L), 0x0A2F657574D28A19L, 0x0B86A8E3CA47381BL, 0x0A2F657574D28A19L), // p_2232->g_872
        (VECTOR(int64_t, 8))((VECTOR(int64_t, 2))((-1L), 0L), (VECTOR(int64_t, 2))((-1L), 0L), (-1L), (VECTOR(int64_t, 2))((-1L), 0L), 0L), // p_2232->g_878
        (VECTOR(int64_t, 4))(0x48FE4E6683CC1FD9L, (VECTOR(int64_t, 2))(0x48FE4E6683CC1FD9L, (-1L)), (-1L)), // p_2232->g_879
        3UL, // p_2232->g_889
        0x78821DDD1CC2A50AL, // p_2232->g_908
        (VECTOR(int32_t, 2))(0x1E15F0C3L, (-3L)), // p_2232->g_924
        (VECTOR(int64_t, 8))((VECTOR(int64_t, 2))((-1L), 0x435A8ED019CADC88L), (-1L), (VECTOR(int64_t, 4))((VECTOR(int64_t, 2))((-1L), 0x435A8ED019CADC88L), (-1L), 0x435A8ED019CADC88L), 0x435A8ED019CADC88L), // p_2232->g_946
        (VECTOR(int32_t, 8))(1L, 0x08B576F7L, 1L, (VECTOR(int32_t, 4))(1L, (VECTOR(int32_t, 2))(1L, 0x08B576F7L), 0x08B576F7L), 0x08B576F7L), // p_2232->g_1868
        8UL, // p_2232->g_2080
        &p_2232->g_2080, // p_2232->g_2079
        (VECTOR(int32_t, 2))(0x750DD539L, (-1L)), // p_2232->g_2176
        (VECTOR(int8_t, 16))((VECTOR(int8_t, 4))(0x66L, (VECTOR(int8_t, 2))(0x66L, (-1L)), (-1L)), (VECTOR(int8_t, 4))((VECTOR(int8_t, 2))(0x66L, (-1L)), 0x66L, (-1L)), (VECTOR(int8_t, 2))(0x66L, (-1L)), 0x66L, (VECTOR(int8_t, 4))(0x66L, (-1L), 0x66L, (-1L)), (-1L)), // p_2232->g_2189
        (VECTOR(int8_t, 4))(1L, (VECTOR(int8_t, 2))(1L, 0x64L), 0x64L), // p_2232->g_2191
        (VECTOR(int8_t, 4))(0x07L, (-4L), 0x07L, (-4L)), // p_2232->g_2192
        (VECTOR(int8_t, 4))(0L, (VECTOR(int8_t, 2))(0L, (-1L)), (-1L)), // p_2232->g_2194
        (VECTOR(int8_t, 8))((VECTOR(int8_t, 2))(7L, 0L), (VECTOR(int8_t, 2))(7L, 0L), (VECTOR(int8_t, 2))(7L, 0L), 7L, 0L), // p_2232->g_2195
        (VECTOR(int8_t, 8))(6L, (VECTOR(int8_t, 4))(6L, 0x12L, 6L, 0x12L), 0x12L, 6L, 0x12L), // p_2232->g_2196
        {&p_2232->g_25[1],&p_2232->g_25[1]}, // p_2232->g_2205
        &p_2232->g_2205[1], // p_2232->g_2204
        (VECTOR(uint16_t, 8))((VECTOR(uint16_t, 2))(0xB022L, 0x4F05L), 0xB022L, (VECTOR(uint16_t, 4))(0xB022L, (VECTOR(uint16_t, 2))(0xB022L, 0x4F05L), 0x4F05L), 0x4F05L), // p_2232->g_2209
        (VECTOR(int32_t, 2))(0x47DF2C0CL, 0x13D84AE3L), // p_2232->g_2215
        0, // p_2232->v_collective
        sequence_input[get_global_id(0)], // p_2232->global_0_offset
        sequence_input[get_global_id(1)], // p_2232->global_1_offset
        sequence_input[get_global_id(2)], // p_2232->global_2_offset
        sequence_input[get_local_id(0)], // p_2232->local_0_offset
        sequence_input[get_local_id(1)], // p_2232->local_1_offset
        sequence_input[get_local_id(2)], // p_2232->local_2_offset
        sequence_input[get_group_id(0)], // p_2232->group_0_offset
        sequence_input[get_group_id(1)], // p_2232->group_1_offset
        sequence_input[get_group_id(2)], // p_2232->group_2_offset
        (safe_add_func_uint32_t_u_u((safe_mul_func_uint32_t_u_u(get_linear_group_id(), 1)), permutations[0][get_linear_local_id()])), // p_2232->tid
        l_atomic_input, // l_atomic_input
        l_special_values, // l_special_values
        g_atomic_input, // g_atomic_input
        g_special_values, // g_special_values
        l_atomic_reduction, // l_atomic_reduction
        g_atomic_reduction, // g_atomic_reduction
        emi_input, // emi_input
        l_comm_values, // l_comm_values
        g_comm_values, // g_comm_values
    };
    c_2233 = c_2234;
    barrier(CLK_LOCAL_MEM_FENCE | CLK_GLOBAL_MEM_FENCE);
    func_59(p_2232);
    barrier(CLK_LOCAL_MEM_FENCE | CLK_GLOBAL_MEM_FENCE);
    uint64_t crc64_context = 0xFFFFFFFFFFFFFFFFUL;
    int print_hash_value = 0;
    transparent_crc(p_2232->g_10.s0, "p_2232->g_10.s0", print_hash_value);
    transparent_crc(p_2232->g_10.s1, "p_2232->g_10.s1", print_hash_value);
    transparent_crc(p_2232->g_10.s2, "p_2232->g_10.s2", print_hash_value);
    transparent_crc(p_2232->g_10.s3, "p_2232->g_10.s3", print_hash_value);
    transparent_crc(p_2232->g_10.s4, "p_2232->g_10.s4", print_hash_value);
    transparent_crc(p_2232->g_10.s5, "p_2232->g_10.s5", print_hash_value);
    transparent_crc(p_2232->g_10.s6, "p_2232->g_10.s6", print_hash_value);
    transparent_crc(p_2232->g_10.s7, "p_2232->g_10.s7", print_hash_value);
    transparent_crc(p_2232->g_10.s8, "p_2232->g_10.s8", print_hash_value);
    transparent_crc(p_2232->g_10.s9, "p_2232->g_10.s9", print_hash_value);
    transparent_crc(p_2232->g_10.sa, "p_2232->g_10.sa", print_hash_value);
    transparent_crc(p_2232->g_10.sb, "p_2232->g_10.sb", print_hash_value);
    transparent_crc(p_2232->g_10.sc, "p_2232->g_10.sc", print_hash_value);
    transparent_crc(p_2232->g_10.sd, "p_2232->g_10.sd", print_hash_value);
    transparent_crc(p_2232->g_10.se, "p_2232->g_10.se", print_hash_value);
    transparent_crc(p_2232->g_10.sf, "p_2232->g_10.sf", print_hash_value);
    for (i = 0; i < 2; i++)
    {
        transparent_crc(p_2232->g_25[i], "p_2232->g_25[i]", print_hash_value);

    }
    transparent_crc(p_2232->g_48, "p_2232->g_48", print_hash_value);
    transparent_crc(p_2232->g_54, "p_2232->g_54", print_hash_value);
    transparent_crc(p_2232->g_72, "p_2232->g_72", print_hash_value);
    transparent_crc(p_2232->g_78.s0, "p_2232->g_78.s0", print_hash_value);
    transparent_crc(p_2232->g_78.s1, "p_2232->g_78.s1", print_hash_value);
    transparent_crc(p_2232->g_78.s2, "p_2232->g_78.s2", print_hash_value);
    transparent_crc(p_2232->g_78.s3, "p_2232->g_78.s3", print_hash_value);
    transparent_crc(p_2232->g_78.s4, "p_2232->g_78.s4", print_hash_value);
    transparent_crc(p_2232->g_78.s5, "p_2232->g_78.s5", print_hash_value);
    transparent_crc(p_2232->g_78.s6, "p_2232->g_78.s6", print_hash_value);
    transparent_crc(p_2232->g_78.s7, "p_2232->g_78.s7", print_hash_value);
    transparent_crc(p_2232->g_78.s8, "p_2232->g_78.s8", print_hash_value);
    transparent_crc(p_2232->g_78.s9, "p_2232->g_78.s9", print_hash_value);
    transparent_crc(p_2232->g_78.sa, "p_2232->g_78.sa", print_hash_value);
    transparent_crc(p_2232->g_78.sb, "p_2232->g_78.sb", print_hash_value);
    transparent_crc(p_2232->g_78.sc, "p_2232->g_78.sc", print_hash_value);
    transparent_crc(p_2232->g_78.sd, "p_2232->g_78.sd", print_hash_value);
    transparent_crc(p_2232->g_78.se, "p_2232->g_78.se", print_hash_value);
    transparent_crc(p_2232->g_78.sf, "p_2232->g_78.sf", print_hash_value);
    transparent_crc(p_2232->g_79, "p_2232->g_79", print_hash_value);
    for (i = 0; i < 1; i++)
    {
        transparent_crc(p_2232->g_80[i], "p_2232->g_80[i]", print_hash_value);

    }
    transparent_crc(p_2232->g_83.s0, "p_2232->g_83.s0", print_hash_value);
    transparent_crc(p_2232->g_83.s1, "p_2232->g_83.s1", print_hash_value);
    transparent_crc(p_2232->g_83.s2, "p_2232->g_83.s2", print_hash_value);
    transparent_crc(p_2232->g_83.s3, "p_2232->g_83.s3", print_hash_value);
    transparent_crc(p_2232->g_83.s4, "p_2232->g_83.s4", print_hash_value);
    transparent_crc(p_2232->g_83.s5, "p_2232->g_83.s5", print_hash_value);
    transparent_crc(p_2232->g_83.s6, "p_2232->g_83.s6", print_hash_value);
    transparent_crc(p_2232->g_83.s7, "p_2232->g_83.s7", print_hash_value);
    for (i = 0; i < 1; i++)
    {
        transparent_crc(p_2232->g_97[i], "p_2232->g_97[i]", print_hash_value);

    }
    for (i = 0; i < 3; i++)
    {
        transparent_crc(p_2232->g_116[i], "p_2232->g_116[i]", print_hash_value);

    }
    transparent_crc(p_2232->g_118, "p_2232->g_118", print_hash_value);
    transparent_crc(p_2232->g_127.s0, "p_2232->g_127.s0", print_hash_value);
    transparent_crc(p_2232->g_127.s1, "p_2232->g_127.s1", print_hash_value);
    transparent_crc(p_2232->g_127.s2, "p_2232->g_127.s2", print_hash_value);
    transparent_crc(p_2232->g_127.s3, "p_2232->g_127.s3", print_hash_value);
    transparent_crc(p_2232->g_127.s4, "p_2232->g_127.s4", print_hash_value);
    transparent_crc(p_2232->g_127.s5, "p_2232->g_127.s5", print_hash_value);
    transparent_crc(p_2232->g_127.s6, "p_2232->g_127.s6", print_hash_value);
    transparent_crc(p_2232->g_127.s7, "p_2232->g_127.s7", print_hash_value);
    transparent_crc(p_2232->g_170.s0, "p_2232->g_170.s0", print_hash_value);
    transparent_crc(p_2232->g_170.s1, "p_2232->g_170.s1", print_hash_value);
    transparent_crc(p_2232->g_170.s2, "p_2232->g_170.s2", print_hash_value);
    transparent_crc(p_2232->g_170.s3, "p_2232->g_170.s3", print_hash_value);
    transparent_crc(p_2232->g_170.s4, "p_2232->g_170.s4", print_hash_value);
    transparent_crc(p_2232->g_170.s5, "p_2232->g_170.s5", print_hash_value);
    transparent_crc(p_2232->g_170.s6, "p_2232->g_170.s6", print_hash_value);
    transparent_crc(p_2232->g_170.s7, "p_2232->g_170.s7", print_hash_value);
    transparent_crc(p_2232->g_170.s8, "p_2232->g_170.s8", print_hash_value);
    transparent_crc(p_2232->g_170.s9, "p_2232->g_170.s9", print_hash_value);
    transparent_crc(p_2232->g_170.sa, "p_2232->g_170.sa", print_hash_value);
    transparent_crc(p_2232->g_170.sb, "p_2232->g_170.sb", print_hash_value);
    transparent_crc(p_2232->g_170.sc, "p_2232->g_170.sc", print_hash_value);
    transparent_crc(p_2232->g_170.sd, "p_2232->g_170.sd", print_hash_value);
    transparent_crc(p_2232->g_170.se, "p_2232->g_170.se", print_hash_value);
    transparent_crc(p_2232->g_170.sf, "p_2232->g_170.sf", print_hash_value);
    transparent_crc(p_2232->g_186.s0, "p_2232->g_186.s0", print_hash_value);
    transparent_crc(p_2232->g_186.s1, "p_2232->g_186.s1", print_hash_value);
    transparent_crc(p_2232->g_186.s2, "p_2232->g_186.s2", print_hash_value);
    transparent_crc(p_2232->g_186.s3, "p_2232->g_186.s3", print_hash_value);
    transparent_crc(p_2232->g_186.s4, "p_2232->g_186.s4", print_hash_value);
    transparent_crc(p_2232->g_186.s5, "p_2232->g_186.s5", print_hash_value);
    transparent_crc(p_2232->g_186.s6, "p_2232->g_186.s6", print_hash_value);
    transparent_crc(p_2232->g_186.s7, "p_2232->g_186.s7", print_hash_value);
    transparent_crc(p_2232->g_187.s0, "p_2232->g_187.s0", print_hash_value);
    transparent_crc(p_2232->g_187.s1, "p_2232->g_187.s1", print_hash_value);
    transparent_crc(p_2232->g_187.s2, "p_2232->g_187.s2", print_hash_value);
    transparent_crc(p_2232->g_187.s3, "p_2232->g_187.s3", print_hash_value);
    transparent_crc(p_2232->g_187.s4, "p_2232->g_187.s4", print_hash_value);
    transparent_crc(p_2232->g_187.s5, "p_2232->g_187.s5", print_hash_value);
    transparent_crc(p_2232->g_187.s6, "p_2232->g_187.s6", print_hash_value);
    transparent_crc(p_2232->g_187.s7, "p_2232->g_187.s7", print_hash_value);
    transparent_crc(p_2232->g_232, "p_2232->g_232", print_hash_value);
    transparent_crc(p_2232->g_242.x, "p_2232->g_242.x", print_hash_value);
    transparent_crc(p_2232->g_242.y, "p_2232->g_242.y", print_hash_value);
    transparent_crc(p_2232->g_242.z, "p_2232->g_242.z", print_hash_value);
    transparent_crc(p_2232->g_242.w, "p_2232->g_242.w", print_hash_value);
    transparent_crc(p_2232->g_253.s0, "p_2232->g_253.s0", print_hash_value);
    transparent_crc(p_2232->g_253.s1, "p_2232->g_253.s1", print_hash_value);
    transparent_crc(p_2232->g_253.s2, "p_2232->g_253.s2", print_hash_value);
    transparent_crc(p_2232->g_253.s3, "p_2232->g_253.s3", print_hash_value);
    transparent_crc(p_2232->g_253.s4, "p_2232->g_253.s4", print_hash_value);
    transparent_crc(p_2232->g_253.s5, "p_2232->g_253.s5", print_hash_value);
    transparent_crc(p_2232->g_253.s6, "p_2232->g_253.s6", print_hash_value);
    transparent_crc(p_2232->g_253.s7, "p_2232->g_253.s7", print_hash_value);
    transparent_crc(p_2232->g_267.s0, "p_2232->g_267.s0", print_hash_value);
    transparent_crc(p_2232->g_267.s1, "p_2232->g_267.s1", print_hash_value);
    transparent_crc(p_2232->g_267.s2, "p_2232->g_267.s2", print_hash_value);
    transparent_crc(p_2232->g_267.s3, "p_2232->g_267.s3", print_hash_value);
    transparent_crc(p_2232->g_267.s4, "p_2232->g_267.s4", print_hash_value);
    transparent_crc(p_2232->g_267.s5, "p_2232->g_267.s5", print_hash_value);
    transparent_crc(p_2232->g_267.s6, "p_2232->g_267.s6", print_hash_value);
    transparent_crc(p_2232->g_267.s7, "p_2232->g_267.s7", print_hash_value);
    transparent_crc(p_2232->g_272.x, "p_2232->g_272.x", print_hash_value);
    transparent_crc(p_2232->g_272.y, "p_2232->g_272.y", print_hash_value);
    transparent_crc(p_2232->g_276.x, "p_2232->g_276.x", print_hash_value);
    transparent_crc(p_2232->g_276.y, "p_2232->g_276.y", print_hash_value);
    transparent_crc(p_2232->g_276.z, "p_2232->g_276.z", print_hash_value);
    transparent_crc(p_2232->g_276.w, "p_2232->g_276.w", print_hash_value);
    transparent_crc(p_2232->g_306.s0, "p_2232->g_306.s0", print_hash_value);
    transparent_crc(p_2232->g_306.s1, "p_2232->g_306.s1", print_hash_value);
    transparent_crc(p_2232->g_306.s2, "p_2232->g_306.s2", print_hash_value);
    transparent_crc(p_2232->g_306.s3, "p_2232->g_306.s3", print_hash_value);
    transparent_crc(p_2232->g_306.s4, "p_2232->g_306.s4", print_hash_value);
    transparent_crc(p_2232->g_306.s5, "p_2232->g_306.s5", print_hash_value);
    transparent_crc(p_2232->g_306.s6, "p_2232->g_306.s6", print_hash_value);
    transparent_crc(p_2232->g_306.s7, "p_2232->g_306.s7", print_hash_value);
    transparent_crc(p_2232->g_313.s0, "p_2232->g_313.s0", print_hash_value);
    transparent_crc(p_2232->g_313.s1, "p_2232->g_313.s1", print_hash_value);
    transparent_crc(p_2232->g_313.s2, "p_2232->g_313.s2", print_hash_value);
    transparent_crc(p_2232->g_313.s3, "p_2232->g_313.s3", print_hash_value);
    transparent_crc(p_2232->g_313.s4, "p_2232->g_313.s4", print_hash_value);
    transparent_crc(p_2232->g_313.s5, "p_2232->g_313.s5", print_hash_value);
    transparent_crc(p_2232->g_313.s6, "p_2232->g_313.s6", print_hash_value);
    transparent_crc(p_2232->g_313.s7, "p_2232->g_313.s7", print_hash_value);
    transparent_crc(p_2232->g_313.s8, "p_2232->g_313.s8", print_hash_value);
    transparent_crc(p_2232->g_313.s9, "p_2232->g_313.s9", print_hash_value);
    transparent_crc(p_2232->g_313.sa, "p_2232->g_313.sa", print_hash_value);
    transparent_crc(p_2232->g_313.sb, "p_2232->g_313.sb", print_hash_value);
    transparent_crc(p_2232->g_313.sc, "p_2232->g_313.sc", print_hash_value);
    transparent_crc(p_2232->g_313.sd, "p_2232->g_313.sd", print_hash_value);
    transparent_crc(p_2232->g_313.se, "p_2232->g_313.se", print_hash_value);
    transparent_crc(p_2232->g_313.sf, "p_2232->g_313.sf", print_hash_value);
    transparent_crc(p_2232->g_317.x, "p_2232->g_317.x", print_hash_value);
    transparent_crc(p_2232->g_317.y, "p_2232->g_317.y", print_hash_value);
    transparent_crc(p_2232->g_320.s0, "p_2232->g_320.s0", print_hash_value);
    transparent_crc(p_2232->g_320.s1, "p_2232->g_320.s1", print_hash_value);
    transparent_crc(p_2232->g_320.s2, "p_2232->g_320.s2", print_hash_value);
    transparent_crc(p_2232->g_320.s3, "p_2232->g_320.s3", print_hash_value);
    transparent_crc(p_2232->g_320.s4, "p_2232->g_320.s4", print_hash_value);
    transparent_crc(p_2232->g_320.s5, "p_2232->g_320.s5", print_hash_value);
    transparent_crc(p_2232->g_320.s6, "p_2232->g_320.s6", print_hash_value);
    transparent_crc(p_2232->g_320.s7, "p_2232->g_320.s7", print_hash_value);
    transparent_crc(p_2232->g_331.x, "p_2232->g_331.x", print_hash_value);
    transparent_crc(p_2232->g_331.y, "p_2232->g_331.y", print_hash_value);
    transparent_crc(p_2232->g_354, "p_2232->g_354", print_hash_value);
    transparent_crc(p_2232->g_374.x, "p_2232->g_374.x", print_hash_value);
    transparent_crc(p_2232->g_374.y, "p_2232->g_374.y", print_hash_value);
    transparent_crc(p_2232->g_374.z, "p_2232->g_374.z", print_hash_value);
    transparent_crc(p_2232->g_374.w, "p_2232->g_374.w", print_hash_value);
    transparent_crc(p_2232->g_386.s0, "p_2232->g_386.s0", print_hash_value);
    transparent_crc(p_2232->g_386.s1, "p_2232->g_386.s1", print_hash_value);
    transparent_crc(p_2232->g_386.s2, "p_2232->g_386.s2", print_hash_value);
    transparent_crc(p_2232->g_386.s3, "p_2232->g_386.s3", print_hash_value);
    transparent_crc(p_2232->g_386.s4, "p_2232->g_386.s4", print_hash_value);
    transparent_crc(p_2232->g_386.s5, "p_2232->g_386.s5", print_hash_value);
    transparent_crc(p_2232->g_386.s6, "p_2232->g_386.s6", print_hash_value);
    transparent_crc(p_2232->g_386.s7, "p_2232->g_386.s7", print_hash_value);
    transparent_crc(p_2232->g_387.s0, "p_2232->g_387.s0", print_hash_value);
    transparent_crc(p_2232->g_387.s1, "p_2232->g_387.s1", print_hash_value);
    transparent_crc(p_2232->g_387.s2, "p_2232->g_387.s2", print_hash_value);
    transparent_crc(p_2232->g_387.s3, "p_2232->g_387.s3", print_hash_value);
    transparent_crc(p_2232->g_387.s4, "p_2232->g_387.s4", print_hash_value);
    transparent_crc(p_2232->g_387.s5, "p_2232->g_387.s5", print_hash_value);
    transparent_crc(p_2232->g_387.s6, "p_2232->g_387.s6", print_hash_value);
    transparent_crc(p_2232->g_387.s7, "p_2232->g_387.s7", print_hash_value);
    transparent_crc(p_2232->g_387.s8, "p_2232->g_387.s8", print_hash_value);
    transparent_crc(p_2232->g_387.s9, "p_2232->g_387.s9", print_hash_value);
    transparent_crc(p_2232->g_387.sa, "p_2232->g_387.sa", print_hash_value);
    transparent_crc(p_2232->g_387.sb, "p_2232->g_387.sb", print_hash_value);
    transparent_crc(p_2232->g_387.sc, "p_2232->g_387.sc", print_hash_value);
    transparent_crc(p_2232->g_387.sd, "p_2232->g_387.sd", print_hash_value);
    transparent_crc(p_2232->g_387.se, "p_2232->g_387.se", print_hash_value);
    transparent_crc(p_2232->g_387.sf, "p_2232->g_387.sf", print_hash_value);
    transparent_crc(p_2232->g_395.s0, "p_2232->g_395.s0", print_hash_value);
    transparent_crc(p_2232->g_395.s1, "p_2232->g_395.s1", print_hash_value);
    transparent_crc(p_2232->g_395.s2, "p_2232->g_395.s2", print_hash_value);
    transparent_crc(p_2232->g_395.s3, "p_2232->g_395.s3", print_hash_value);
    transparent_crc(p_2232->g_395.s4, "p_2232->g_395.s4", print_hash_value);
    transparent_crc(p_2232->g_395.s5, "p_2232->g_395.s5", print_hash_value);
    transparent_crc(p_2232->g_395.s6, "p_2232->g_395.s6", print_hash_value);
    transparent_crc(p_2232->g_395.s7, "p_2232->g_395.s7", print_hash_value);
    transparent_crc(p_2232->g_395.s8, "p_2232->g_395.s8", print_hash_value);
    transparent_crc(p_2232->g_395.s9, "p_2232->g_395.s9", print_hash_value);
    transparent_crc(p_2232->g_395.sa, "p_2232->g_395.sa", print_hash_value);
    transparent_crc(p_2232->g_395.sb, "p_2232->g_395.sb", print_hash_value);
    transparent_crc(p_2232->g_395.sc, "p_2232->g_395.sc", print_hash_value);
    transparent_crc(p_2232->g_395.sd, "p_2232->g_395.sd", print_hash_value);
    transparent_crc(p_2232->g_395.se, "p_2232->g_395.se", print_hash_value);
    transparent_crc(p_2232->g_395.sf, "p_2232->g_395.sf", print_hash_value);
    transparent_crc(p_2232->g_399.s0, "p_2232->g_399.s0", print_hash_value);
    transparent_crc(p_2232->g_399.s1, "p_2232->g_399.s1", print_hash_value);
    transparent_crc(p_2232->g_399.s2, "p_2232->g_399.s2", print_hash_value);
    transparent_crc(p_2232->g_399.s3, "p_2232->g_399.s3", print_hash_value);
    transparent_crc(p_2232->g_399.s4, "p_2232->g_399.s4", print_hash_value);
    transparent_crc(p_2232->g_399.s5, "p_2232->g_399.s5", print_hash_value);
    transparent_crc(p_2232->g_399.s6, "p_2232->g_399.s6", print_hash_value);
    transparent_crc(p_2232->g_399.s7, "p_2232->g_399.s7", print_hash_value);
    transparent_crc(p_2232->g_402.s0, "p_2232->g_402.s0", print_hash_value);
    transparent_crc(p_2232->g_402.s1, "p_2232->g_402.s1", print_hash_value);
    transparent_crc(p_2232->g_402.s2, "p_2232->g_402.s2", print_hash_value);
    transparent_crc(p_2232->g_402.s3, "p_2232->g_402.s3", print_hash_value);
    transparent_crc(p_2232->g_402.s4, "p_2232->g_402.s4", print_hash_value);
    transparent_crc(p_2232->g_402.s5, "p_2232->g_402.s5", print_hash_value);
    transparent_crc(p_2232->g_402.s6, "p_2232->g_402.s6", print_hash_value);
    transparent_crc(p_2232->g_402.s7, "p_2232->g_402.s7", print_hash_value);
    transparent_crc(p_2232->g_402.s8, "p_2232->g_402.s8", print_hash_value);
    transparent_crc(p_2232->g_402.s9, "p_2232->g_402.s9", print_hash_value);
    transparent_crc(p_2232->g_402.sa, "p_2232->g_402.sa", print_hash_value);
    transparent_crc(p_2232->g_402.sb, "p_2232->g_402.sb", print_hash_value);
    transparent_crc(p_2232->g_402.sc, "p_2232->g_402.sc", print_hash_value);
    transparent_crc(p_2232->g_402.sd, "p_2232->g_402.sd", print_hash_value);
    transparent_crc(p_2232->g_402.se, "p_2232->g_402.se", print_hash_value);
    transparent_crc(p_2232->g_402.sf, "p_2232->g_402.sf", print_hash_value);
    transparent_crc(p_2232->g_696, "p_2232->g_696", print_hash_value);
    transparent_crc(p_2232->g_710.x, "p_2232->g_710.x", print_hash_value);
    transparent_crc(p_2232->g_710.y, "p_2232->g_710.y", print_hash_value);
    transparent_crc(p_2232->g_710.z, "p_2232->g_710.z", print_hash_value);
    transparent_crc(p_2232->g_710.w, "p_2232->g_710.w", print_hash_value);
    transparent_crc(p_2232->g_711.x, "p_2232->g_711.x", print_hash_value);
    transparent_crc(p_2232->g_711.y, "p_2232->g_711.y", print_hash_value);
    transparent_crc(p_2232->g_712.x, "p_2232->g_712.x", print_hash_value);
    transparent_crc(p_2232->g_712.y, "p_2232->g_712.y", print_hash_value);
    transparent_crc(p_2232->g_712.z, "p_2232->g_712.z", print_hash_value);
    transparent_crc(p_2232->g_712.w, "p_2232->g_712.w", print_hash_value);
    transparent_crc(p_2232->g_769.x, "p_2232->g_769.x", print_hash_value);
    transparent_crc(p_2232->g_769.y, "p_2232->g_769.y", print_hash_value);
    transparent_crc(p_2232->g_770.s0, "p_2232->g_770.s0", print_hash_value);
    transparent_crc(p_2232->g_770.s1, "p_2232->g_770.s1", print_hash_value);
    transparent_crc(p_2232->g_770.s2, "p_2232->g_770.s2", print_hash_value);
    transparent_crc(p_2232->g_770.s3, "p_2232->g_770.s3", print_hash_value);
    transparent_crc(p_2232->g_770.s4, "p_2232->g_770.s4", print_hash_value);
    transparent_crc(p_2232->g_770.s5, "p_2232->g_770.s5", print_hash_value);
    transparent_crc(p_2232->g_770.s6, "p_2232->g_770.s6", print_hash_value);
    transparent_crc(p_2232->g_770.s7, "p_2232->g_770.s7", print_hash_value);
    transparent_crc(p_2232->g_777.s0, "p_2232->g_777.s0", print_hash_value);
    transparent_crc(p_2232->g_777.s1, "p_2232->g_777.s1", print_hash_value);
    transparent_crc(p_2232->g_777.s2, "p_2232->g_777.s2", print_hash_value);
    transparent_crc(p_2232->g_777.s3, "p_2232->g_777.s3", print_hash_value);
    transparent_crc(p_2232->g_777.s4, "p_2232->g_777.s4", print_hash_value);
    transparent_crc(p_2232->g_777.s5, "p_2232->g_777.s5", print_hash_value);
    transparent_crc(p_2232->g_777.s6, "p_2232->g_777.s6", print_hash_value);
    transparent_crc(p_2232->g_777.s7, "p_2232->g_777.s7", print_hash_value);
    transparent_crc(p_2232->g_777.s8, "p_2232->g_777.s8", print_hash_value);
    transparent_crc(p_2232->g_777.s9, "p_2232->g_777.s9", print_hash_value);
    transparent_crc(p_2232->g_777.sa, "p_2232->g_777.sa", print_hash_value);
    transparent_crc(p_2232->g_777.sb, "p_2232->g_777.sb", print_hash_value);
    transparent_crc(p_2232->g_777.sc, "p_2232->g_777.sc", print_hash_value);
    transparent_crc(p_2232->g_777.sd, "p_2232->g_777.sd", print_hash_value);
    transparent_crc(p_2232->g_777.se, "p_2232->g_777.se", print_hash_value);
    transparent_crc(p_2232->g_777.sf, "p_2232->g_777.sf", print_hash_value);
    transparent_crc(p_2232->g_800, "p_2232->g_800", print_hash_value);
    transparent_crc(p_2232->g_802, "p_2232->g_802", print_hash_value);
    transparent_crc(p_2232->g_824.s0, "p_2232->g_824.s0", print_hash_value);
    transparent_crc(p_2232->g_824.s1, "p_2232->g_824.s1", print_hash_value);
    transparent_crc(p_2232->g_824.s2, "p_2232->g_824.s2", print_hash_value);
    transparent_crc(p_2232->g_824.s3, "p_2232->g_824.s3", print_hash_value);
    transparent_crc(p_2232->g_824.s4, "p_2232->g_824.s4", print_hash_value);
    transparent_crc(p_2232->g_824.s5, "p_2232->g_824.s5", print_hash_value);
    transparent_crc(p_2232->g_824.s6, "p_2232->g_824.s6", print_hash_value);
    transparent_crc(p_2232->g_824.s7, "p_2232->g_824.s7", print_hash_value);
    transparent_crc(p_2232->g_824.s8, "p_2232->g_824.s8", print_hash_value);
    transparent_crc(p_2232->g_824.s9, "p_2232->g_824.s9", print_hash_value);
    transparent_crc(p_2232->g_824.sa, "p_2232->g_824.sa", print_hash_value);
    transparent_crc(p_2232->g_824.sb, "p_2232->g_824.sb", print_hash_value);
    transparent_crc(p_2232->g_824.sc, "p_2232->g_824.sc", print_hash_value);
    transparent_crc(p_2232->g_824.sd, "p_2232->g_824.sd", print_hash_value);
    transparent_crc(p_2232->g_824.se, "p_2232->g_824.se", print_hash_value);
    transparent_crc(p_2232->g_824.sf, "p_2232->g_824.sf", print_hash_value);
    for (i = 0; i < 10; i++)
    {
        for (j = 0; j < 2; j++)
        {
            transparent_crc(p_2232->g_860[i][j], "p_2232->g_860[i][j]", print_hash_value);

        }
    }
    transparent_crc(p_2232->g_872.s0, "p_2232->g_872.s0", print_hash_value);
    transparent_crc(p_2232->g_872.s1, "p_2232->g_872.s1", print_hash_value);
    transparent_crc(p_2232->g_872.s2, "p_2232->g_872.s2", print_hash_value);
    transparent_crc(p_2232->g_872.s3, "p_2232->g_872.s3", print_hash_value);
    transparent_crc(p_2232->g_872.s4, "p_2232->g_872.s4", print_hash_value);
    transparent_crc(p_2232->g_872.s5, "p_2232->g_872.s5", print_hash_value);
    transparent_crc(p_2232->g_872.s6, "p_2232->g_872.s6", print_hash_value);
    transparent_crc(p_2232->g_872.s7, "p_2232->g_872.s7", print_hash_value);
    transparent_crc(p_2232->g_878.s0, "p_2232->g_878.s0", print_hash_value);
    transparent_crc(p_2232->g_878.s1, "p_2232->g_878.s1", print_hash_value);
    transparent_crc(p_2232->g_878.s2, "p_2232->g_878.s2", print_hash_value);
    transparent_crc(p_2232->g_878.s3, "p_2232->g_878.s3", print_hash_value);
    transparent_crc(p_2232->g_878.s4, "p_2232->g_878.s4", print_hash_value);
    transparent_crc(p_2232->g_878.s5, "p_2232->g_878.s5", print_hash_value);
    transparent_crc(p_2232->g_878.s6, "p_2232->g_878.s6", print_hash_value);
    transparent_crc(p_2232->g_878.s7, "p_2232->g_878.s7", print_hash_value);
    transparent_crc(p_2232->g_879.x, "p_2232->g_879.x", print_hash_value);
    transparent_crc(p_2232->g_879.y, "p_2232->g_879.y", print_hash_value);
    transparent_crc(p_2232->g_879.z, "p_2232->g_879.z", print_hash_value);
    transparent_crc(p_2232->g_879.w, "p_2232->g_879.w", print_hash_value);
    transparent_crc(p_2232->g_889, "p_2232->g_889", print_hash_value);
    transparent_crc(p_2232->g_908, "p_2232->g_908", print_hash_value);
    transparent_crc(p_2232->g_924.x, "p_2232->g_924.x", print_hash_value);
    transparent_crc(p_2232->g_924.y, "p_2232->g_924.y", print_hash_value);
    transparent_crc(p_2232->g_946.s0, "p_2232->g_946.s0", print_hash_value);
    transparent_crc(p_2232->g_946.s1, "p_2232->g_946.s1", print_hash_value);
    transparent_crc(p_2232->g_946.s2, "p_2232->g_946.s2", print_hash_value);
    transparent_crc(p_2232->g_946.s3, "p_2232->g_946.s3", print_hash_value);
    transparent_crc(p_2232->g_946.s4, "p_2232->g_946.s4", print_hash_value);
    transparent_crc(p_2232->g_946.s5, "p_2232->g_946.s5", print_hash_value);
    transparent_crc(p_2232->g_946.s6, "p_2232->g_946.s6", print_hash_value);
    transparent_crc(p_2232->g_946.s7, "p_2232->g_946.s7", print_hash_value);
    transparent_crc(p_2232->g_1868.s0, "p_2232->g_1868.s0", print_hash_value);
    transparent_crc(p_2232->g_1868.s1, "p_2232->g_1868.s1", print_hash_value);
    transparent_crc(p_2232->g_1868.s2, "p_2232->g_1868.s2", print_hash_value);
    transparent_crc(p_2232->g_1868.s3, "p_2232->g_1868.s3", print_hash_value);
    transparent_crc(p_2232->g_1868.s4, "p_2232->g_1868.s4", print_hash_value);
    transparent_crc(p_2232->g_1868.s5, "p_2232->g_1868.s5", print_hash_value);
    transparent_crc(p_2232->g_1868.s6, "p_2232->g_1868.s6", print_hash_value);
    transparent_crc(p_2232->g_1868.s7, "p_2232->g_1868.s7", print_hash_value);
    transparent_crc(p_2232->g_2080, "p_2232->g_2080", print_hash_value);
    transparent_crc(p_2232->g_2176.x, "p_2232->g_2176.x", print_hash_value);
    transparent_crc(p_2232->g_2176.y, "p_2232->g_2176.y", print_hash_value);
    transparent_crc(p_2232->g_2189.s0, "p_2232->g_2189.s0", print_hash_value);
    transparent_crc(p_2232->g_2189.s1, "p_2232->g_2189.s1", print_hash_value);
    transparent_crc(p_2232->g_2189.s2, "p_2232->g_2189.s2", print_hash_value);
    transparent_crc(p_2232->g_2189.s3, "p_2232->g_2189.s3", print_hash_value);
    transparent_crc(p_2232->g_2189.s4, "p_2232->g_2189.s4", print_hash_value);
    transparent_crc(p_2232->g_2189.s5, "p_2232->g_2189.s5", print_hash_value);
    transparent_crc(p_2232->g_2189.s6, "p_2232->g_2189.s6", print_hash_value);
    transparent_crc(p_2232->g_2189.s7, "p_2232->g_2189.s7", print_hash_value);
    transparent_crc(p_2232->g_2189.s8, "p_2232->g_2189.s8", print_hash_value);
    transparent_crc(p_2232->g_2189.s9, "p_2232->g_2189.s9", print_hash_value);
    transparent_crc(p_2232->g_2189.sa, "p_2232->g_2189.sa", print_hash_value);
    transparent_crc(p_2232->g_2189.sb, "p_2232->g_2189.sb", print_hash_value);
    transparent_crc(p_2232->g_2189.sc, "p_2232->g_2189.sc", print_hash_value);
    transparent_crc(p_2232->g_2189.sd, "p_2232->g_2189.sd", print_hash_value);
    transparent_crc(p_2232->g_2189.se, "p_2232->g_2189.se", print_hash_value);
    transparent_crc(p_2232->g_2189.sf, "p_2232->g_2189.sf", print_hash_value);
    transparent_crc(p_2232->g_2191.x, "p_2232->g_2191.x", print_hash_value);
    transparent_crc(p_2232->g_2191.y, "p_2232->g_2191.y", print_hash_value);
    transparent_crc(p_2232->g_2191.z, "p_2232->g_2191.z", print_hash_value);
    transparent_crc(p_2232->g_2191.w, "p_2232->g_2191.w", print_hash_value);
    transparent_crc(p_2232->g_2192.x, "p_2232->g_2192.x", print_hash_value);
    transparent_crc(p_2232->g_2192.y, "p_2232->g_2192.y", print_hash_value);
    transparent_crc(p_2232->g_2192.z, "p_2232->g_2192.z", print_hash_value);
    transparent_crc(p_2232->g_2192.w, "p_2232->g_2192.w", print_hash_value);
    transparent_crc(p_2232->g_2194.x, "p_2232->g_2194.x", print_hash_value);
    transparent_crc(p_2232->g_2194.y, "p_2232->g_2194.y", print_hash_value);
    transparent_crc(p_2232->g_2194.z, "p_2232->g_2194.z", print_hash_value);
    transparent_crc(p_2232->g_2194.w, "p_2232->g_2194.w", print_hash_value);
    transparent_crc(p_2232->g_2195.s0, "p_2232->g_2195.s0", print_hash_value);
    transparent_crc(p_2232->g_2195.s1, "p_2232->g_2195.s1", print_hash_value);
    transparent_crc(p_2232->g_2195.s2, "p_2232->g_2195.s2", print_hash_value);
    transparent_crc(p_2232->g_2195.s3, "p_2232->g_2195.s3", print_hash_value);
    transparent_crc(p_2232->g_2195.s4, "p_2232->g_2195.s4", print_hash_value);
    transparent_crc(p_2232->g_2195.s5, "p_2232->g_2195.s5", print_hash_value);
    transparent_crc(p_2232->g_2195.s6, "p_2232->g_2195.s6", print_hash_value);
    transparent_crc(p_2232->g_2195.s7, "p_2232->g_2195.s7", print_hash_value);
    transparent_crc(p_2232->g_2196.s0, "p_2232->g_2196.s0", print_hash_value);
    transparent_crc(p_2232->g_2196.s1, "p_2232->g_2196.s1", print_hash_value);
    transparent_crc(p_2232->g_2196.s2, "p_2232->g_2196.s2", print_hash_value);
    transparent_crc(p_2232->g_2196.s3, "p_2232->g_2196.s3", print_hash_value);
    transparent_crc(p_2232->g_2196.s4, "p_2232->g_2196.s4", print_hash_value);
    transparent_crc(p_2232->g_2196.s5, "p_2232->g_2196.s5", print_hash_value);
    transparent_crc(p_2232->g_2196.s6, "p_2232->g_2196.s6", print_hash_value);
    transparent_crc(p_2232->g_2196.s7, "p_2232->g_2196.s7", print_hash_value);
    transparent_crc(p_2232->g_2209.s0, "p_2232->g_2209.s0", print_hash_value);
    transparent_crc(p_2232->g_2209.s1, "p_2232->g_2209.s1", print_hash_value);
    transparent_crc(p_2232->g_2209.s2, "p_2232->g_2209.s2", print_hash_value);
    transparent_crc(p_2232->g_2209.s3, "p_2232->g_2209.s3", print_hash_value);
    transparent_crc(p_2232->g_2209.s4, "p_2232->g_2209.s4", print_hash_value);
    transparent_crc(p_2232->g_2209.s5, "p_2232->g_2209.s5", print_hash_value);
    transparent_crc(p_2232->g_2209.s6, "p_2232->g_2209.s6", print_hash_value);
    transparent_crc(p_2232->g_2209.s7, "p_2232->g_2209.s7", print_hash_value);
    transparent_crc(p_2232->g_2215.x, "p_2232->g_2215.x", print_hash_value);
    transparent_crc(p_2232->g_2215.y, "p_2232->g_2215.y", print_hash_value);
    transparent_crc(p_2232->v_collective, "p_2232->v_collective", print_hash_value);
    barrier(CLK_LOCAL_MEM_FENCE | CLK_GLOBAL_MEM_FENCE);
    if (!get_linear_global_id())
        for (i = 0 ; i < 69; i++)
            transparent_crc(p_2232->g_special_values[i + 69 * get_linear_group_id()], "p_2232->g_special_values[i + 69 * get_linear_group_id()]", print_hash_value);
    barrier(CLK_LOCAL_MEM_FENCE | CLK_GLOBAL_MEM_FENCE);
    if (!get_linear_local_id())
        for (i = 0; i < 69; i++)
            transparent_crc(p_2232->l_special_values[i], "p_2232->l_special_values[i]", print_hash_value);
    transparent_crc(p_2232->l_comm_values[get_linear_local_id()], "p_2232->l_comm_values[get_linear_local_id()]", print_hash_value);
    transparent_crc(p_2232->g_comm_values[get_linear_global_id()], "p_2232->g_comm_values[get_linear_global_id()]", print_hash_value);
    result[get_linear_global_id()] = crc64_context ^ 0xFFFFFFFFFFFFFFFFUL;
}
