// -g 1,1,9935 -l 1,1,1
#define int64_t long
#define uint64_t ulong
#define int_least64_t long
#define uint_least64_t ulong
#define int_fast64_t long
#define uint_fast64_t ulong
#define intmax_t long
#define uintmax_t ulong
#define int32_t int
#define uint32_t uint
#define int16_t short
#define uint16_t ushort
#define int8_t char
#define uint8_t uchar

#define INT64_MIN LONG_MIN
#define INT64_MAX LONG_MAX
#define INT32_MIN INT_MIN
#define INT32_MAX INT_MAX
#define INT16_MIN SHRT_MIN
#define INT16_MAX SHRT_MAX
#define INT8_MIN CHAR_MIN
#define INT8_MAX CHAR_MAX
#define UINT64_MIN ULONG_MIN
#define UINT64_MAX ULONG_MAX
#define UINT32_MIN UINT_MIN
#define UINT32_MAX UINT_MAX
#define UINT16_MIN USHRT_MIN
#define UINT16_MAX USHRT_MAX
#define UINT8_MIN UCHAR_MIN
#define UINT8_MAX UCHAR_MAX

#define transparent_crc(X, Y, Z) transparent_crc_(&crc64_context, X, Y, Z)

#include "CLSmith.h"

struct S0 {
   int64_t  f0;
   int32_t  f1;
   uint32_t  f2;
   uint64_t  f3;
   uint32_t  f4;
   uint16_t  f5;
   uint64_t  f6;
   uint16_t  f7;
   int8_t  f8;
   volatile int32_t  f9;
};

union U1 {
   int8_t  f0;
   int32_t  f1;
   struct S0  f2;
};

struct S2 {
    uint16_t g_10;
    int32_t g_12;
    int32_t *g_50;
    struct S0 g_288;
    union U1 g_611[3];
    struct S0 g_1007;
    union U1 g_1060;
    struct S0 g_1166;
    union U1 g_1273;
    volatile uint64_t g_1289[8];
};

__kernel void entry(__global ulong *result) {
    int i, j, k;
    struct S2 c_2626;
    struct S2* p_2625 = &c_2626;
    struct S2 c_2627 = {
        65535UL, // p_2625->g_10
        0x34688073L, // p_2625->g_12
        &p_2625->g_12, // p_2625->g_50
        {0x272EEDA3B71BF53AL,0x1702607DL,0x25DC2EB6L,0xA9DCE3C7A173E98AL,0x15F02B78L,0x9705L,18446744073709551615UL,0x084EL,-4L,0x3FA67C54L}, // p_2625->g_288
        {{1L},{1L},{1L}}, // p_2625->g_611
        {0x5524F38554E0770BL,-1L,0x9C36B664L,0UL,0x0541983AL,3UL,0x39972FB6FDDE304FL,0x308CL,0x53L,0x15B553A6L}, // p_2625->g_1007
        {1L}, // p_2625->g_1060
        {0x4F5D17DAB84FE217L,0x60FA1814L,0x6CC7703DL,0x5451B2A1BDEED0CEL,0xA95269E1L,2UL,1UL,0xE574L,1L,0x3E1761CBL}, // p_2625->g_1166
        {1L}, // p_2625->g_1273
        {0xAFB9EC3180EEAB3FL,18446744073709551615UL,0xAFB9EC3180EEAB3FL,0xAFB9EC3180EEAB3FL,18446744073709551615UL,0xAFB9EC3180EEAB3FL,0xAFB9EC3180EEAB3FL,18446744073709551615UL}, // p_2625->g_1289
    };
    c_2626 = c_2627;
    uint64_t crc64_context = 0UL;
    for (i = 0; i < 3; ++i) crc64_context += p_2625->g_611[i].f0;
    crc64_context += p_2625->g_1060.f0;
    crc64_context += p_2625->g_1273.f0;
    result[get_linear_global_id()] = crc64_context;
}
