// ---fake_divergence -g 13,1,769 -l 13,1,1
#define int64_t long
#define uint64_t ulong
#define int_least64_t long
#define uint_least64_t ulong
#define int_fast64_t long
#define uint_fast64_t ulong
#define intmax_t long
#define uintmax_t ulong
#define int32_t int
#define uint32_t uint
#define int16_t short
#define uint16_t ushort
#define int8_t char
#define uint8_t uchar

#define INT64_MIN LONG_MIN
#define INT64_MAX LONG_MAX
#define INT32_MIN INT_MIN
#define INT32_MAX INT_MAX
#define INT16_MIN SHRT_MIN
#define INT16_MAX SHRT_MAX
#define INT8_MIN CHAR_MIN
#define INT8_MAX CHAR_MAX
#define UINT64_MIN ULONG_MIN
#define UINT64_MAX ULONG_MAX
#define UINT32_MIN UINT_MIN
#define UINT32_MAX UINT_MAX
#define UINT16_MIN USHRT_MIN
#define UINT16_MAX USHRT_MAX
#define UINT8_MIN UCHAR_MIN
#define UINT8_MAX UCHAR_MAX

#define VECTOR(X , Y) VECTOR_(X, Y)
#define VECTOR_(X, Y) X##Y

#ifndef NO_FAKE_DIVERGENCE
#define FAKE_DIVERGE(x, y, z) (x - y)
#else
#define FAKE_DIVERGE(x, y, z) (z)
#endif

// Seed: 7958

#include "CLSmith.h"

/* --- Struct/Union Declarations --- */
struct S0 {
   uint64_t  f0;
   int32_t  f1;
   uint32_t  f2;
   uint8_t  f3;
   int32_t  f4;
   int8_t  f5;
   int64_t  f6;
   int64_t  f7;
};

struct S1 {
    volatile int16_t g_23;
    uint32_t g_25;
    volatile uint32_t g_51[8][6][4];
    volatile uint32_t *g_50;
    uint32_t g_55[9];
    uint32_t *g_54;
    VECTOR(uint64_t, 2) g_67;
    VECTOR(uint64_t, 16) g_69;
    VECTOR(uint16_t, 8) g_84;
    VECTOR(uint16_t, 16) g_89;
    VECTOR(uint16_t, 2) g_90;
    struct S0 g_95[1];
    uint16_t g_103;
    int32_t g_106;
    VECTOR(int32_t, 2) g_111;
    VECTOR(int32_t, 8) g_112;
    VECTOR(int16_t, 8) g_118;
    VECTOR(int16_t, 8) g_121;
    int64_t g_134;
    VECTOR(int32_t, 8) g_158;
    VECTOR(int32_t, 8) g_159;
    uint64_t g_168;
    VECTOR(uint16_t, 2) g_174;
    uint32_t *g_180;
    struct S0 g_185;
    VECTOR(uint8_t, 8) g_232;
    VECTOR(uint8_t, 4) g_233;
    int64_t g_251;
    volatile int32_t * volatile g_254;
    volatile int32_t * volatile *g_253;
    int32_t *g_268;
    int32_t g_281;
    VECTOR(int8_t, 4) g_286;
    VECTOR(int8_t, 16) g_287;
    VECTOR(int8_t, 16) g_289;
    volatile struct S0 g_300;
    volatile struct S0 *g_299[10];
    volatile struct S0 * volatile *g_298[7][8];
    volatile struct S0 * volatile **g_297;
    VECTOR(int32_t, 8) g_318;
    VECTOR(uint16_t, 8) g_376;
    uint64_t *g_400;
    uint64_t **g_399;
    int16_t *g_452[9][9][1];
    VECTOR(uint64_t, 4) g_535;
    volatile int8_t g_562;
    volatile int8_t *g_561;
    uint32_t g_583;
    VECTOR(int32_t, 16) g_595;
    VECTOR(int64_t, 2) g_604;
    int32_t g_619;
    VECTOR(uint8_t, 8) g_642;
    VECTOR(int8_t, 2) g_644;
    VECTOR(uint8_t, 16) g_649;
    VECTOR(int8_t, 4) g_650;
    VECTOR(int8_t, 8) g_651;
    VECTOR(int8_t, 2) g_669;
    VECTOR(int8_t, 16) g_670;
    VECTOR(int8_t, 4) g_671;
    VECTOR(int16_t, 2) g_695;
    VECTOR(int16_t, 2) g_696;
    uint64_t * volatile g_705[9];
    uint64_t * volatile *g_704;
    VECTOR(uint16_t, 8) g_706;
    uint32_t g_711;
    VECTOR(int8_t, 8) g_758;
    VECTOR(int8_t, 8) g_759;
    VECTOR(int8_t, 16) g_760;
    VECTOR(uint8_t, 4) g_769;
    VECTOR(uint64_t, 2) g_799;
    VECTOR(int16_t, 8) g_831;
    VECTOR(int16_t, 16) g_838;
    VECTOR(int16_t, 16) g_839;
    VECTOR(int64_t, 16) g_846;
    VECTOR(int64_t, 8) g_856;
    VECTOR(int32_t, 4) g_901;
    VECTOR(int32_t, 2) g_902;
    VECTOR(int16_t, 8) g_903;
    uint64_t *g_918;
    uint64_t **g_917[3][2];
    VECTOR(int32_t, 16) g_925;
    int8_t g_1013;
    VECTOR(int32_t, 8) g_1032;
    int16_t g_1060;
    int16_t g_1062;
    volatile uint64_t **g_1074;
    volatile uint64_t ** volatile *g_1073[1];
    volatile uint64_t ** volatile **g_1072;
    VECTOR(int8_t, 16) g_1075;
    volatile int64_t **g_1087;
    VECTOR(int32_t, 4) g_1088;
    VECTOR(int32_t, 16) g_1090;
    VECTOR(int32_t, 2) g_1091;
    VECTOR(int32_t, 4) g_1092;
    VECTOR(int32_t, 16) g_1097;
    VECTOR(int8_t, 8) g_1098;
    int16_t g_1118;
    VECTOR(uint64_t, 16) g_1172;
    VECTOR(uint32_t, 2) g_1228;
    VECTOR(uint32_t, 2) g_1229;
    VECTOR(uint32_t, 8) g_1230;
    VECTOR(uint32_t, 4) g_1232;
    VECTOR(uint32_t, 16) g_1233;
    VECTOR(uint32_t, 2) g_1234;
    VECTOR(uint32_t, 4) g_1239;
    VECTOR(uint32_t, 4) g_1241;
    VECTOR(uint32_t, 8) g_1244;
    VECTOR(int8_t, 16) g_1245;
    uint32_t g_1249;
    VECTOR(uint64_t, 4) g_1261;
    VECTOR(uint64_t, 4) g_1262;
    VECTOR(uint64_t, 8) g_1266;
    VECTOR(uint64_t, 4) g_1267;
    VECTOR(int64_t, 16) g_1284;
    VECTOR(int16_t, 4) g_1288;
    int16_t g_1296;
    int64_t *g_1298[3][3][7];
    int64_t **g_1297;
    uint16_t g_1350;
    volatile VECTOR(int8_t, 8) g_1396;
    int32_t ** volatile g_1410;
    volatile uint32_t * volatile **g_1415;
    uint32_t g_1436;
    VECTOR(int8_t, 16) g_1449;
    VECTOR(int8_t, 16) g_1450;
    volatile VECTOR(int32_t, 2) g_1460;
    uint32_t **g_1503;
    uint32_t ***g_1502;
    volatile VECTOR(int8_t, 8) g_1508;
    VECTOR(int8_t, 4) g_1540;
    VECTOR(int8_t, 8) g_1541;
    VECTOR(int16_t, 2) g_1556;
    volatile VECTOR(uint16_t, 2) g_1563;
    VECTOR(int8_t, 16) g_1577;
    VECTOR(int8_t, 8) g_1578;
    VECTOR(uint32_t, 16) g_1611;
    VECTOR(uint64_t, 8) g_1636;
    volatile VECTOR(uint64_t, 8) g_1637;
    volatile VECTOR(int64_t, 2) g_1645;
    VECTOR(int64_t, 16) g_1651;
    VECTOR(int8_t, 2) g_1667;
    volatile VECTOR(int16_t, 4) g_1678;
    VECTOR(uint8_t, 2) g_1684;
    VECTOR(int64_t, 16) g_1687;
    uint64_t ***g_1701;
    uint32_t g_1707;
    VECTOR(int64_t, 4) g_1720;
    uint32_t g_1743;
    uint8_t g_1749;
    int32_t * volatile g_1764;
    uint64_t global_0_offset;
    uint64_t global_1_offset;
    uint64_t global_2_offset;
    uint64_t local_0_offset;
    uint64_t local_1_offset;
    uint64_t local_2_offset;
    uint64_t group_0_offset;
    uint64_t group_1_offset;
    uint64_t group_2_offset;
};

int32_t  func_1(struct S1 * p_1767);
int8_t  func_2(uint64_t  p_3, int64_t  p_4, struct S1 * p_1767);
uint64_t  func_5(int16_t  p_6, int32_t  p_7, int32_t  p_8, int32_t  p_9, struct S1 * p_1767);
int16_t  func_13(int64_t  p_14, struct S0  p_15, int32_t  p_16, int64_t  p_17, uint64_t  p_18, struct S1 * p_1767);
struct S0  func_19(uint32_t  p_20, int64_t  p_21, uint8_t  p_22, struct S1 * p_1767);
int32_t  func_26(uint32_t * p_27, uint32_t * p_28, uint32_t * p_29, uint8_t  p_30, struct S1 * p_1767);
uint32_t * func_31(int16_t  p_32, struct S1 * p_1767);
int8_t  func_37(uint32_t * p_38, struct S1 * p_1767);
uint32_t * func_39(uint8_t  p_40, uint32_t * p_41, uint32_t * p_42, uint32_t  p_43, struct S1 * p_1767);
uint32_t * func_45(uint32_t * p_46, uint64_t  p_47, uint32_t * p_48, uint32_t  p_49, struct S1 * p_1767);

int32_t  func_1(struct S1 * p_1767) {
    VECTOR(uint64_t, 8) l_12 = (VECTOR(uint64_t, 8))((VECTOR(uint64_t, 2))(0x2D714F98CAFA32FDL, 18446744073709551615UL), 0x2D714F98CAFA32FDL, 18446744073709551615UL, (VECTOR(uint64_t, 2))(0x2D714F98CAFA32FDL, 18446744073709551615UL), 0x2D714F98CAFA32FDL, 18446744073709551615UL);
    uint32_t *l_24 = &p_1767->g_25;
    int16_t l_44 = (-1L);
    uint32_t **l_56 = &p_1767->g_54;
    uint32_t *l_58 = &p_1767->g_55[3];
    uint32_t **l_57 = &l_58;
    uint32_t *l_60 = &p_1767->g_55[3];
    uint32_t **l_59 = &l_60;
    int16_t *l_712 = (void*)0;
    int16_t *l_713 = &l_44;
    int8_t *l_1383[6][3] = {{(void*)0,(void*)0,(void*)0},{(void*)0,(void*)0,(void*)0},{(void*)0,(void*)0,(void*)0},{(void*)0,(void*)0,(void*)0},{(void*)0,(void*)0,(void*)0},{(void*)0,(void*)0,(void*)0}};
    uint8_t l_1384 = 255UL;
    int32_t l_1404 = 6L;
    uint32_t l_1419[2][8][2] = {{{0xCB7E9A4DL,1UL},{0xCB7E9A4DL,1UL},{0xCB7E9A4DL,1UL},{0xCB7E9A4DL,1UL},{0xCB7E9A4DL,1UL},{0xCB7E9A4DL,1UL},{0xCB7E9A4DL,1UL},{0xCB7E9A4DL,1UL}},{{0xCB7E9A4DL,1UL},{0xCB7E9A4DL,1UL},{0xCB7E9A4DL,1UL},{0xCB7E9A4DL,1UL},{0xCB7E9A4DL,1UL},{0xCB7E9A4DL,1UL},{0xCB7E9A4DL,1UL},{0xCB7E9A4DL,1UL}}};
    int32_t l_1747[2];
    uint16_t l_1763 = 1UL;
    int32_t *l_1765 = (void*)0;
    int32_t *l_1766 = &p_1767->g_106;
    int i, j, k;
    for (i = 0; i < 2; i++)
        l_1747[i] = 6L;
    if ((((p_1767->g_1075.s5 = func_2(func_5(((FAKE_DIVERGE(get_local_id(1), p_1767->local_1_offset, 10) | ((((VECTOR(uint64_t, 8))((((VECTOR(uint64_t, 4))(clamp(((VECTOR(uint64_t, 16))(l_12.s4666516122253705)).sb647, ((VECTOR(uint64_t, 2))(upsample(((VECTOR(uint32_t, 8))((func_13(l_12.s2, func_19(((*l_24) = (65529UL | p_1767->g_23)), ((l_1384 &= (func_26(func_31(((*l_713) = (safe_lshift_func_int16_t_s_s((safe_mul_func_int8_t_s_s(func_37(func_39(l_44, ((*l_59) = func_45(l_24, (p_1767->g_50 != ((*l_59) = (((safe_lshift_func_int16_t_s_s((((*l_56) = p_1767->g_54) == ((*l_57) = (void*)0)), 0)) , l_44) , (*l_56)))), &p_1767->g_55[3], p_1767->g_55[3], p_1767)), &p_1767->g_55[3], p_1767->g_376.s5, p_1767), p_1767), l_12.s5)), l_44))), p_1767), &p_1767->g_55[3], &p_1767->g_55[6], p_1767->g_649.sf, p_1767) || p_1767->g_286.x)) > l_12.s0), p_1767->g_1228.y, p_1767), p_1767->g_111.x, l_12.s5, l_1404, p_1767) <= 65528UL), 0xF07D0321L, 0xC0263B19L, p_1767->g_185.f5, ((VECTOR(uint32_t, 2))(1UL)), 4294967295UL, 1UL)).s76, ((VECTOR(uint32_t, 2))(0x8014D1F5L))))).yyxy, ((VECTOR(uint64_t, 4))(0UL))))).xwxxxyxx + ((VECTOR(uint64_t, 8))(18446744073709551615UL))))).s6 >= l_1404) | l_12.s0)) , l_1384), p_1767->g_1234.x, l_12.s0, l_1419[1][2][1], p_1767), p_1767->g_670.sa, p_1767)) >= (-1L)) ^ FAKE_DIVERGE(get_group_id(0), p_1767->group_0_offset, 10)))
    {
        int64_t *l_1744 = &p_1767->g_134;
    }
    (*l_1766) &= l_1419[1][2][1];
    return (*l_1766);
}

int8_t  func_2(uint64_t  p_3, int64_t  p_4, struct S1 * p_1767) {
    VECTOR(int32_t, 16) l_1672 = (VECTOR(int32_t, 16))((VECTOR(int32_t, 4))((VECTOR(int32_t, 2))(0x55DEA337L, (-1L)), 0x55DEA337L, (-1L)), (VECTOR(int32_t, 4))(0x55DEA337L, (VECTOR(int32_t, 2))(0x55DEA337L, (-1L)), (-1L)), 0x55DEA337L, (-1L), 0x55DEA337L, (VECTOR(int32_t, 4))(0x55DEA337L, (-1L), 0x55DEA337L, (-1L)), (-1L));
    VECTOR(int16_t, 8) l_1679 = (VECTOR(int16_t, 8))(0x5921L, (-1L), (VECTOR(int16_t, 2))(0x5921L, (-1L)), (VECTOR(int16_t, 2))(0x5921L, (-1L)), 0x5921L, (-1L));
    uint32_t ***l_1685 = &p_1767->g_1503;
    uint64_t ****l_1694 = (void*)0;
    uint64_t ***l_1698 = &p_1767->g_917[1][1];
    uint16_t *l_1702 = (void*)0;
    uint16_t *l_1703 = (void*)0;
    uint16_t *l_1710 = &p_1767->g_1350;
    int32_t l_1715 = (-8L);
    int i, j, k;
    for (p_1767->g_185.f3 = (-13); (p_1767->g_185.f3 > 20); ++p_1767->g_185.f3)
    {
        uint16_t l_1675 = 65532UL;
        uint32_t ****l_1686 = &p_1767->g_1502;
        uint8_t *l_1690 = (void*)0;
        uint8_t *l_1691 = (void*)0;
        uint8_t *l_1692 = &p_1767->g_95[0].f3;
        struct S0 *l_1693 = &p_1767->g_95[0];
        int32_t *l_1695 = (void*)0;
        int32_t *l_1696 = (void*)0;
        int32_t *l_1697 = &p_1767->g_619;
        (*l_1697) |= ((VECTOR(int32_t, 4))(((VECTOR(int32_t, 2))((((VECTOR(int32_t, 8))(l_1672.s1ca07694)).s05 || ((VECTOR(int32_t, 16))((((VECTOR(int32_t, 2))((((VECTOR(int32_t, 8))(upsample(((VECTOR(int16_t, 4))(1L, (safe_lshift_func_int16_t_s_s(l_1675, ((((((*l_1693) = func_19((*p_1767->g_180), p_3, (safe_rshift_func_uint16_t_u_s((((VECTOR(int16_t, 16))((((VECTOR(int16_t, 16))(p_1767->g_1678.xwyxxxwwwwxyzxxy)) < ((VECTOR(int16_t, 8))(l_1679.s56047144)).s7430433134721733))).s5 & ((VECTOR(uint16_t, 8))((((VECTOR(uint16_t, 4))((((VECTOR(uint16_t, 8))(abs(((VECTOR(int16_t, 2))((((VECTOR(int16_t, 2))((-1L), 0x54E8L)) == ((VECTOR(int16_t, 16))(upsample(((VECTOR(int8_t, 4))(l_1672.sb, p_1767->g_121.s1, 0L, 0x29L)).yzyyzxwzxxyyzxww, ((VECTOR(uint8_t, 2))(max(((VECTOR(uint8_t, 8))(p_1767->g_1684.yxxyxxxy)).s03, (uint8_t)((l_1685 != ((*l_1686) = l_1685)) & ((l_1675 >= ((VECTOR(int64_t, 8))(0L, ((VECTOR(int64_t, 4))(max(((VECTOR(int64_t, 16))(p_1767->g_1687.s95b1b18042e1aee1)).s1363, (int64_t)(safe_mod_func_uint8_t_u_u(((*l_1692) = p_1767->g_1062), (-3L)))))), ((VECTOR(int64_t, 2))(4L)), 0x1A63C7B2EA050EF7L)).s3) , l_1679.s4))))).yxyyxyyxxyyyxxyx))).s51))).yyxxxyxx))).odd + ((VECTOR(uint16_t, 4))(0x1552L))))).wyxzywww + ((VECTOR(uint16_t, 8))(0UL))))).s2), 7)), p_1767)) , &p_1767->g_1073[0]) != l_1694) , l_1675) < p_3))), (-6L), 0x088DL)).zyxyxwwz, ((VECTOR(uint16_t, 8))(0xC866L))))).s77 && ((VECTOR(int32_t, 2))((-5L)))))).yxxxyyyyyyxyyyxx | ((VECTOR(int32_t, 16))((-8L)))))).s76))), 0x6EA4509CL, 0x381DB17CL)).x;
    }
    p_1767->g_595.sb = ((p_1767->g_1350 |= (l_1698 == (p_1767->g_1701 = l_1698))) , l_1679.s1);
    p_1767->g_1090.s0 = ((safe_lshift_func_uint16_t_u_u(get_group_id(2), p_1767->g_650.z)) & (((p_1767->g_1707 = p_1767->g_121.s3) == p_1767->g_318.s2) , (safe_mod_func_uint16_t_u_u(((*l_1710)++), (safe_mul_func_int8_t_s_s((*p_1767->g_561), ((*p_1767->g_1072) == (void*)0)))))));
    l_1715 = (-5L);
    return (*p_1767->g_561);
}

struct S0  func_19(uint32_t  p_20, int64_t  p_21, uint8_t  p_22, struct S1 * p_1767) {
    struct S0 l_1403 = {0UL,0x4BEC607CL,0xB9CB329AL,0x48L,9L,0L,0x08F8405FD6467143L,-1L};
    return l_1403;
}

__kernel void entry(__global ulong *result, __global int *sequence_input) {
    int i, j, k;
    struct S1 c_1768;
    struct S1* p_1767 = &c_1768;
    struct S1 c_1769 = {
        0x7B9AL, // p_1767->g_23
        6UL, // p_1767->g_25
        {{{0xE49BA5CDL,0x04C38DB0L,0x2D584125L,4294967290UL},{0xE49BA5CDL,0x04C38DB0L,0x2D584125L,4294967290UL},{0xE49BA5CDL,0x04C38DB0L,0x2D584125L,4294967290UL},{0xE49BA5CDL,0x04C38DB0L,0x2D584125L,4294967290UL},{0xE49BA5CDL,0x04C38DB0L,0x2D584125L,4294967290UL},{0xE49BA5CDL,0x04C38DB0L,0x2D584125L,4294967290UL}},{{0xE49BA5CDL,0x04C38DB0L,0x2D584125L,4294967290UL},{0xE49BA5CDL,0x04C38DB0L,0x2D584125L,4294967290UL},{0xE49BA5CDL,0x04C38DB0L,0x2D584125L,4294967290UL},{0xE49BA5CDL,0x04C38DB0L,0x2D584125L,4294967290UL},{0xE49BA5CDL,0x04C38DB0L,0x2D584125L,4294967290UL},{0xE49BA5CDL,0x04C38DB0L,0x2D584125L,4294967290UL}},{{0xE49BA5CDL,0x04C38DB0L,0x2D584125L,4294967290UL},{0xE49BA5CDL,0x04C38DB0L,0x2D584125L,4294967290UL},{0xE49BA5CDL,0x04C38DB0L,0x2D584125L,4294967290UL},{0xE49BA5CDL,0x04C38DB0L,0x2D584125L,4294967290UL},{0xE49BA5CDL,0x04C38DB0L,0x2D584125L,4294967290UL},{0xE49BA5CDL,0x04C38DB0L,0x2D584125L,4294967290UL}},{{0xE49BA5CDL,0x04C38DB0L,0x2D584125L,4294967290UL},{0xE49BA5CDL,0x04C38DB0L,0x2D584125L,4294967290UL},{0xE49BA5CDL,0x04C38DB0L,0x2D584125L,4294967290UL},{0xE49BA5CDL,0x04C38DB0L,0x2D584125L,4294967290UL},{0xE49BA5CDL,0x04C38DB0L,0x2D584125L,4294967290UL},{0xE49BA5CDL,0x04C38DB0L,0x2D584125L,4294967290UL}},{{0xE49BA5CDL,0x04C38DB0L,0x2D584125L,4294967290UL},{0xE49BA5CDL,0x04C38DB0L,0x2D584125L,4294967290UL},{0xE49BA5CDL,0x04C38DB0L,0x2D584125L,4294967290UL},{0xE49BA5CDL,0x04C38DB0L,0x2D584125L,4294967290UL},{0xE49BA5CDL,0x04C38DB0L,0x2D584125L,4294967290UL},{0xE49BA5CDL,0x04C38DB0L,0x2D584125L,4294967290UL}},{{0xE49BA5CDL,0x04C38DB0L,0x2D584125L,4294967290UL},{0xE49BA5CDL,0x04C38DB0L,0x2D584125L,4294967290UL},{0xE49BA5CDL,0x04C38DB0L,0x2D584125L,4294967290UL},{0xE49BA5CDL,0x04C38DB0L,0x2D584125L,4294967290UL},{0xE49BA5CDL,0x04C38DB0L,0x2D584125L,4294967290UL},{0xE49BA5CDL,0x04C38DB0L,0x2D584125L,4294967290UL}},{{0xE49BA5CDL,0x04C38DB0L,0x2D584125L,4294967290UL},{0xE49BA5CDL,0x04C38DB0L,0x2D584125L,4294967290UL},{0xE49BA5CDL,0x04C38DB0L,0x2D584125L,4294967290UL},{0xE49BA5CDL,0x04C38DB0L,0x2D584125L,4294967290UL},{0xE49BA5CDL,0x04C38DB0L,0x2D584125L,4294967290UL},{0xE49BA5CDL,0x04C38DB0L,0x2D584125L,4294967290UL}},{{0xE49BA5CDL,0x04C38DB0L,0x2D584125L,4294967290UL},{0xE49BA5CDL,0x04C38DB0L,0x2D584125L,4294967290UL},{0xE49BA5CDL,0x04C38DB0L,0x2D584125L,4294967290UL},{0xE49BA5CDL,0x04C38DB0L,0x2D584125L,4294967290UL},{0xE49BA5CDL,0x04C38DB0L,0x2D584125L,4294967290UL},{0xE49BA5CDL,0x04C38DB0L,0x2D584125L,4294967290UL}}}, // p_1767->g_51
        &p_1767->g_51[6][2][0], // p_1767->g_50
        {0x5992E414L,0x5992E414L,0x5992E414L,0x5992E414L,0x5992E414L,0x5992E414L,0x5992E414L,0x5992E414L,0x5992E414L}, // p_1767->g_55
        &p_1767->g_55[3], // p_1767->g_54
        (VECTOR(uint64_t, 2))(18446744073709551615UL, 0x98891C1AAD5EAB19L), // p_1767->g_67
        (VECTOR(uint64_t, 16))((VECTOR(uint64_t, 4))((VECTOR(uint64_t, 2))(0xBED38BC6A5050E7AL, 1UL), 0xBED38BC6A5050E7AL, 1UL), 0xBED38BC6A5050E7AL, (VECTOR(uint64_t, 2))(0xBED38BC6A5050E7AL, 1UL), 1UL, (VECTOR(uint64_t, 2))(0xBED38BC6A5050E7AL, 1UL), (VECTOR(uint64_t, 2))(0xBED38BC6A5050E7AL, 1UL), (VECTOR(uint64_t, 2))(0xBED38BC6A5050E7AL, 1UL), 0xBED38BC6A5050E7AL, 1UL), // p_1767->g_69
        (VECTOR(uint16_t, 8))((VECTOR(uint16_t, 2))(7UL, 0x47F7L), (VECTOR(uint16_t, 2))(7UL, 0x47F7L), (VECTOR(uint16_t, 2))(7UL, 0x47F7L), 7UL, 0x47F7L), // p_1767->g_84
        (VECTOR(uint16_t, 16))(65526UL, 0x06BEL, (VECTOR(uint16_t, 2))(65526UL, 0x06BEL), 65526UL, (VECTOR(uint16_t, 2))(65526UL, 0x06BEL), 0x06BEL, (VECTOR(uint16_t, 2))(65526UL, 0x06BEL), (VECTOR(uint16_t, 2))(65526UL, 0x06BEL), (VECTOR(uint16_t, 2))(65526UL, 0x06BEL), 65526UL, 0x06BEL), // p_1767->g_89
        (VECTOR(uint16_t, 2))(0x8476L, 0x124FL), // p_1767->g_90
        {{1UL,0x6886BE4BL,0x277CB2DEL,0x47L,0x59FAD1A4L,-1L,0x60ECAC02D6B031E6L,0x426F4C769F55D16FL}}, // p_1767->g_95
        1UL, // p_1767->g_103
        (-1L), // p_1767->g_106
        (VECTOR(int32_t, 2))(0L, 0x251E9EB3L), // p_1767->g_111
        (VECTOR(int32_t, 8))((VECTOR(int32_t, 2))((-1L), (-1L)), (VECTOR(int32_t, 2))((-1L), (-1L)), (VECTOR(int32_t, 2))((-1L), (-1L)), (-1L), (-1L)), // p_1767->g_112
        (VECTOR(int16_t, 8))(1L, (-1L), (VECTOR(int16_t, 2))(1L, (-1L)), 1L, (VECTOR(int16_t, 2))(1L, (-1L)), (-1L)), // p_1767->g_118
        (VECTOR(int16_t, 8))((VECTOR(int16_t, 2))(0L, 0x0279L), (VECTOR(int16_t, 2))(0L, 0x0279L), (VECTOR(int16_t, 2))(0L, 0x0279L), 0L, 0x0279L), // p_1767->g_121
        (-5L), // p_1767->g_134
        (VECTOR(int32_t, 8))((VECTOR(int32_t, 2))(0x3BA08E5EL, 0x2783F5DFL), 0x3BA08E5EL, 0x2783F5DFL, (VECTOR(int32_t, 2))(0x3BA08E5EL, 0x2783F5DFL), 0x3BA08E5EL, 0x2783F5DFL), // p_1767->g_158
        (VECTOR(int32_t, 8))(8L, (VECTOR(int32_t, 4))(8L, (-6L), 8L, (-6L)), (VECTOR(int32_t, 2))(8L, (-6L)), (-6L)), // p_1767->g_159
        0x91490432EA9840A5L, // p_1767->g_168
        (VECTOR(uint16_t, 2))(0x8959L, 9UL), // p_1767->g_174
        &p_1767->g_95[0].f2, // p_1767->g_180
        {0xFF29AA79E077B5E0L,0x1AC87C86L,0x8FC4C534L,0x02L,-1L,0x69L,0L,-1L}, // p_1767->g_185
        (VECTOR(uint8_t, 8))(0x2BL, 0x17L, (VECTOR(uint8_t, 2))(0x2BL, 0x17L), 0x2BL, (VECTOR(uint8_t, 2))(0x2BL, 0x17L), 0x17L), // p_1767->g_232
        (VECTOR(uint8_t, 4))(0xF4L, (VECTOR(uint8_t, 2))(0xF4L, 0xF9L), 0xF9L), // p_1767->g_233
        0x331BCE832EED427EL, // p_1767->g_251
        (void*)0, // p_1767->g_254
        &p_1767->g_254, // p_1767->g_253
        &p_1767->g_95[0].f4, // p_1767->g_268
        (-6L), // p_1767->g_281
        (VECTOR(int8_t, 4))((VECTOR(int8_t, 2))(0x6BL, 0x0DL), 0x6BL, 0x0DL), // p_1767->g_286
        (VECTOR(int8_t, 16))((-1L), (-1L), (-1L), (VECTOR(int8_t, 4))((VECTOR(int8_t, 2))((-1L), (-1L)), (-1L), (-1L)), (VECTOR(int8_t, 4))((VECTOR(int8_t, 2))((-1L), (-1L)), (-1L), (-1L)), (VECTOR(int8_t, 4))((-1L), (VECTOR(int8_t, 2))((-1L), (-1L)), (-1L)), (-1L)), // p_1767->g_287
        (VECTOR(int8_t, 16))((VECTOR(int8_t, 4))(0x57L, (VECTOR(int8_t, 2))(0x57L, 0x5FL), 0x5FL), 0x57L, 0x5FL, (VECTOR(int8_t, 4))(0x57L, 0x5FL, 0x57L, 0x5FL), (VECTOR(int8_t, 2))(0x57L, 0x5FL), (VECTOR(int8_t, 2))(0x57L, 0x5FL), 0x57L, 0x5FL), // p_1767->g_289
        {0xC4CEC06E7D003E0EL,0x51C36F9AL,4294967295UL,255UL,-1L,0x2EL,-1L,0x02F2C5A303774D24L}, // p_1767->g_300
        {&p_1767->g_300,&p_1767->g_300,&p_1767->g_300,&p_1767->g_300,&p_1767->g_300,&p_1767->g_300,&p_1767->g_300,&p_1767->g_300,&p_1767->g_300,&p_1767->g_300}, // p_1767->g_299
        {{(void*)0,&p_1767->g_299[4],&p_1767->g_299[5],&p_1767->g_299[5],&p_1767->g_299[5],&p_1767->g_299[5],&p_1767->g_299[5],&p_1767->g_299[4]},{(void*)0,&p_1767->g_299[4],&p_1767->g_299[5],&p_1767->g_299[5],&p_1767->g_299[5],&p_1767->g_299[5],&p_1767->g_299[5],&p_1767->g_299[4]},{(void*)0,&p_1767->g_299[4],&p_1767->g_299[5],&p_1767->g_299[5],&p_1767->g_299[5],&p_1767->g_299[5],&p_1767->g_299[5],&p_1767->g_299[4]},{(void*)0,&p_1767->g_299[4],&p_1767->g_299[5],&p_1767->g_299[5],&p_1767->g_299[5],&p_1767->g_299[5],&p_1767->g_299[5],&p_1767->g_299[4]},{(void*)0,&p_1767->g_299[4],&p_1767->g_299[5],&p_1767->g_299[5],&p_1767->g_299[5],&p_1767->g_299[5],&p_1767->g_299[5],&p_1767->g_299[4]},{(void*)0,&p_1767->g_299[4],&p_1767->g_299[5],&p_1767->g_299[5],&p_1767->g_299[5],&p_1767->g_299[5],&p_1767->g_299[5],&p_1767->g_299[4]},{(void*)0,&p_1767->g_299[4],&p_1767->g_299[5],&p_1767->g_299[5],&p_1767->g_299[5],&p_1767->g_299[5],&p_1767->g_299[5],&p_1767->g_299[4]}}, // p_1767->g_298
        &p_1767->g_298[4][0], // p_1767->g_297
        (VECTOR(int32_t, 8))(0x1CE6B03BL, (VECTOR(int32_t, 4))(0x1CE6B03BL, (VECTOR(int32_t, 2))(0x1CE6B03BL, 0x78901145L), 0x78901145L), (VECTOR(int32_t, 2))(0x1CE6B03BL, 0x78901145L), 0x78901145L), // p_1767->g_318
        (VECTOR(uint16_t, 8))(0xC7A3L, 0x08A1L, 0xC7A3L, (VECTOR(uint16_t, 4))((VECTOR(uint16_t, 2))(0xC7A3L, 0x08A1L), 0xC7A3L, 0x08A1L), 0x08A1L), // p_1767->g_376
        &p_1767->g_95[0].f0, // p_1767->g_400
        &p_1767->g_400, // p_1767->g_399
        {{{(void*)0},{(void*)0},{(void*)0},{(void*)0},{(void*)0},{(void*)0},{(void*)0},{(void*)0},{(void*)0}},{{(void*)0},{(void*)0},{(void*)0},{(void*)0},{(void*)0},{(void*)0},{(void*)0},{(void*)0},{(void*)0}},{{(void*)0},{(void*)0},{(void*)0},{(void*)0},{(void*)0},{(void*)0},{(void*)0},{(void*)0},{(void*)0}},{{(void*)0},{(void*)0},{(void*)0},{(void*)0},{(void*)0},{(void*)0},{(void*)0},{(void*)0},{(void*)0}},{{(void*)0},{(void*)0},{(void*)0},{(void*)0},{(void*)0},{(void*)0},{(void*)0},{(void*)0},{(void*)0}},{{(void*)0},{(void*)0},{(void*)0},{(void*)0},{(void*)0},{(void*)0},{(void*)0},{(void*)0},{(void*)0}},{{(void*)0},{(void*)0},{(void*)0},{(void*)0},{(void*)0},{(void*)0},{(void*)0},{(void*)0},{(void*)0}},{{(void*)0},{(void*)0},{(void*)0},{(void*)0},{(void*)0},{(void*)0},{(void*)0},{(void*)0},{(void*)0}},{{(void*)0},{(void*)0},{(void*)0},{(void*)0},{(void*)0},{(void*)0},{(void*)0},{(void*)0},{(void*)0}}}, // p_1767->g_452
        (VECTOR(uint64_t, 4))(0UL, (VECTOR(uint64_t, 2))(0UL, 0xF0CE16115A832158L), 0xF0CE16115A832158L), // p_1767->g_535
        (-5L), // p_1767->g_562
        &p_1767->g_562, // p_1767->g_561
        0UL, // p_1767->g_583
        (VECTOR(int32_t, 16))(0x16EF9696L, (VECTOR(int32_t, 4))(0x16EF9696L, 0x48BFF250L, 0x16EF9696L, 0x48BFF250L), (VECTOR(int32_t, 2))(0x16EF9696L, 0x48BFF250L), (VECTOR(int32_t, 4))((VECTOR(int32_t, 2))(0x16EF9696L, 0x48BFF250L), 0x16EF9696L, 0x48BFF250L), (VECTOR(int32_t, 4))(0x16EF9696L, (VECTOR(int32_t, 2))(0x16EF9696L, 0x48BFF250L), 0x48BFF250L), 0x48BFF250L), // p_1767->g_595
        (VECTOR(int64_t, 2))(0x08D80FA9A57BE38FL, (-7L)), // p_1767->g_604
        0x1D5CF663L, // p_1767->g_619
        (VECTOR(uint8_t, 8))((VECTOR(uint8_t, 2))(0x70L, 1UL), 0x70L, (VECTOR(uint8_t, 4))((VECTOR(uint8_t, 2))(0x70L, 1UL), 0x70L, 1UL), 1UL), // p_1767->g_642
        (VECTOR(int8_t, 2))(1L, 0x22L), // p_1767->g_644
        (VECTOR(uint8_t, 16))((VECTOR(uint8_t, 4))((VECTOR(uint8_t, 2))(0x01L, 0xCFL), 0x01L, 0xCFL), (VECTOR(uint8_t, 4))((VECTOR(uint8_t, 2))(0x01L, 0xCFL), 0x01L, 0xCFL), 0x01L, 0xCFL, 0x01L, (VECTOR(uint8_t, 4))((VECTOR(uint8_t, 2))(0x01L, 0xCFL), 0x01L, 0xCFL), 0xCFL), // p_1767->g_649
        (VECTOR(int8_t, 4))((VECTOR(int8_t, 2))(0L, 0x1EL), 0L, 0x1EL), // p_1767->g_650
        (VECTOR(int8_t, 8))((VECTOR(int8_t, 2))(0L, 0x16L), 0L, (VECTOR(int8_t, 4))(0L, 0x16L, 0L, 0x16L), 0x16L), // p_1767->g_651
        (VECTOR(int8_t, 2))(0x5EL, 0x6DL), // p_1767->g_669
        (VECTOR(int8_t, 16))(0x3FL, (VECTOR(int8_t, 4))(0x3FL, 0x6FL, 0x3FL, 0x6FL), 0x6FL, 0x3FL, 0x6FL, (VECTOR(int8_t, 2))(0x3FL, 0x6FL), (VECTOR(int8_t, 2))(0x3FL, 0x6FL), (VECTOR(int8_t, 2))(0x3FL, 0x6FL), 0x3FL, 0x6FL), // p_1767->g_670
        (VECTOR(int8_t, 4))(0x5CL, (VECTOR(int8_t, 2))(0x5CL, 0x36L), 0x36L), // p_1767->g_671
        (VECTOR(int16_t, 2))(0L, 0x70BFL), // p_1767->g_695
        (VECTOR(int16_t, 2))(0x07CBL, (-1L)), // p_1767->g_696
        {&p_1767->g_168,&p_1767->g_168,&p_1767->g_168,&p_1767->g_168,&p_1767->g_168,&p_1767->g_168,&p_1767->g_168,&p_1767->g_168,&p_1767->g_168}, // p_1767->g_705
        &p_1767->g_705[7], // p_1767->g_704
        (VECTOR(uint16_t, 8))(65532UL, (VECTOR(uint16_t, 4))((VECTOR(uint16_t, 2))(65532UL, 0xEB66L), 65532UL, 0xEB66L), 0xEB66L, 65532UL, 0xEB66L), // p_1767->g_706
        0UL, // p_1767->g_711
        (VECTOR(int8_t, 8))(1L, (-1L), (VECTOR(int8_t, 2))(1L, (-1L)), (VECTOR(int8_t, 2))(1L, (-1L)), 1L, (-1L)), // p_1767->g_758
        (VECTOR(int8_t, 8))(2L, 1L, 2L, (VECTOR(int8_t, 4))(2L, 1L, 2L, 1L), 1L), // p_1767->g_759
        (VECTOR(int8_t, 16))((VECTOR(int8_t, 4))((VECTOR(int8_t, 2))(0x1DL, 0L), 0x1DL, 0L), 0x1DL, (VECTOR(int8_t, 2))(0x1DL, 0L), 0L, (VECTOR(int8_t, 2))(0x1DL, 0L), 0x1DL, 0L, 0x1DL, 0L, 0x1DL, 0L), // p_1767->g_760
        (VECTOR(uint8_t, 4))((VECTOR(uint8_t, 2))(248UL, 0x86L), 248UL, 0x86L), // p_1767->g_769
        (VECTOR(uint64_t, 2))(0xB4BEC1533CD24371L, 8UL), // p_1767->g_799
        (VECTOR(int16_t, 8))((-1L), (VECTOR(int16_t, 4))((VECTOR(int16_t, 2))((-1L), 0x41D6L), (-1L), 0x41D6L), (VECTOR(int16_t, 2))((-1L), 0x41D6L), 0x41D6L), // p_1767->g_831
        (VECTOR(int16_t, 16))(4L, (VECTOR(int16_t, 4))((VECTOR(int16_t, 2))(4L, 0x2167L), 4L, 0x2167L), (VECTOR(int16_t, 2))(4L, 0x2167L), (VECTOR(int16_t, 4))(4L, (VECTOR(int16_t, 2))(4L, 0x2167L), 0x2167L), (VECTOR(int16_t, 4))(4L, (VECTOR(int16_t, 2))(4L, 0x2167L), 0x2167L), 0x2167L), // p_1767->g_838
        (VECTOR(int16_t, 16))((VECTOR(int16_t, 4))(0x7DAEL, 0x55D7L, 0x7DAEL, 0x55D7L), 0x7DAEL, 0x55D7L, 0x7DAEL, (VECTOR(int16_t, 4))(0x7DAEL, (VECTOR(int16_t, 2))(0x7DAEL, 0x55D7L), 0x55D7L), (VECTOR(int16_t, 4))((VECTOR(int16_t, 2))(0x7DAEL, 0x55D7L), 0x7DAEL, 0x55D7L), 0x55D7L), // p_1767->g_839
        (VECTOR(int64_t, 16))(7L, (VECTOR(int64_t, 4))(7L, (VECTOR(int64_t, 2))(7L, 0x512788118B1071EDL), 0x512788118B1071EDL), (VECTOR(int64_t, 2))(7L, 0x512788118B1071EDL), 0x512788118B1071EDL, 7L, 0x512788118B1071EDL, 7L, 0x512788118B1071EDL, (VECTOR(int64_t, 2))(7L, 0x512788118B1071EDL), 7L, 0x512788118B1071EDL), // p_1767->g_846
        (VECTOR(int64_t, 8))((VECTOR(int64_t, 2))(0x39C6817508A1AFE2L, 1L), 0x39C6817508A1AFE2L, 1L, 0x39C6817508A1AFE2L, (VECTOR(int64_t, 2))(0x39C6817508A1AFE2L, 1L), 1L), // p_1767->g_856
        (VECTOR(int32_t, 4))(0x0B0063B0L, 0x27C241F6L, 0x0B0063B0L, 0x27C241F6L), // p_1767->g_901
        (VECTOR(int32_t, 2))(7L, 0x3CCF955DL), // p_1767->g_902
        (VECTOR(int16_t, 8))(0L, (VECTOR(int16_t, 4))((VECTOR(int16_t, 2))(0L, (-1L)), 0L, (-1L)), (-1L), 0L, (-1L)), // p_1767->g_903
        &p_1767->g_168, // p_1767->g_918
        {{&p_1767->g_918,&p_1767->g_918},{&p_1767->g_918,&p_1767->g_918},{&p_1767->g_918,&p_1767->g_918}}, // p_1767->g_917
        (VECTOR(int32_t, 16))(0x2BE30E6BL, (VECTOR(int32_t, 4))(0x2BE30E6BL, (VECTOR(int32_t, 2))(0x2BE30E6BL, 0x7F4552E9L), 0x7F4552E9L), 0x7F4552E9L, (VECTOR(int32_t, 4))((VECTOR(int32_t, 2))(0x2BE30E6BL, 0x7F4552E9L), 0x2BE30E6BL, 0x7F4552E9L), 0x2BE30E6BL, 0x7F4552E9L, (VECTOR(int32_t, 2))(0x2BE30E6BL, 0x7F4552E9L), 0x2BE30E6BL, 0x7F4552E9L), // p_1767->g_925
        (-1L), // p_1767->g_1013
        (VECTOR(int32_t, 8))(0x26483C70L, (VECTOR(int32_t, 4))((VECTOR(int32_t, 2))(0x26483C70L, 0x69BC33CBL), 0x26483C70L, 0x69BC33CBL), 0x69BC33CBL, 0x26483C70L, 0x69BC33CBL), // p_1767->g_1032
        0x4B5CL, // p_1767->g_1060
        (-3L), // p_1767->g_1062
        (void*)0, // p_1767->g_1074
        {&p_1767->g_1074}, // p_1767->g_1073
        &p_1767->g_1073[0], // p_1767->g_1072
        (VECTOR(int8_t, 16))(0x4BL, (VECTOR(int8_t, 4))(0x4BL, (VECTOR(int8_t, 2))(0x4BL, 0x68L), 0x68L), (VECTOR(int8_t, 2))(0x4BL, 0x68L), (VECTOR(int8_t, 4))((VECTOR(int8_t, 2))(0x4BL, 0x68L), 0x4BL, 0x68L), 0x68L, 0x4BL, (VECTOR(int8_t, 2))(0x4BL, 0x68L), 0x68L), // p_1767->g_1075
        (void*)0, // p_1767->g_1087
        (VECTOR(int32_t, 4))(0x4840FDFAL, 0x7D0D4544L, 0x4840FDFAL, 0x7D0D4544L), // p_1767->g_1088
        (VECTOR(int32_t, 16))(0x55A7C378L, (-7L), (VECTOR(int32_t, 2))(0x55A7C378L, (-7L)), 0x55A7C378L, (-7L), 0x55A7C378L, (VECTOR(int32_t, 4))(0x55A7C378L, (VECTOR(int32_t, 2))(0x55A7C378L, (-7L)), (-7L)), (VECTOR(int32_t, 4))(0x55A7C378L, (-7L), 0x55A7C378L, (-7L)), (-7L)), // p_1767->g_1090
        (VECTOR(int32_t, 2))(0x13ECC9B6L, (-1L)), // p_1767->g_1091
        (VECTOR(int32_t, 4))((-2L), 0x61E87C87L, (-2L), 0x61E87C87L), // p_1767->g_1092
        (VECTOR(int32_t, 16))((VECTOR(int32_t, 4))((VECTOR(int32_t, 2))(0x1DF016C0L, 0x1B2D1421L), 0x1DF016C0L, 0x1B2D1421L), 0x1DF016C0L, 0x1B2D1421L, 0x1DF016C0L, (VECTOR(int32_t, 4))((VECTOR(int32_t, 2))(0x1DF016C0L, 0x1B2D1421L), 0x1DF016C0L, 0x1B2D1421L), (VECTOR(int32_t, 4))((VECTOR(int32_t, 2))(0x1DF016C0L, 0x1B2D1421L), 0x1DF016C0L, 0x1B2D1421L), 0x1B2D1421L), // p_1767->g_1097
        (VECTOR(int8_t, 8))(1L, 0x7CL, (VECTOR(int8_t, 2))(1L, 0x7CL), 1L, (VECTOR(int8_t, 2))(1L, 0x7CL), 0x7CL), // p_1767->g_1098
        0x6B33L, // p_1767->g_1118
        (VECTOR(uint64_t, 16))((VECTOR(uint64_t, 4))(1UL, 0x3E2759B8AEB3A73CL, 1UL, 0x3E2759B8AEB3A73CL), (VECTOR(uint64_t, 4))((VECTOR(uint64_t, 2))(1UL, 0x3E2759B8AEB3A73CL), 1UL, 0x3E2759B8AEB3A73CL), (VECTOR(uint64_t, 2))(1UL, 0x3E2759B8AEB3A73CL), (VECTOR(uint64_t, 2))(1UL, 0x3E2759B8AEB3A73CL), 1UL, (VECTOR(uint64_t, 2))(1UL, 0x3E2759B8AEB3A73CL), 0x3E2759B8AEB3A73CL), // p_1767->g_1172
        (VECTOR(uint32_t, 2))(4294967295UL, 3UL), // p_1767->g_1228
        (VECTOR(uint32_t, 2))(0x9811132BL, 1UL), // p_1767->g_1229
        (VECTOR(uint32_t, 8))(0xC3FAF0F4L, 0xDDDF1ED5L, (VECTOR(uint32_t, 2))(0xC3FAF0F4L, 0xDDDF1ED5L), 0xC3FAF0F4L, 0xDDDF1ED5L, 0xC3FAF0F4L, 0xDDDF1ED5L), // p_1767->g_1230
        (VECTOR(uint32_t, 4))((VECTOR(uint32_t, 2))(0x30900BD2L, 1UL), 0x30900BD2L, 1UL), // p_1767->g_1232
        (VECTOR(uint32_t, 16))(0x1BDE0F9BL, (VECTOR(uint32_t, 4))((VECTOR(uint32_t, 2))(0x1BDE0F9BL, 0xE2379244L), 0x1BDE0F9BL, 0xE2379244L), (VECTOR(uint32_t, 2))(0x1BDE0F9BL, 0xE2379244L), 0xE2379244L, 0x1BDE0F9BL, (VECTOR(uint32_t, 4))((VECTOR(uint32_t, 2))(0x1BDE0F9BL, 0xE2379244L), 0x1BDE0F9BL, 0xE2379244L), 0xE2379244L, 0x1BDE0F9BL, 0xE2379244L), // p_1767->g_1233
        (VECTOR(uint32_t, 2))(0x5FB6C4F4L, 0xC9F7B48BL), // p_1767->g_1234
        (VECTOR(uint32_t, 4))(6UL, (VECTOR(uint32_t, 2))(6UL, 5UL), 5UL), // p_1767->g_1239
        (VECTOR(uint32_t, 4))(0xDB022F79L, 0x141751F1L, 0xDB022F79L, 0x141751F1L), // p_1767->g_1241
        (VECTOR(uint32_t, 8))(1UL, (VECTOR(uint32_t, 4))(1UL, (VECTOR(uint32_t, 2))(1UL, 0x87AFB3DDL), 0x87AFB3DDL), (VECTOR(uint32_t, 2))(1UL, 0x87AFB3DDL), 0x87AFB3DDL), // p_1767->g_1244
        (VECTOR(int8_t, 16))(0L, (VECTOR(int8_t, 4))(0L, (VECTOR(int8_t, 2))(0L, 0x58L), 0x58L), 0x58L, (VECTOR(int8_t, 4))((VECTOR(int8_t, 2))(0L, 0x58L), 0L, 0x58L), (VECTOR(int8_t, 2))(0L, 0x58L), 0L, 0x58L, 0L, 0x58L), // p_1767->g_1245
        0x0A5AD859L, // p_1767->g_1249
        (VECTOR(uint64_t, 4))(0UL, (VECTOR(uint64_t, 2))(0UL, 0xD1F5ED2C2FAB34D1L), 0xD1F5ED2C2FAB34D1L), // p_1767->g_1261
        (VECTOR(uint64_t, 4))((VECTOR(uint64_t, 2))(0xD9FF3F87512662E7L, 0xB67F0B3B51A7E42BL), 0xD9FF3F87512662E7L, 0xB67F0B3B51A7E42BL), // p_1767->g_1262
        (VECTOR(uint64_t, 8))(0UL, 1UL, 0UL, (VECTOR(uint64_t, 4))(0UL, 1UL, 0UL, 1UL), 1UL), // p_1767->g_1266
        (VECTOR(uint64_t, 4))(0UL, (VECTOR(uint64_t, 2))(0UL, 0xD6FA4AEAF5BBDBC1L), 0xD6FA4AEAF5BBDBC1L), // p_1767->g_1267
        (VECTOR(int64_t, 16))((VECTOR(int64_t, 4))((VECTOR(int64_t, 2))(0x7C34B61DFEBD757BL, 0L), 0x7C34B61DFEBD757BL, 0L), 0x7C34B61DFEBD757BL, 0L, 0x7C34B61DFEBD757BL, (VECTOR(int64_t, 4))(0x7C34B61DFEBD757BL, (VECTOR(int64_t, 2))(0x7C34B61DFEBD757BL, 0L), 0L), (VECTOR(int64_t, 4))((VECTOR(int64_t, 2))(0x7C34B61DFEBD757BL, 0L), 0x7C34B61DFEBD757BL, 0L), 0L), // p_1767->g_1284
        (VECTOR(int16_t, 4))((VECTOR(int16_t, 2))((-1L), 0x2BECL), (-1L), 0x2BECL), // p_1767->g_1288
        0x1C4EL, // p_1767->g_1296
        {{{&p_1767->g_134,&p_1767->g_134,&p_1767->g_251,(void*)0,(void*)0,&p_1767->g_134,(void*)0},{&p_1767->g_134,&p_1767->g_134,&p_1767->g_251,(void*)0,(void*)0,&p_1767->g_134,(void*)0},{&p_1767->g_134,&p_1767->g_134,&p_1767->g_251,(void*)0,(void*)0,&p_1767->g_134,(void*)0}},{{&p_1767->g_134,&p_1767->g_134,&p_1767->g_251,(void*)0,(void*)0,&p_1767->g_134,(void*)0},{&p_1767->g_134,&p_1767->g_134,&p_1767->g_251,(void*)0,(void*)0,&p_1767->g_134,(void*)0},{&p_1767->g_134,&p_1767->g_134,&p_1767->g_251,(void*)0,(void*)0,&p_1767->g_134,(void*)0}},{{&p_1767->g_134,&p_1767->g_134,&p_1767->g_251,(void*)0,(void*)0,&p_1767->g_134,(void*)0},{&p_1767->g_134,&p_1767->g_134,&p_1767->g_251,(void*)0,(void*)0,&p_1767->g_134,(void*)0},{&p_1767->g_134,&p_1767->g_134,&p_1767->g_251,(void*)0,(void*)0,&p_1767->g_134,(void*)0}}}, // p_1767->g_1298
        &p_1767->g_1298[0][2][2], // p_1767->g_1297
        9UL, // p_1767->g_1350
        (VECTOR(int8_t, 8))((VECTOR(int8_t, 2))((-8L), 2L), (-8L), (VECTOR(int8_t, 4))((-8L), (VECTOR(int8_t, 2))((-8L), 2L), 2L), 2L), // p_1767->g_1396
        &p_1767->g_268, // p_1767->g_1410
        (void*)0, // p_1767->g_1415
        0xE39CF00CL, // p_1767->g_1436
        (VECTOR(int8_t, 16))((VECTOR(int8_t, 4))((VECTOR(int8_t, 2))((-1L), 0x68L), (-1L), 0x68L), (-1L), (VECTOR(int8_t, 2))((-1L), 0x68L), (VECTOR(int8_t, 4))((-1L), (VECTOR(int8_t, 2))((-1L), 0x68L), 0x68L), 0x68L, (-1L), (VECTOR(int8_t, 2))((-1L), 0x68L), 0x68L), // p_1767->g_1449
        (VECTOR(int8_t, 16))((VECTOR(int8_t, 4))((-5L), 1L, (-5L), 1L), (-5L), (VECTOR(int8_t, 2))((-5L), 1L), 1L, (-5L), 1L, (VECTOR(int8_t, 2))((-5L), 1L), (-5L), (VECTOR(int8_t, 2))((-5L), 1L), 1L), // p_1767->g_1450
        (VECTOR(int32_t, 2))((-6L), 0x66DEBE48L), // p_1767->g_1460
        &p_1767->g_54, // p_1767->g_1503
        &p_1767->g_1503, // p_1767->g_1502
        (VECTOR(int8_t, 8))((VECTOR(int8_t, 2))(0x01L, 0L), 0x01L, (VECTOR(int8_t, 4))((VECTOR(int8_t, 2))(0x01L, 0L), 0x01L, 0L), 0L), // p_1767->g_1508
        (VECTOR(int8_t, 4))((VECTOR(int8_t, 2))(3L, 5L), 3L, 5L), // p_1767->g_1540
        (VECTOR(int8_t, 8))((VECTOR(int8_t, 2))((-1L), 0x32L), (VECTOR(int8_t, 2))((-1L), 0x32L), (-1L), (VECTOR(int8_t, 2))((-1L), 0x32L), 0x32L), // p_1767->g_1541
        (VECTOR(int16_t, 2))(0x7381L, 0x6528L), // p_1767->g_1556
        (VECTOR(uint16_t, 2))(0x8B24L, 0x79F3L), // p_1767->g_1563
        (VECTOR(int8_t, 16))((VECTOR(int8_t, 4))((VECTOR(int8_t, 2))(1L, 0x51L), 1L, 0x51L), 1L, 0x51L, 1L, (VECTOR(int8_t, 4))(1L, 0x51L, 1L, 0x51L), (VECTOR(int8_t, 4))((VECTOR(int8_t, 2))(1L, 0x51L), 1L, 0x51L), 0x51L), // p_1767->g_1577
        (VECTOR(int8_t, 8))(7L, (VECTOR(int8_t, 4))((VECTOR(int8_t, 2))(7L, (-10L)), 7L, (-10L)), (-10L), 7L, (-10L)), // p_1767->g_1578
        (VECTOR(uint32_t, 16))(4294967289UL, (VECTOR(uint32_t, 4))((VECTOR(uint32_t, 2))(4294967289UL, 0xA30B9130L), 4294967289UL, 0xA30B9130L), 0xA30B9130L, 4294967289UL, (VECTOR(uint32_t, 4))((VECTOR(uint32_t, 2))(4294967289UL, 0xA30B9130L), 4294967289UL, 0xA30B9130L), 0xA30B9130L, 4294967289UL, (VECTOR(uint32_t, 2))(4294967289UL, 0xA30B9130L), 0xA30B9130L), // p_1767->g_1611
        (VECTOR(uint64_t, 8))((VECTOR(uint64_t, 2))(0x37C3AC0F7833775BL, 0x0B3897E00C1829B6L), 0x37C3AC0F7833775BL, 0x0B3897E00C1829B6L, (VECTOR(uint64_t, 2))(0x37C3AC0F7833775BL, 0x0B3897E00C1829B6L), 0x37C3AC0F7833775BL, 0x0B3897E00C1829B6L), // p_1767->g_1636
        (VECTOR(uint64_t, 8))((VECTOR(uint64_t, 2))(0UL, 0x8B70F5D9662A5332L), 0UL, (VECTOR(uint64_t, 4))((VECTOR(uint64_t, 2))(0UL, 0x8B70F5D9662A5332L), 0UL, 0x8B70F5D9662A5332L), 0x8B70F5D9662A5332L), // p_1767->g_1637
        (VECTOR(int64_t, 2))((-1L), 0x71A37F4EAFE12C2FL), // p_1767->g_1645
        (VECTOR(int64_t, 16))(0x6866A738CF3A2ABDL, (VECTOR(int64_t, 4))((VECTOR(int64_t, 2))(0x6866A738CF3A2ABDL, 0x3F0D081C3794E43DL), 0x6866A738CF3A2ABDL, 0x3F0D081C3794E43DL), (VECTOR(int64_t, 2))(0x6866A738CF3A2ABDL, 0x3F0D081C3794E43DL), (VECTOR(int64_t, 4))((VECTOR(int64_t, 2))(0x6866A738CF3A2ABDL, 0x3F0D081C3794E43DL), 0x6866A738CF3A2ABDL, 0x3F0D081C3794E43DL), 0x3F0D081C3794E43DL, (VECTOR(int64_t, 2))(0x6866A738CF3A2ABDL, 0x3F0D081C3794E43DL), 0x6866A738CF3A2ABDL, 0x3F0D081C3794E43DL), // p_1767->g_1651
        (VECTOR(int8_t, 2))(6L, 0x51L), // p_1767->g_1667
        (VECTOR(int16_t, 4))(7L, (VECTOR(int16_t, 2))(7L, (-4L)), (-4L)), // p_1767->g_1678
        (VECTOR(uint8_t, 2))(0x7FL, 0UL), // p_1767->g_1684
        (VECTOR(int64_t, 16))(0L, 2L, 0L, (VECTOR(int64_t, 4))((VECTOR(int64_t, 2))(0L, 2L), 0L, 2L), (VECTOR(int64_t, 4))(0L, 2L, 0L, 2L), (VECTOR(int64_t, 4))(0L, 2L, 0L, 2L), 2L), // p_1767->g_1687
        &p_1767->g_917[2][0], // p_1767->g_1701
        0x5EFD15D3L, // p_1767->g_1707
        (VECTOR(int64_t, 4))((VECTOR(int64_t, 2))(0x51F7B4FAC3CD315AL, (-1L)), 0x51F7B4FAC3CD315AL, (-1L)), // p_1767->g_1720
        0xDE95602AL, // p_1767->g_1743
        0xB8L, // p_1767->g_1749
        (void*)0, // p_1767->g_1764
        sequence_input[get_global_id(0)], // p_1767->global_0_offset
        sequence_input[get_global_id(1)], // p_1767->global_1_offset
        sequence_input[get_global_id(2)], // p_1767->global_2_offset
        sequence_input[get_local_id(0)], // p_1767->local_0_offset
        sequence_input[get_local_id(1)], // p_1767->local_1_offset
        sequence_input[get_local_id(2)], // p_1767->local_2_offset
        sequence_input[get_group_id(0)], // p_1767->group_0_offset
        sequence_input[get_group_id(1)], // p_1767->group_1_offset
        sequence_input[get_group_id(2)], // p_1767->group_2_offset
    };
    c_1768 = c_1769;
    barrier(CLK_LOCAL_MEM_FENCE | CLK_GLOBAL_MEM_FENCE);
    func_1(p_1767);
    barrier(CLK_LOCAL_MEM_FENCE | CLK_GLOBAL_MEM_FENCE);
    result[get_linear_global_id()] = 0;
}
