// -g 1,1,224 -l 1,1,8
#define int64_t long
#define uint64_t ulong
#define int_least64_t long
#define uint_least64_t ulong
#define int_fast64_t long
#define uint_fast64_t ulong
#define intmax_t long
#define uintmax_t ulong
#define int32_t int
#define uint32_t uint
#define int16_t short
#define uint16_t ushort
#define int8_t char
#define uint8_t uchar

#define INT64_MIN LONG_MIN
#define INT64_MAX LONG_MAX
#define INT32_MIN INT_MIN
#define INT32_MAX INT_MAX
#define INT16_MIN SHRT_MIN
#define INT16_MAX SHRT_MAX
#define INT8_MIN CHAR_MIN
#define INT8_MAX CHAR_MAX
#define UINT64_MIN ULONG_MIN
#define UINT64_MAX ULONG_MAX
#define UINT32_MIN UINT_MIN
#define UINT32_MAX UINT_MAX
#define UINT16_MIN USHRT_MIN
#define UINT16_MAX USHRT_MAX
#define UINT8_MIN UCHAR_MIN
#define UINT8_MAX UCHAR_MAX

#define transparent_crc(X, Y, Z) transparent_crc_(&crc64_context, X, Y, Z)

#define VECTOR(X , Y) VECTOR_(X, Y)
#define VECTOR_(X, Y) X##Y


// Seed: 1

#include "CLSmith.h"

/* --- Struct/Union Declarations --- */
struct S0 {
   uint32_t  f0;
};

struct S1 {
uint64_t g_17;
uint32_t g_19[9][2];
int32_t g_23;
int32_t g_25;
volatile uint8_t g_30;
struct S0 g_64;
int32_t *g_72;
int32_t ** volatile g_71;
int32_t g_85;
int16_t g_89;
int64_t g_103;
};

__kernel void entry(__global ulong *result, __global int *sequence_input) {
    int i, j, k;
    struct S1 c_1994;
    struct S1* p_1993 = &c_1994;
    struct S1 c_1995 = {
0xCD9D75405732AA61L, // p_1993->g_17
{{0x6968939FL,0x6968939FL},{0x6968939FL,0x6968939FL},{0x6968939FL,0x6968939FL},{0x6968939FL,0x6968939FL},{0x6968939FL,0x6968939FL},{0x6968939FL,0x6968939FL},{0x6968939FL,0x6968939FL},{0x6968939FL,0x6968939FL},{0x6968939FL,0x6968939FL}}, // p_1993->g_19
(-7L), // p_1993->g_23
0x25739271L, // p_1993->g_25
0UL, // p_1993->g_30
{0xAB76A10BL}, // p_1993->g_64
(void*)0, // p_1993->g_72
(void**)0, // p_1993->g_71
0x3D8A5C08L, // p_1993->g_85
0x6EA1L, // p_1993->g_89
0x720137108D8AE6FBL, // p_1993->g_103
    };
    c_1994 = c_1995;
    barrier(CLK_LOCAL_MEM_FENCE | CLK_GLOBAL_MEM_FENCE);
  //func_1(p_1993);
    uint64_t crc64_context = 0xFFFFFFFFFFFFFFFFUL;
    int print_hash_value = 0;
#ifdef HASH
transparent_crc(p_1993->g_17, "p_1993->g_17", print_hash_value);
for (i = 0; i < 9; i++) { for (j = 0; j < 2; j++) { transparent_crc(p_1993->g_19[i][j], "p_1993->g_19[i][j]", print_hash_value); } }
transparent_crc(p_1993->g_23, "p_1993->g_23", print_hash_value);
transparent_crc(p_1993->g_25, "p_1993->g_25", print_hash_value);
transparent_crc(p_1993->g_30, "p_1993->g_30", print_hash_value);
transparent_crc(p_1993->g_64.f0, "p_1993->g_64.f0", print_hash_value);
transparent_crc(p_1993->g_85, "p_1993->g_85", print_hash_value);
transparent_crc(p_1993->g_89, "p_1993->g_89", print_hash_value);
transparent_crc(p_1993->g_103, "p_1993->g_103", print_hash_value);
#endif
    result[get_linear_global_id()] = crc64_context ^ 0xFFFFFFFFFFFFFFFFUL;
}
